% ResKit: Marek Blok
% function ZapiszUI(fig_h, nazwa)
function ZapiszUI(fig_h, nazwa)

if nargin==0,
  fig_h=gcf;
  nazwa='temp.m';
elseif nargin==1,
  nazwa='temp.m';
end;

plik=fopen(nazwa,'wb');

%figure
H=fig_h(1);
fprintf(plik,'function fig_h=DrawFig\r\n');
fprintf(plik,'fig_h=figure;\r\n');
%fprintf(plik,'whitebg(''w'');\r\n');

fprintf(plik,'set(fig_h, ...\r\n');

set(H,'Units', 'normalized');
Pozycja=get(H,'Position');
fprintf(plik,'  ''Units'', ''Normalized'',...\r\n');
fprintf(plik,'  ''Position'', [%.4f %.4f %.4f %.4f],...\r\n',...
        Pozycja(1),Pozycja(2),Pozycja(3),Pozycja(4));

Pozycja=get(H,'Color');
fprintf(plik,'  ''Color'', [%.4f %.4f %.4f],...\r\n',...
        Pozycja(1),Pozycja(2),Pozycja(3));
      
Tekst=get(H,'Name');
fprintf(plik,'  ''Name'', ''%s'',...\r\n', Tekst);

Tekst=get(H,'NumberTitle');
%if strcmp(Tekst,'on')
%  Tekst='yes';
%else
%  Tekst='no';
%end;
fprintf(plik,'  ''NumberTitle'', ''%s'',...\r\n', Tekst);
      
Tekst=get(H,'Menu');
fprintf(plik,'  ''Menu'', ''%s'',...\r\n', Tekst);
      
Tekst=get(H,'Tag');
fprintf(plik,'  ''Tag'', ''%s''...\r\n', Tekst);
fprintf(plik,'  );\r\n');

%axes
H=findobj(fig_h,'type', 'axes');
if length(H)>=1
  for i=1:length(H)
    %odczytanie parametrw
    fprintf(plik,'h=axes;\r\n');
    fprintf(plik,'set(h, ...\r\n');

    set(H(i),'Units', 'normalized');
    Pozycja=get(H(i),'Position');
    fprintf(plik,'  ''Units'', ''Normalized'',...\r\n');
    fprintf(plik,'  ''Position'', [%.4f %.4f %.4f %.4f],...\r\n',...
            Pozycja(1),Pozycja(2),Pozycja(3),Pozycja(4));

    Pozycja=get(H(i),'Color');
    fprintf(plik,'  ''Color'', [%.4f %.4f %.4f],...\r\n',...
        Pozycja(1),Pozycja(2),Pozycja(3));
    Pozycja=get(H(i),'XColor');
    fprintf(plik,'  ''XColor'', [%.4f %.4f %.4f],...\r\n',...
        Pozycja(1),Pozycja(2),Pozycja(3));
    Pozycja=get(H(i),'YColor');
    fprintf(plik,'  ''YColor'', [%.4f %.4f %.4f],...\r\n',...
        Pozycja(1),Pozycja(2),Pozycja(3));
         
    Pozycja=get(H(i),'FontSize');
    fprintf(plik,'  ''FontSize'', %i,...\r\n', Pozycja);

    Pozycja=get(H(i),'Box');
    fprintf(plik,'  ''Box'', ''%s'',...\r\n', Pozycja);

    Tekst=get(H(i),'Tag');
    if iscell(Tekst), Tekst=Tekst{1}; end;
    fprintf(plik,'  ''Tag'', ''%s''...\r\n', Tekst);
    fprintf(plik,'  );\r\n');
  end
end

%uicontrols
H=findobj(fig_h,'type', 'uicontrol', 'Style','frame');
H_=findobj(fig_h,'type', 'uicontrol');
for i=1:length(H),
  ind_=find(H_==H(i)); H_(ind_)=[];
end;
H=[H(:); H_(:)];
if length(H)>=1
  for i=1:length(H)
    %odczytanie parametrw
    fprintf(plik,'h=uicontrol;\r\n');

    fprintf(plik,'x=version;\r\n', Pozycja);
    fprintf(plik,'if (x(1)>=''5''),\r\n');
    fprintf(plik,'  set(h, ...\r\n');
    Pozycja=get(H(i),'FontSize');
    fprintf(plik,'    ''FontSize'', %i);\r\n', Pozycja);
    fprintf(plik,'end;\r\n');
          
    fprintf(plik,'set(h, ...\r\n');

    Tekst=get(H(i),'Style');
    fprintf(plik,'  ''Style'', ''%s'',...\r\n', Tekst);

    set(H(i),'Units', 'normalized');
    Pozycja=get(H(i),'Position');
    fprintf(plik,'  ''Units'', ''Normalized'',...\r\n');
    fprintf(plik,'  ''Position'', [%.4f %.4f %.4f %.4f],...\r\n',...
            Pozycja(1),Pozycja(2),Pozycja(3),Pozycja(4));

    Pozycja=get(H(i),'BackGroundColor');
    fprintf(plik,'  ''BackGroundColor'', [%.4f %.4f %.4f],...\r\n',...
        Pozycja(1),Pozycja(2),Pozycja(3));
         
    Tekst=get(H(i),'String');
    if size(Tekst,1)>1,
      fprintf(plik,'  ''String'', [''%s'' ,...\r\n', Tekst{1});
      for ind_=2:length(Tekst),
        fprintf(plik,'  ''|%s'',...\r\n', Tekst{ind_});
      end;
      fprintf(plik,'  ],...\r\n', Tekst{ind_});
    else
      if iscell(Tekst), Tekst=Tekst{1}; end;
      fprintf(plik,'  ''String'', ''%s'',...\r\n', Tekst);
    end;

    Tekst=get(H(i),'Value');
    fprintf(plik,'  ''Value'', %i,...\r\n', Tekst);

    Tekst=get(H(i),'Visible');
%    if strcmp(Tekst,'yes')
%      Tekst='on';
%    else
%      Tekst='off';
%    end;
    fprintf(plik,'  ''Visible'', ''%s'',...\r\n', Tekst);

    Tekst=DoubleQuotes(get(H(i),'Callback'));
    fprintf(plik,'  ''Callback'', ''%s'',...\r\n', Tekst);

    Tekst=get(H(i),'Tag');
    if iscell(Tekst), Tekst=Tekst{1}; end;
    fprintf(plik,'  ''Tag'', ''%s''...\r\n', Tekst);
    fprintf(plik,'  );\r\n');
  end
end

fclose(plik);

function Tekst=DoubleQuotes(tekst)

Tekst='';
for ind=1:length(tekst)
  Tekst=[Tekst tekst(ind)];
  if tekst(ind)=='''',
    Tekst=[Tekst tekst(ind)];
  end;
end;
