%function ZerPol(Param)
%ZerPol -> testyed with MatLab ver. 2021b
% Param: (parametr tekstowy)
%  'Licz' - liczy charakterystyki czstotliwociowe i odpowied impulsow
%           i je wykrela
%  'Zakoncz' - koczy prac ZerPol'a
%  'Delete' - usuwanie zaznaczonych punktw osobliwych
%  'down' - nacinito klawisz myszki
%  'Ruch' - poruszono myszk
%  'up' - puszczono klawisz myszki
%  'Zera#' - zmiana typu nowo wprowadzanych punktw osobliwych
%  'Zamien' - zamiana zaznaczonych zer na bieguny i bieguny na zera
%  'ZamienReal' - zamiana znaku skadowej rzeczywistej
%  'ZamienImag' - zamiana znaku skadowej urojonej
%  'ZamienMod' - zamiana moduu zanaczonych na przeciwny
%  'ZmienWart' - zmiana wartoci ostatniego punktu osobliwego na wart. edytowan
%  'SelectAll' - Wybierz wszystkie punkty osobliwe
%  'SelectZ' - Wybierz wszystkie zera
%  'SelectP' - Wybierz wszystkie zera
%  'Key' - Nacinito klawisz
%  'NoweZero'
%  'NowyBiegun'
%  'DodajSprzone_All'
%  'DodajSprzone_Selected'
%  'DodajOdwrcone_All'
%  'DodajOdwrcone_Selected'
%  '3D_view'
%  'autoK'
%  'SoundConfig'
%
% New (2005.09.29):
%   'SelectZplaneRange' - zmieniono zakres/tryb wywietlania paszczyzny Z
function ZerPol(Param, Param1, Param2)

% PiAPS_sound:  zamiast checkbox'a dla filtrw wejciowego/wyjciowego zrobi popupmenu
% z list dostpnych filtrw (odwiean przy redraw) 
%  INFO - opis z pliku (ew. nazwa gdy nie ma opisu), natywna szybkoc prbkowania

% 2021.04.09 Fixed problem with figures partially hidden behind Windows menu bar
%
% 2005.12.22 Problem z rozwijaniem fazy dla filtrw rzeczywistych
%  1) zero z1=0.9 - dobrze
%  2) zero z1=1.1 - faza dla w=0 rwna +/-pi i niebardzo wiadomo jak j
%    rozwin, tak aby cechowaa j symetria nieparzysta, a nie byo skoku
%    fazy w zerze

% \TODO 2005.12.24 Add hints to all uicontrols
%
% \TODO 2005.12.24 Improve support for filtered waveform defintions
%   + info for users
%
% \TODO 2005.12.22 hourglass w trakcie rysowania wykresw 3D
%
% \TODO 2005.12.17 When "keep conj" is selected, select zero/pole allways
%    with zero/pole conjugate to it
% \TODO 2005.12.21 w trybie 'keep conj.' zawsze zaznacza punkty parami sprzonymi
%   problemy:
%    - punkty rzeczywiste
%    - edycja poprzez pola edit musi odnosi si do par sprzonych
%    - problem przy edycji punktw rzeczywistych, 
%      przy zmianie fazy na rn od zera to musi by rozdzielony na dwa
%    - problem przy edycji punktw sprzonych, 
%      przy zmianie fazy na rwn zeru to pytanie czy powinny pozosta dwa
%    - problem co robi przy przeczaniu trybw
%
% \TODO 2005.12.20 Przy wywietlanu charakterystyk, przed wyznaczaniem pulsacji sprawdza, 
%   wszystkie punkty osobliwe maj skoczone wartoci
% \TODO 2005.12.16 when adding pole/zero to selection (SHIFT + left click)
%  1) all nearby zeros/poles (not only nearest)
%  2) display number of selected poles and zeros
% \TODO 2005_12_17 aktualizacja charakterystyk czstotliwociowych w trakcie
%    przesuwania punktw osobliwych
% \TODO 2005_12_17 w polu edycyjnym przecinek zamienia na kropk


% 2015_09_28 New version: 2.2b
%  \Fixed 2015.09.28 uniform capitalization for ZerPol
%  \Fixed 2015.09.28 replaced finite with isfinite
%  \Fixed 2015.09.28 replaced use of Symbol font with TeX
%  \Fixed 2015.09.28 correcting figures position and size based on actual
%                    screensize instead of the one reported by MATLAB
%  \Fixed 2015.09.28 removed EraseMode
%  \Fixed 2015.09.28 corrected figure selection for 3D-view and sound

% 2009_02_04 New version: 2.2
% \Fixed 2009.02.04 fixed problem when clickng button resulted in ignoring change in edit control 
% \Fixed 2009.02.04 Improved figures positioning for panoramic monitors
% \Fixed 2009.02.04 Option to select only points with |z| < 1 or |z| > 1
% \Fixed 2009.02.04 Added option for net phase response
% \Fixed 2009.02.04 Change in frequency response draw mode indicated by change of axis background
% \Fixed 2009.02.04 Window method set the proper value of the K parameter
% \Fixed 2009.02.04 Renamed 'Load' button to 'Design/Load'
% \Fixed 2009.02.04 Design is now default action instead of Load
% \Fixed 2009.02.04 Window method is now the default one
% \Fixed 2009.02.04 Save button now works
% \Fixed 2009.02.03 wavplay(..., 'sync') used to prevent too fast sound
%   playback repetition
% \Fixed 2009.02.03 switching off auto scaling now sets gain K = 1
% \Fixed 2009.02.03 added function roots_ - removes zeros at the beginning
%    and the ned of the impulse response, and returns additional poles in
%    zero if necessary
%
% 2007_11_07 New version: 2.1c
% \Fixed 2007.11.07 poprawiono problem z wywietlaniem skadowej urojonej
%     zawsze ze znakiem minus

% 2006_10_23 New version: 2.1b
% \ADDED 2006.10.23 Loading FIR filters from MAT files with impulse response vector
%     NOTE zero/pole representation of the filter will be correct
%          only for short impulse responses 
% \FIXED 2006.10.23 Increased sensitivity of GetOb function (better
%     detection of multiple characteristic points) 
%

% 2005_12_20 New version: 2.1
% \Fixed 2005.12.27 On Exit: sound config figure is also closed if it was
%   left open
% \added 2005.12.27 auto scale option in sound_config
% \added 2005.12.27 stereo option in sound_config
% \Fixed 2005.12.24 Improved support for filtered waveform definitions
%   + delta
%   + multiline
% \added 2005.12.24 filtered sound playback; filtered waveform is userdefined
% \added 2005.12.23 filter transmittance factor K (manual & auto)
%   in auto mode: K = 1/max(|H(w)|)
% \Fixed 2005.12.23 Fixed problem with LoadTool function call in callback 
% \added 2005.12.22 automatic filter scaling factor selection 
%   (so the max gain will be equal 1)
% \Fixed 2005.12.22 Impulse response scalling problem, when |h[n]| < 1
% \Fixed 2005.12.22 El & Az are preserved when redraw is pressed in '3D view'
% \added 2005.12.21 added |H(z)| range [dB] in 3D view
% \added 2005.12.21 added |H(z)| offset [dB] in 3D view
% \added 2005.12.20 |H(z)| 3D view [dB]
%
% 2005_12_17 New version: 2.0b
% \Fixed 2005.12.19 In group move mode zeros/poles placed in z-plane origin
%  (0+j0) cannot be moved (so if you try, nothing happens)
% \Fixed 2005.12.19 In group move mode zeros/poles placed in z-plane origin (0+j0) do not change their position 
% \added 2005.12.19 New buttons +1/conj(z) & +1/conj(z_sel) addig points
%   with conjugate reciprocal of all/selected points
%  input parameters: 'DodajOdwrcone_All', 'DodajOdwrcone_Selected'
% \Fixed 2005.12.19 When '1/conj(z)' button is hit, zeros/poles in 0+j0 are
%   omitted (result would be INF)
% \Fixed 2005.12.19 Changed button description '1/abs(z)' to more appropriate '1/conj(z)'
% \Fixed 2005.12.17 When "keep conj" is selected real zeros/poles should stay real
% \added 2005.12.17 Information about number of zeros and poles 
%  1) number of zeros/polse near mouse cursor
%  2) size of text depends on number of zeros/poles in the same place
%  3) GetOb can return all zeros/poles which are in the same place as the nearest one
% \added 2005.12.17 Checkbox "keep conjugate" (move with preserving conjugation of zeros/poles)  
% \Fixed 2005_12_17 when SHIFT is pressed only points selection should be performed, not moving
% \added 2005.12.17 moving group of zeros/poles with correction in radial coordinates
%   instead of cartesian one
% \added 2005.12.16 adding/removing pole/zero to/from selection (SHIFT + left mouse button / middle mouse button)
% \Fixed 2005.12.16 Change checkbox 'lin/dB' to 'linear'
% \added 2005_12_16 Pushbutton adding conjugated points:
%   'DodajSprzone_All' - adds zeros/poles conjugates to all already enterd
% \added 2005_12_16 Pushbutton adding conjugated points:
%   'DodajSprzone_Selected' - adds zeros/poles conjugates to selected zeros/poles
% \fixed 2005_12_16 could not load when number of zeros and poles was different 
% \fixed 2005_12_16 phase is now unwrapped from zero frequency towards -pi
%   and +pi. This guarantees symetry for real filters
% \fixed 2005_12_16 integrated into one m-file
%
% 2005_11_20 New version: 2.0a
% \fixed 2005_11_20 All m-files placed in one file
% \fixed 2005_11_20 Got rid of warning: Divide by zero
%
% 2005_09_30 New version: 2.0
% \fixed 2005_09_30 (ZerPol.m) Problems in compressed mode when using functions
%   "-real(z)", "-imag(z)", "1/abs(z)"
% \fixed 2005_09_30 (ZerPol.m) Group delay outside [-100 Sa, +100 Sa] is set to NaN
%   Characteristics details are exposed that way
% \fixed 2005_09_30 (ZerPol.m) Magnitude response lower than -100 dB is set to NaN
%   Characteristics details are exposed that way
% \fixed 2005_09_30 (LoadTool.m) in design mode frequencies now are interpreted
%   as angular frequencies from range [0, pi], and not in MATLAB like
%   style [0, 1]
% \fixed 2005_09_30 (ZerPol.m) suppresed "Warning: Log of zero."
% \fixed 2005_09_30 (ZerPol.m) when new characteristic point is entered
%   using mouse it is automaticly selected (like in case of entering new 
%   point using buttons "New Zero", "New Pole"
% \fixed 2005_09_30 (ZerPol.m) increased 10 times number of frequency points 
%   computer efficiency is no more an issue (since 1997 much have changed)
% \fixed 2005_09_30 (ZerPol.m) isues with zoom and switching Z-plane ranges
% \fixed 2005_09_29 (ZerPol.m) When pole or zero had been moved out of box_range, the 
%   characteristic point was moved back but position values in edit boxes
%   was not set back
% \fixed 2005_09_29 (ZerPol.m, InBox.m, GetOb.m, ConvertPos.m)  Added
%   compressed Z-plane mode: distance to unit cirle is the same for zeros &
%   poles with |r| and 1/|r|
% \fixed 2005_09_29 (ZerPol.m, Tools.m) Added "Z-plane range" option
% 2005_09_29 New version: 1.3
% \fixed 2009_09_29 updated a bit figures positions
% \fixed 2005_09_29 (ZerPol.m) Question about closing ZerPol if Exit is pressed 
% \fixed 2005_09_29 (ZerPol.m) When one of the windows is close, the application 
%   is forced to close (thus problems with missing windows do not aprear)
% \fixed 2005_09_29 (GrSlow.m) Suppressed some warning messages
% \fixed 2005_09_29 (ZerPol.m, Tools.m, GrSlow.m) corrected frequency response names
% \fixed 2005_09_29 (GrSlow.m) when frequency is theoreticaly constant   
%   and in computations we get numeric errors, we draw now stright line   
%   at mean value of this frequency response 
% \fixed 2009_09_29 (ZerPol.m, SaveZP.m) save won't crash if no new pole and zero has been added yet
% \fixed 2005_09_29 (SaveZP.m) save files are now saved in multiline format
% \fixed 2005_09_29 (LoadTool.m) added support for multiline save files
% \fixed 2005_09_29 (LoadTool.m, SaveZP.m) improved file type filtering in MATLAB 6 (and above ?)
DebugKeys = 0; % \added 2005_09_29 if == 1 unassigned keyboard keys codes are displayed

global ZerPolFigure ZerPolTools ZerPolLoad ZerPolhAxes ZerPolhBox ZerPolObiekt ZerPol_xlabel ZerPol_Hz_3D_fig;
global ZerPolhLoad;
global ZerPolSygnaly ZerPol_lin_dB ZerPol_netto ZerPolResponseAxes;
global ZerPolRadio ZerPolTrybEdycji ZerPolStart ZerPolStart_Obiekt_ind ZerPol_ZplaneRange;
global ZerPolZera ZerPolBieguny ZerPolWybrane;
global ZerPolSkalaX ZerPolSkalaY ZerPolZoom ZerPolXLim ZerPolYLim;
global ZerPolXTick ZerPolYTick MatLabVer; %Mag
global ZerPolVer ZerPol_Sel;
global ZerPol_Zplane_compressed ZerPol_h_inf_ring;
global ZerPol_K ZerPol_autoK;
global ZerPol_Show_SoundConfig_fig ZerPol_SoundConfig;

if (nargin==0)
 if ~isempty(ZerPolFigure)
    ButtonName = questdlg(['ZerPol is about to be closed. Are you sure you want to do this?'], ...
        'Closing ZerPol', 'Yes', 'Abort closing', 'Yes');
    switch (ButtonName),
      case 'Yes',
        ZerPol('Zakoncz');
      case 'Abort closing',
        return;
    end
    return;
 end
 %Mag
 x=version;
 MatLabVer=eval(x(1));
 clear x;
 %Mag end
 if MatLabVer==4
   ZerPol_Sel='extend';
   ZerPol_AddSel='alt';
 else
   ZerPol_Sel='alt';
   ZerPol_AddSel='extend';
 end;
 ZerPolVer='ZerPol for MATLAB v.2.2.1 (Marek Blok)';
 ZerPol_Zplane_compressed = 0;

 ZerPol_Hz_3D_fig = [];
 ZerPolFigure=figure('Visible', 'on', 'WindowState', 'maximized', 'Units', 'pixels');
%  whitebg('w');
 set(ZerPolFigure,'MenuBar', 'None');
%  Ekran=get(0, 'ScreenSize'); 
 drawnow
 Ekran=get(ZerPolFigure, 'OuterPosition'); 
 set(ZerPolFigure, 'Visible', 'off');
 screen_size = Ekran(3:4); %-Ekran(1:2);
 screen_offset = Ekran(1:2);

%  if (MatLabVer>=6),
%    ge = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment;
%    gd = ge.getDefaultScreenDevice;
%    screen_size = [gd.getDisplayMode.getWidth gd.getDisplayMode.getHeight];
%  end

%  Pozycja=get(ZerPolFigure, 'Position');
% -2     2   804   562
%  PozycjaFigure = [4 9+Ekran(4)-2*Ekran(4)/3 2*Ekran(4)/3-20 2*Ekran(4)/3-32];
screen_panoramic_ratio = Ekran(3)/Ekran(4) *3/4;

%  PozycjaFigure = [0.001 0.97-2/3 (1.5/3)/screen_panoramic_ratio, 2/3];
 PozycjaFigure = [screen_offset(1) screen_offset(2)+Ekran(4)-floor(screen_size(2)*2/3) floor(Ekran(3)/3), floor(screen_size(2)*2/3)];
 %Mag
 if (MatLabVer>=5)
  set(ZerPolFigure,...
   'Units', 'Pixels',...
   'DoubleBuffer', 'on', ...
   'Color', 'w',...
   'OuterPosition', PozycjaFigure,...
   'ReSize', 'off',...
   'NumberTitle', 'off',...
   'Name', ZerPolVer,...
   'Pointer', 'crosshair',...
   'windowbuttondownfcn','ZerPol(''down'')', ...
   'windowbuttonupfcn','', ...
   'windowbuttonmotionfcn','ZerPol(''Ruch_info'')',...
   'buttondownfcn','', ...
   'KeyPressFcn', 'ZerPol(''Key'');',...
   'interruptible','on',...
   'DeleteFcn', 'ZerPol(''Zakoncz'');', ...
   'UserData', ZerPolVer);
  else
   set(ZerPolFigure,...
   'Units', 'pixel',...
   'Position', PozycjaFigure,...
   'ReSize', 'off',...
   'NumberTitle', 'off',...
   'Name', ZerPolVer,...
   'Pointer', 'crosshair',...
   'windowbuttondownfcn','ZerPol(''down'')', ...
   'windowbuttonupfcn','', ...
   'windowbuttonmotionfcn','ZerPol(''Ruch_info'')',...
   'buttondownfcn','', ...
   'KeyPressFcn', 'ZerPol(''Key'');',...
   'interruptible','yes',...
   'UserData', ZerPolVer);
 end
%  %A teraz korekta pooenia
%  Pozycja=get(ZerPolFigure, 'OuterPosition');
% % Korekta=PozycjaFigure(2)-Pozycja(2);
% % PozycjaFigure(3:4) = PozycjaFigure(3:4)-Korekta;

 %ZerPolFigure_poz = Pozycja;
 ZerPolFigure_poz = PozycjaFigure;
%  ZerPolTools_poz = [4 -2 ZerPolFigure_poz(3) ZerPolFigure_poz(2)-14-10];
% ZerPolTools_poz = [0.001 0 ZerPolFigure_poz(3) 0.94-ZerPolFigure_poz(4)];
 ZerPolTools_poz = [screen_offset(1) screen_offset(2)+Ekran(4)-screen_size(2) ZerPolFigure_poz(3) floor(screen_size(2)*1/3)];
%  ZerPolSygnaly_poz=[12+PozycjaFigure(3) 2 Ekran(3)-PozycjaFigure(3)-16 Ekran(4)-25];
% ZerPolSygnaly_poz=[0.004+PozycjaFigure(3) 0 1-PozycjaFigure(3)-0.004 0.97];
% % ZerPolSygnaly_poz=[PozycjaFigure(3) 0 Ekran(3)-PozycjaFigure(3) Ekran(4)];
 ZerPolSygnaly_poz=[screen_offset(1)+PozycjaFigure(3) screen_offset(2)+Ekran(4)-screen_size(2) screen_size(1)-PozycjaFigure(3) screen_size(2)];

%   PozycjaFigure = [0 Ekran(4)-floor(screen_size(2)*2/3) floor(Ekran(3)/3), floor(screen_size(2)*2/3)];

 set(ZerPolFigure,'OuterPosition', ZerPolFigure_poz);

 ZerPolhAxes = axes;
 plot(cos((1:101)*2*pi/100), sin((1:101)*2*pi/100));
 hold on
 ZerPol_h_inf_ring=plot(2*cos((1:101)*2*pi/100), 2*sin((1:101)*2*pi/100), 'r');
 set(ZerPol_h_inf_ring, 'Visible', 'off');
 hold off
 axis('square');
 grid on;
 ZerPol_xlabel = xlabel(' ');
 set(ZerPolhAxes,'Units', 'normalized',...
                 'FontSize', 8,...
                 'Position', [0.075 0.075 0.9 0.9],...
                 'XLim', [-2 2],...
                 'XTick', [-10 -5 -2 -1 0 1 2 5 10],... % \fixed 2005_09_29
                 'YLim', [-2 2],...
                 'YTick', [-10 -5 -2 -1 0 1 2 5 10]); % \fixed 2005_09_29
 ZerPolSkalaX=4;
 ZerPolSkalaY=4;

 ZerPolTools=figure('Visible', 'off');
 set(ZerPolTools, 'NumberTitle', 'off', 'Name', 'Tools',...
        'MenuBar', 'none',...
        'ReSize', 'off',...
        'Units', 'pixels',...
        'OuterPosition', ZerPolTools_poz,...
        'KeyPressFcn', 'ZerPol(''Key'');',...
      	'UserData', ZerPolVer);
 if (MatLabVer>=5)
   set(ZerPolTools, 'DeleteFcn', 'ZerPol(''Zakoncz'');');
   set(ZerPolTools, 'OuterPosition', ZerPolTools_poz);
 end

%        'Position', [4 -2 PozycjaFigure(3) PozycjaFigure(2)-Korekta-3-10],...

 ZerPol_K = 1;
 ZerPol_autoK = 0;

 %Uicontrols dla Tools
 Tools;

 ZerPolLoad=figure('Visible', 'off');
 set(ZerPolLoad, 'NumberTitle', 'off', 'Name', 'Load/Design',...
        'MenuBar', 'none',...
        'ReSize', 'off',...
        'Units', 'pixels',...
        'OuterPosition', ZerPolTools_poz,...
        'KeyPressFcn', 'ZerPol(''Key'');',...
      	'UserData', ZerPolVer);
%        'Position', [4 -2 PozycjaFigure(3) PozycjaFigure(2)-Korekta-3-10],...
 if (MatLabVer>=5)
   set(ZerPolLoad, 'DeleteFcn', 'ZerPol(''Zakoncz'');');
 end
      
 %Uicontrols dla Tools
 LoadTool;
% set(ZerPolLoad, 'Visible', 'off');

 %Otwieranie okna do wywietlania charakterystyk i odpowiedzi impulsowej
 ZerPolSygnaly=figure;
 if MatLabVer~=4
   set(ZerPolSygnaly, 'DoubleBuffer', 'on');
 end;

 set(ZerPolSygnaly, 'NumberTitle', 'off', 'Name', 'Impulse response & frequency characteristics',...
        'MenuBar', 'none',...
        'ReSize', 'off',...
        'Color', [1 1 1],...
        'Units', 'pixels',...
        'OuterPosition', ZerPolSygnaly_poz,...
        'KeyPressFcn', 'ZerPol(''Key'');',...
        'UserData', ZerPolVer);
%        'Position', [12+PozycjaFigure(3) 2 Ekran(3)-PozycjaFigure(3)-16 Ekran(4)-Korekta-25],...
 if (MatLabVer>=5)
   set(ZerPolSygnaly, 'DeleteFcn', 'ZerPol(''Zakoncz'');', ...
        'DoubleBuffer', 'on');
 end

 % GrFast('Inicjuj');
 GrSlow('Inicjuj');

 ZerPolObiekt='o';
 % \fixed 2009_09_29
 if MatLabVer >= 5
   ZerPolZera   = zeros(0,2);
   ZerPolBieguny = zeros(0,2);
 else
   % I'm not sure whether the above construction would work with ver.4
   ZerPolZera=[];
   ZerPolBieguny=[];
 end
 % /fixed 2009_09_29
 ZerPolWybrane=[];
 set(ZerPolRadio(11:12), 'Enable', 'off');
 ZerPolhBox=-1;
 set([ZerPolTools ZerPolSygnaly], 'Visible', 'on');
 figure(ZerPolFigure);
 ZerPol('Licz');
 
 % SoundConfig
 ZerPol_SoundConfig.Fs=8000;
 ZerPol_SoundConfig.T=2;
 ZerPol_SoundConfig.dF=0;
 ZerPol_SoundConfig.play_real_part = 1;
 ZerPol_SoundConfig.play_imag_part = 0;
 ZerPol_SoundConfig.play_stereo = 0;
 ZerPol_SoundConfig.auto_scale = 0;
 
 ZerPol_SoundConfig.signal_string = 'delta(n)';
 ZerPol_SoundConfig.signal_info_string = [ ...
     'Signal: text in form of any MATLAB string defining real or complex vector.', 10, 10, ...
     'Example:', 10, ...
     '   delta(n)+', 10, ...
     '   j*rand(1,N)/20+', 10, ...
     '   sin(2*pi*1000/Fs*n)'];
else

  % force edit controls update
  h_tmp = gcbo;
  if strcmp(lower(get(h_tmp, 'Type')), 'uicontrol') == 1,
    if strcmp(lower(get(h_tmp, 'Style')), 'pushbutton') == 1,
      handles=findobj([ZerPolTools, ZerPolLoad],'style', 'edit', 'Visible', 'on');
      set(handles,'Visible', 'off');
      set(handles,'Visible', 'on');
      % disp('Edit update done')
    end
  end
  
  %Zakoczenie pracy ZerPol'a
  if strcmp(Param, 'Zakoncz')
    x=get(0, 'Children');
    if length(x)>=1
      for i=1:length(x),
				%Mag
				if (MatLabVer>=5)
          if strcmp(class(get(x(i), 'UserData')), 'char')
            if strcmp(get(x(i), 'UserData'), ZerPolVer)
              set(x(i), 'DeleteFcn', '');
              delete(x(i));
            end
          end
				else
				  if strcmp(get(x(i), 'UserData'), ZerPolVer)
            delete(x(i));
          end
        end
				%Mag end
      end
    end
    clear global ZerPolFigure ZerPolTools ZerPolLoad ZerPolhAxes ZerPolhBox ZerPolObiekt ZerPol_xlabel ZerPol_Hz_3D_fig;
    clear global ZerPolhLoad;
    clear global ZerPolSygnaly ZerPolhSygn ZerPol_lin_dB ZerPol_netto ZerPolResponseAxes;
    clear global ZerPolRadio ZerPolTrybEdycji ZerPolStart ZerPolStart_Obiekt_ind ZerPol_ZplaneRange;
    clear global ZerPolWybrane ZerPolZera ZerPolBieguny;
    clear global ZerPolSkalaX ZerPolSkalaY ZerPolZoom ZerPolXLim ZerPolYLim;
    clear global ZerPolXTick ZerPolYTick MatLabVer; % Mag
    clear global ZerPolVer ZerPol_Sel;
    clear global ZerPol_K ZerPol_autoK;
    clear global ZerPol_Show_SoundConfig_fig ZerPol_SoundConfig;
  %    GrFast('Koniec');
    GrSlow('Koniec');
    return;
    
  elseif strcmp(Param, 'lin_dB')
    if get(ZerPol_lin_dB(1),'Value')==0
      set(ZerPol_lin_dB(2), 'String', 'Magnitude response [dB]');
      set(ZerPolResponseAxes(1), 'Color', 'w');
    else
      set(ZerPol_lin_dB(2), 'String', 'Magnitude response [lin]');
      set(ZerPolResponseAxes(1), 'Color', [1, 1, 0.9]);
    end;
    ZerPol('Licz');
    return;
    
  elseif strcmp(Param, 'netto')
    if get(ZerPol_netto(1),'Value')==0
      set(ZerPol_netto(2), 'String', 'Phase response [rad]');
      set(ZerPol_netto(3), 'String', 'Group delay response [Sa]');
      set(ZerPolResponseAxes(2), 'Color', 'w');
      set(ZerPolResponseAxes(3), 'Color', 'w');
    else
      set(ZerPol_netto(2), 'String', 'Net phase response [rad]');
      set(ZerPol_netto(3), 'String', 'Net group delay response [Sa]');
      set(ZerPolResponseAxes(2), 'Color', [1, 1, 0.9]);
      set(ZerPolResponseAxes(3), 'Color', [1, 1, 0.9]);
    end;
    ZerPol('Licz');
    return;
    
  elseif strcmp(Param, 'Licz')
    %Policz transmitancj, charakterystyki czstotliwociowe,
    %odpowiedzied impulsow
    if size(ZerPolZera,1)
      HL = poly(ZerPolZera(:,2)); %Licznik transmitancji
    else
      HL=1;
    end
    if size(ZerPolBieguny,1)
      HM = poly(ZerPolBieguny(:,2)); %Mianownik transmitancji
    else
      HM=1;
    end
  	% Wyznaczamy punkty do oblicznia charakterystyk
    if (length(HM)~=1) | (length(HL)~=1)
      Puls=[0]; %\Fixed 2005.12.16
      if size(ZerPolZera,1)>0
        Puls=[Puls; angle(ZerPolZera(:,2))]; %\Fixed 2005.12.16
      end
      if size(ZerPolBieguny,1)>0
        Puls=[Puls; angle(ZerPolBieguny(:,2))];
      end
      Puls=sort(Puls);
      if Puls(1)>-pi
        Puls=[-pi; Puls];
      end
      if Puls(length(Puls))<pi
        Puls=[Puls; pi];
      end
    else
      Puls=[-pi, 0, pi]; %\Fixed 2005.12.16
    end

    %usuwamy ewentualne powtrzenia
    PomPuls(1)=Puls(1);
    k=1;
    for i=2:length(Puls),
      if abs(PomPuls(k)-Puls(i))>0.005
        k=k+1;
        PomPuls(k)=Puls(i);
      % \Fixed 2005.12.23 puls == 0, -pi, +pi sometimes where removed from the list
      else
        if (Puls(i) == 0) | (abs(Puls(i)) == pi),
          PomPuls(k)=Puls(i);
        end  
      % /Fixed 2005.12.23 
      end
    end
    Puls=PomPuls;
    clear PomPuls;

  	%Teraz zagcimy pulsacj
  	Np=length(Puls);
  	dPuls=Puls(2:Np)-Puls(1:(Np-1));
  	Pom=1; Pulsacja=Puls(1);
  	for i=1:(Np-1)
  		if dPuls(i)
  			if dPuls(i)<=0.006, % 0.06 % \fixed 2005_09_30
  				Pulsacja=[Pulsacja (Pulsacja(Pom)+Puls(i+1))/2 Puls(i+1)];
  			elseif dPuls(i)<=0.04, %0.4 % \fixed 2005_09_30
%   				Pulsacja=[Pulsacja Pulsacja(Pom)+0.02 (Pulsacja(Pom)+Puls(i+1))/2 ...
%   					Puls(i+1)-0.02 Puls(i+1)];
  				Pulsacja=[Pulsacja Pulsacja(Pom)+0.002 (Pulsacja(Pom)+Puls(i+1))/2 ...
  					Puls(i+1)-0.002 Puls(i+1)]; % \fixed 2005_09_30
  			else
%   				Ile = fix(dPuls(i)/0.2)*3;
  				Ile = fix(dPuls(i)/0.02)*3; % \fixed 2005_09_30
  				Skok=dPuls(i)/Ile/3;
%   				Pulsacja=[Pulsacja Pulsacja(Pom)+0.02 ...
%   					linspace(Pulsacja(Pom)+Skok,Puls(i+1)-Skok, Ile) ...
%   					Puls(i+1)-0.02 Puls(i+1)]; % \fixed 2005_09_30
  				Pulsacja=[Pulsacja Pulsacja(Pom)+0.002 ...
  					linspace(Pulsacja(Pom)+Skok,Puls(i+1)-Skok, Ile) ...
  					Puls(i+1)-0.002 Puls(i+1)];
  			end
  			Pom=length(Pulsacja);
  		end
  	end

    
  	%teraz chrakterystyka czstotliwociowa
    %\fixed 2005_11_20
    denominator_ = polyval(HM,exp(j*Pulsacja));
    ind_den = find(abs(denominator_) < eps);
    if length(ind_den) > 0,
      denominator_(ind_den) = NaN*ones(size(ind_den));
    end
    %/fixed 2005_11_20
    Hw=polyval(HL,exp(j*Pulsacja))./denominator_;  
	%Mag      Hw=LiczHw(HL, HM, Pulsacja);
    if ZerPol_autoK == 1,
      ind_K_=isfinite(Hw);
      if length(ind_K_) > 0,
        ZerPol_K = 1/max(abs(Hw(ind_K_)));
      else
        ZerPol_K = 1;
      end
      set(ZerPolRadio(14), 'String', ZerPol_K);
    else
      ZerPol_K = eval(get(ZerPolRadio(14),'String'), '1.0');
    end
    Hw=ZerPol_K*Hw;

    %Liczymy faz rozwinit
    if get(ZerPol_netto(1),'Value') == 1,
      N_L = (length(HL)-1)/2 - (length(HM)-1);
      Hw_ = Hw .* exp(j*(-N_L*Pulsacja)); % charakterystyka netto
    else
      Hw_ = Hw;
    end
    Faza=angle(Hw_);
    tmp_=find(~isfinite(Faza));
    if length(tmp_)>0
      Faza(tmp_)=zeros(size(tmp_));
    end;
    % \Fixed 2005.12.16
%     Faza=unwrap(Faza);
    ind_zero_puls = find(Pulsacja == 0);
    if (abs(Hw_(ind_zero_puls)) < abs(max(Hw_))/1000),
      Faza(ind_zero_puls) = 0;
    end
%     if abs(imag(Hw(ind_zero_puls))) < 100*eps,
%       if abs(Hw(ind_zero_puls)) < 100*eps,
%         Faza=Faza-Faza(ind_zero_puls);
%         
%         Faza_right=unwrap(Faza(ind_zero_puls:end));
%         Faza_left=unwrap(Faza(ind_zero_puls:-1:1));
%       else
%         Faza_right=unwrap(Faza(ind_zero_puls:end));
%         
%         Faza(1:ind_zero_puls) = Faza(1:ind_zero_puls)-sign(Faza(ind_zero_puls))*2*pi;
%         Faza_left=unwrap(Faza(ind_zero_puls:-1:1));
%       end
%     end
    if (mean(abs(imag(HM))) + mean(abs(imag(HL)))) < 100*eps,
      Faza_right=unwrap(Faza(ind_zero_puls:end));
%       Faza_left=unwrap(Faza(ind_zero_puls:-1:1));
      Faza_left=-Faza_right(end:-1:2);
    else
      Faza_right=unwrap(Faza(ind_zero_puls:end));
      Faza_left=unwrap(Faza(ind_zero_puls:-1:1));
      Faza_left=Faza_left(end:-1:2);
    end
    
    Faza = [Faza_left, Faza_right];


    % /Fixed 2005.12.16

  	%Obliczamy opnienie grupowe
  	Np=length(Pulsacja);
  	PulsOpoz=(Pulsacja(1:(Np-1))+Pulsacja(2:Np))/2;
  	dPulsacja=Pulsacja(2:Np)-Pulsacja(1:(Np-1));
    
  	Opoznienie=(Faza(1:(Np-1))-Faza(2:Np))./dPulsacja;

%  	indpom=find(dPulsacja~=0);
%  	PulsOpoz=PulsOpoz(indpom);
%  	Opoznienie=Opoznienie(indpom);

%  	ind=find(dPulsacja~=0);
%  	Nind=length(ind);
%  	PulsOpoz=PulsOpoz(ind);
%  	Opoznienie=(Faza(ind)-Faza(ind+1))./dPulsacja(ind);

  % GrFast('Rysuj', [Pulsacja; 20*log10(abs(Hw))], 1);
  % GrFast('Rysuj', [Pulsacja; Faza], 2);
  % GrFast('Rysuj', [PulsOpoz; Opoznienie], 3);
    if get(ZerPol_lin_dB(1),'Value')==0
      tmp_Hw = abs(Hw);
      ind_ = find(tmp_Hw < 100*eps);
      if length(ind_) > 0,
        tmp_Hw(ind_)=NaN*ones(size(ind_));
      end
      tmp_Hw=20*log10(tmp_Hw);
      ind_ = find(tmp_Hw < -100);
      if length(ind_) > 0,
        tmp_Hw(ind_)=NaN*ones(size(ind_));
      end
      GrSlow('Rysuj', [Pulsacja; tmp_Hw], 1);
    else
      GrSlow('Rysuj', [Pulsacja; abs(Hw)], 1);
    end;
    GrSlow('Rysuj', [Pulsacja; Faza], 2);
% set(ZerPolResponseAxes(2:3), 'XTick', Pulsacja, 'XGrid', 'on'); % just test
    ind_ = find(abs(Opoznienie) > 100);
    if length(ind_) > 0,
      Opoznienie(ind_)=NaN*ones(size(ind_));
    end
    GrSlow('Rysuj', [PulsOpoz; Opoznienie], 3);

  	%Liczymy odpowiedz impulsow
    Odpowiedz = filter(ZerPol_K*HL, HM, [[0 1] zeros([1 32])]);
  	if length(HL)==length(HM)
     OdpowiedzX=[-1:32];
    else
     Roznica=length(HL)-length(HM);
     OdpowiedzX=[-1:32]-Roznica;
    end

  %  GrFast('Rysuj', [OdpowiedzX; real(Odpowiedz)], 4);
  %  GrFast('Rysuj', [OdpowiedzX; imag(Odpowiedz)], 5);
    GrSlow('Rysuj', [OdpowiedzX; Odpowiedz], 4);
    return;

  elseif strcmp(Param, 'Delete')
    %Naley usun wybrane
    if isempty(ZerPolWybrane)
     return;
    end
    Zmiany=0;
    for i=1:size(ZerPolWybrane,1),
      Obiekt=ZerPolWybrane(i,1);
      if get(Obiekt, 'String')=='o'
        Pozycja=find(ZerPolZera(:,1)==Obiekt);
        N=size(ZerPolZera,1);
        if Pozycja==N
          ZerPolZera=ZerPolZera(1:N-1,:);
        elseif Pozycja==1
          ZerPolZera=ZerPolZera(2:N,:);
        else
          ZerPolZera=[ZerPolZera(1:(Pozycja-1),:); ZerPolZera((Pozycja+1):N,:)];
        end
      else
        Pozycja=find(ZerPolBieguny(:,1)==Obiekt);
        N=size(ZerPolBieguny,1);
        if Pozycja==N
          ZerPolBieguny=ZerPolBieguny(1:N-1,:);
        elseif Pozycja==1
          ZerPolBieguny=ZerPolBieguny(2:N,:);
        else
          ZerPolBieguny=[ZerPolBieguny(1:(Pozycja-1),:); ZerPolBieguny((Pozycja+1):N,:)];
        end
      end
      delete(Obiekt);
      Zmiany=1;
    end
    if Zmiany==1
      ZerPolWybrane=[];
      set(ZerPolRadio(11:12), 'Enable', 'off');
      ZerPol('Licz');
    end

  elseif strcmp(Param, 'Zamien')
    %Naley wybrane zera zamieni na bieguny, a bieguny na zera
    if isempty(ZerPolWybrane)
     return;
    end
    Zmiany=0;
    for i=1:size(ZerPolWybrane,1),
      Obiekt=ZerPolWybrane(i,1);
      if get(Obiekt, 'String')=='o'
        %Jest to zero wic szukamy wrd zer
        Pozycja=find(ZerPolZera(:,1)==Obiekt);
        %Dodajemy do biegunw
        set(Obiekt, 'String', 'x');
  			ZerPolBieguny(size(ZerPolBieguny,1)+1,1)=Obiekt;
  		  ZerPolBieguny(size(ZerPolBieguny,1),2)=ZerPolZera(Pozycja,2);
        %Usuwamy z zer
        N=size(ZerPolZera,1);
        if Pozycja==N
          ZerPolZera=ZerPolZera(1:N-1,:);
        elseif Pozycja==1
          ZerPolZera=ZerPolZera(2:N,:);
        else
          ZerPolZera=[ZerPolZera(1:(Pozycja-1),:); ZerPolZera((Pozycja+1):N,:)];
        end
      else
        %Jest to biegun wic szukamy wrd biegunw
        Pozycja=find(ZerPolBieguny(:,1)==Obiekt);
        %Dodajemy do zer
        set(Obiekt, 'String', 'o');
  			ZerPolZera(size(ZerPolZera,1)+1,1)=Obiekt;
  		  ZerPolZera(size(ZerPolZera,1),2)=ZerPolBieguny(Pozycja,2);
        %Usuwamy z biegunw
        N=size(ZerPolBieguny,1);
        if Pozycja==N
          ZerPolBieguny=ZerPolBieguny(1:N-1,:);
        elseif Pozycja==1
          ZerPolBieguny=ZerPolBieguny(2:N,:);
        else
          ZerPolBieguny=[ZerPolBieguny(1:(Pozycja-1),:); ZerPolBieguny((Pozycja+1):N,:)];
        end
      end
      Zmiany=1;
    end
    if Zmiany==1
      ZerPol('Licz');
    end

  elseif strcmp(Param, 'ZamienReal')
    %Naley kty wybranych zamieni na przeciwne
    if isempty(ZerPolWybrane)
     return;
    end
    Zmiany=0;
    for i=1:size(ZerPolWybrane,1),
      Obiekt=ZerPolWybrane(i,1);
      if get(Obiekt, 'String')=='o'
        %Jest to zero wic szukamy wrd zer
        Pozycja=find(ZerPolZera(:,1)==Obiekt);
        %Zmieniamy kt
  		  ZerPolZera(Pozycja,2)=-real(ZerPolZera(Pozycja,2))+j*imag(ZerPolZera(Pozycja,2));
        set(ZerPolZera(Pozycja,1), 'Position', ConvertPos([real(ZerPolZera(Pozycja,2)) imag(ZerPolZera(Pozycja,2))], 0)); % \fixed 2005_09_30
        ZerPolWybrane(i,2)=ZerPolZera(Pozycja,2);
      else
        %Jest to biegun wic szukamy wrd biegunw
        Pozycja=find(ZerPolBieguny(:,1)==Obiekt);
        %Dodajemy do zer
  		  ZerPolBieguny(Pozycja,2)=-real(ZerPolBieguny(Pozycja,2))+j*imag(ZerPolBieguny(Pozycja,2));
        set(ZerPolBieguny(Pozycja,1), 'Position', ConvertPos([real(ZerPolBieguny(Pozycja,2)) imag(ZerPolBieguny(Pozycja,2))], 0)); % \fixed 2005_09_30
        ZerPolWybrane(i,2)=ZerPolBieguny(Pozycja,2);
      end
      Zmiany=1;
    end
    if Zmiany==1
      if get(ZerPolRadio(3),'Value')==1
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      else
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      end
      ZerPol('Licz');
    end

  elseif strcmp(Param, 'ZamienImag')
    %Naley kty wybranych zamieni na przeciwne
    if isempty(ZerPolWybrane)
     return;
    end
    Zmiany=0;
    for i=1:size(ZerPolWybrane,1),
      Obiekt=ZerPolWybrane(i,1);
      if get(Obiekt, 'String')=='o'
        %Jest to zero wic szukamy wrd zer
        Pozycja=find(ZerPolZera(:,1)==Obiekt);
        %Zmieniamy kt
  		  ZerPolZera(Pozycja,2)=real(ZerPolZera(Pozycja,2))-j*imag(ZerPolZera(Pozycja,2));
        set(ZerPolZera(Pozycja,1), 'Position', ConvertPos([real(ZerPolZera(Pozycja,2)) imag(ZerPolZera(Pozycja,2))], 0)); % \fixed 2005_09_30
        ZerPolWybrane(i,2)=ZerPolZera(Pozycja,2);
      else
        %Jest to biegun wic szukamy wrd biegunw
        Pozycja=find(ZerPolBieguny(:,1)==Obiekt);
        %Dodajemy do zer
  		  ZerPolBieguny(Pozycja,2)=real(ZerPolBieguny(Pozycja,2))-j*imag(ZerPolBieguny(Pozycja,2));
        set(ZerPolBieguny(Pozycja,1), 'Position', ConvertPos([real(ZerPolBieguny(Pozycja,2)) imag(ZerPolBieguny(Pozycja,2))], 0)); % \fixed 2005_09_30
        ZerPolWybrane(i,2)=ZerPolBieguny(Pozycja,2);
      end
      Zmiany=1;
    end
    if Zmiany==1
      if get(ZerPolRadio(3),'Value')==1
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      else
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      end
      ZerPol('Licz');
    end

  elseif strcmp(Param, 'ZamienMod')
    %Naley moduy wybranych zamieni na przeciwne
    if isempty(ZerPolWybrane)
     return;
    end
    Zmiany=0;
    for i=1:size(ZerPolWybrane,1),
      Obiekt=ZerPolWybrane(i,1);
      if get(Obiekt, 'String')=='o'
        %Jest to zero wic szukamy wrd zer
        Pozycja=find(ZerPolZera(:,1)==Obiekt);
        %Zmieniamy kt
        if abs(ZerPolZera(Pozycja,2)) > 100*eps,
  %   		  ZerPolZera(Pozycja,2)=1/abs(ZerPolZera(Pozycja,2))*exp(j*angle(ZerPolZera(Pozycja,2)));
    		  ZerPolZera(Pozycja,2)=1/conj(ZerPolZera(Pozycja,2));
          set(ZerPolZera(Pozycja,1), 'Position', ConvertPos([real(ZerPolZera(Pozycja,2)) imag(ZerPolZera(Pozycja,2))], 0)); % \fixed 2005_09_30
          ZerPolWybrane(i,2)=ZerPolZera(Pozycja,2);
        end
      else
        %Jest to biegun wic szukamy wrd biegunw
        Pozycja=find(ZerPolBieguny(:,1)==Obiekt);
        %Dodajemy do zer
%   		  ZerPolBieguny(Pozycja,2)=1/abs(ZerPolBieguny(Pozycja,2))*exp(j*angle(ZerPolBieguny(Pozycja,2)));
        if abs(ZerPolBieguny(Pozycja,2)) > 100*eps,
    		  ZerPolBieguny(Pozycja,2)=1/conj(ZerPolBieguny(Pozycja,2));
          set(ZerPolBieguny(Pozycja,1), 'Position', ConvertPos([real(ZerPolBieguny(Pozycja,2)) imag(ZerPolBieguny(Pozycja,2))], 0)); % \fixed 2005_09_30
          ZerPolWybrane(i,2)=ZerPolBieguny(Pozycja,2);
        end
      end
      Zmiany=1;
    end
    if Zmiany==1
      if get(ZerPolRadio(3),'Value')==1
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      else
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      end
      ZerPol('Licz');
    end

  elseif strcmp(Param, 'ZmienWart')
    %Zmieni warto ostatniego punktu osobliwego na wart. edytowan
    if isempty(ZerPolWybrane)
     return;
    end
    i=size(ZerPolWybrane,1);
    Obiekt=ZerPolWybrane(i,1);

%Mag***************************************

%  if get(ZerPolRadio(3),'Value')==1;
%    eval('Wartosc=str2num(get(ZerPolRadio(11),''String''))+j*str2num(get(ZerPolRadio(12),''String''));',...
%         'set(ZerPolRadio(11),''String'',''0.0'');set(ZerPolRadio(12),''String'',''0.0'');Wartosc=0;');		         			
%  else
%    eval('Wartosc=str2num(get(ZerPolRadio(11), ''String''))*exp(j*str2num(get(ZerPolRadio(12), ''String'')));',...
%         'set(ZerPolRadio(11),''String'',''0.0'');set(ZerPolRadio(12),''String'',''0.0'');Wartosc=0;');
%  end
 
%Mag end***********************************
  if get(Obiekt, 'String')=='o'
    %Jest to zero wic szukamy wrd zer
    Pozycja=find(ZerPolZera(:,1)==Obiekt);
    
    if get(ZerPolRadio(3),'Value')==1;
      Wartosc1=eval(get(ZerPolRadio(11),'String'), 'NaN');
      if isnan(Wartosc1)
        Wartosc1=real(ZerPolZera(Pozycja,2));
        set(ZerPolRadio(11),'String',num2str(Wartosc1,15));
      end;
      Wartosc2=eval(get(ZerPolRadio(12),'String'), 'NaN');
      if isnan(Wartosc2)
        Wartosc2=imag(ZerPolZera(Pozycja,2));
        set(ZerPolRadio(12),'String',num2str(Wartosc2,15));
      end;
      Wartosc=Wartosc1+j*Wartosc2;
   else
      Wartosc1=eval(get(ZerPolRadio(11),'String'), 'NaN');
      if isnan(Wartosc1)
        Wartosc1=abs(ZerPolZera(Pozycja,2));
        set(ZerPolRadio(11),'String',num2str(Wartosc1,15));
      end;
      Wartosc2=eval(get(ZerPolRadio(12),'String'), 'NaN');
      if isnan(Wartosc2)
        Wartosc2=angle(ZerPolZera(Pozycja,2));
        set(ZerPolRadio(12),'String',num2str(Wartosc2,15));
      end;
      Wartosc=Wartosc1*exp(j*Wartosc2);
    end
    
    %Zmieniamy Warto
	%Mag
	  if (MatLabVer==4)  
		  if (Wartosc==[]) 
			 Wartosc=0;
			 set(ZerPolRadio(11),'String','0.0');
			 set(ZerPolRadio(12),'String','0.0'); 
	 	  end;
	  else
		  if isempty(Wartosc)
			 Wartosc=0;
			 set(ZerPolRadio(11),'String','0.0');
			 set(ZerPolRadio(12),'String','0.0'); 
	 	  end;
	  end; 
	%Mag end				   
	  ZerPolZera(Pozycja,2)=Wartosc;
    set(ZerPolZera(Pozycja,1), 'Position', ConvertPos([real(ZerPolZera(Pozycja,2)) imag(ZerPolZera(Pozycja,2))], 0)); % \fixed 2005_09_29
    ZerPolWybrane(i,2)=ZerPolZera(Pozycja,2);
   else
    %Jest to biegun wic szukamy wrd biegunw
    Pozycja=find(ZerPolBieguny(:,1)==Obiekt);
    
    if get(ZerPolRadio(3),'Value')==1;
      Wartosc1=eval(get(ZerPolRadio(11),'String'), 'NaN');
      if isnan(Wartosc1)
        Wartosc1=real(ZerPolBieguny(Pozycja,2));
        set(ZerPolRadio(11),'String',num2str(Wartosc1,15));
      end;
      Wartosc2=eval(get(ZerPolRadio(12),'String'), 'NaN');
      if isnan(Wartosc2)
        Wartosc2=imag(ZerPolBieguny(Pozycja,2));
        set(ZerPolRadio(12),'String',num2str(Wartosc2,15));
      end;
      Wartosc=Wartosc1+j*Wartosc2;
    else
      Wartosc1=eval(get(ZerPolRadio(11),'String'), 'NaN');
      if isnan(Wartosc1)
        Wartosc1=abs(ZerPolBieguny(Pozycja,2));
        set(ZerPolRadio(11),'String',num2str(Wartosc1,15));
      end;
      Wartosc2=eval(get(ZerPolRadio(12),'String'), 'NaN');
      if isnan(Wartosc2)
        Wartosc2=angle(ZerPolBieguny(Pozycja,2));
        set(ZerPolRadio(12),'String',num2str(Wartosc2,15));
      end;
      Wartosc=Wartosc1*exp(j*Wartosc2);
    end
    
    %Zmieniamy warto
%Mag
    if (MatLabVer==4)  
		  if (Wartosc==[]) 
			 Wartosc=0;
			 set(ZerPolRadio(11),'String','0.0');
			 set(ZerPolRadio(12),'String','0.0'); 
	 	  end;
	  else
		  if isempty(Wartosc)
			 Wartosc=0;
			 set(ZerPolRadio(11),'String','0.0');
			 set(ZerPolRadio(12),'String','0.0'); 
	 	  end;
    end; 
    %Mag end	
    ZerPolBieguny(Pozycja,2)=Wartosc;
    set(ZerPolBieguny(Pozycja,1), 'Position', ConvertPos([real(ZerPolBieguny(Pozycja,2)) imag(ZerPolBieguny(Pozycja,2))], 0)); % \fixed 2005_09_29
    ZerPolWybrane(i,2)=ZerPolBieguny(Pozycja,2);
   end
   ZerPol('Licz');

  elseif strcmp(Param, 'down')
    selection_ = get(gcf,'SelectionType');
    if ZerPolZoom==0
      Pozycja = get(ZerPolhAxes, 'CurrentPoint');
      Pozycja = Pozycja(1,1:2);
      Real_Pozycja = ConvertPos(Pozycja, 1); % from compressed to real values ?? \fixed 2005_09_29
      
      if strcmp(selection_, ZerPol_Sel)
      %Jeli prawy przycisk to dodaj zero/biegun
      	Zakres = [get(ZerPolhAxes, 'XLim'), get(ZerPolhAxes, 'YLim')];
      	if InBox(Real_Pozycja, Zakres) % \fixed 2005_09_29
      		pom=text(Pozycja(1), Pozycja(2), ZerPolObiekt);

          % \fixed 2005_09_30
          %Usu poprzednie zaznaczenia
          if ~isempty(ZerPolWybrane)
            set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);
          end
          % /fixed 2005_09_30
      		if ZerPolObiekt=='o'
      			ZerPolZera(size(ZerPolZera,1)+1,1)=pom;
      			ZerPolZera(size(ZerPolZera,1),2)=Real_Pozycja(1)+j*Real_Pozycja(2); % \fixed 2005_09_29

            % \fixed 2005_09_30
            ZerPolWybrane=ZerPolZera(size(ZerPolZera,1),:);
            % /fixed 2005_09_30
      		else
      			ZerPolBieguny(size(ZerPolBieguny,1)+1,1)=pom;
      			ZerPolBieguny(size(ZerPolBieguny,1),2)=Real_Pozycja(1)+j*Real_Pozycja(2); % \fixed 2005_09_29

            % \fixed 2005_09_30
            ZerPolWybrane=ZerPolBieguny(size(ZerPolBieguny,1),:);
            % /fixed 2005_09_30
          end
          % \fixed 2005_09_30
          if get(ZerPolRadio(3),'Value')==1
            set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
            set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
          else
            set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
            set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
          end
          set(ZerPolRadio(11:12), 'Enable', 'on');
          % /fixed 2005_09_30
      		set(pom, 'HorizontalAlignment', 'Center',...
      						 'FontWeight', 'bold',... % \fixed 2005_09_30
      						 'Color', [1 0 0], ...    % \fixed 2005_09_30
      						 'VerticalAlignment', 'Middle');
      		ZerPol('Licz');
      	end
      	return;
      end

%       if strcmp(selection_, 'normal') ...
%         | strcmp(selection_, ZerPol_AddSel)
      %Jeli lewy przycisk to wybierz/wybieraj/przesuwaj
      %Naley znale obiekt najbliszy do pozycji kliknicia
      Obiekt=GetOb([ZerPolZera; ZerPolBieguny], Real_Pozycja(1)+j*Real_Pozycja(2));  % \fixed 2005_09_29

      if ~isempty(Obiekt)
        %jeli tak to wybierz/dodaj  ten jeden
        
        % rodkowy przycisk / SHIFT + lewy przycisk
        % to tylko dodaj do zaznaczonych

        % ale najpierw sprawd czy ju go nie ma na licie
        % jeli jak to go usu z listy
        if size(ZerPolWybrane,1) > 0,
          ind_ob = find(ZerPolWybrane(:,1) == Obiekt);
        else
          ind_ob = [];
        end
        
        if strcmp(selection_, 'normal')
          if length(ind_ob) > 0,
            % jeeli punkt jest akurat wybrany to tylko tryb przesuwania
          else
            %Usu poprzednie zaznaczenia
            if ~isempty(ZerPolWybrane)
              set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);   
              ZerPolWybrane=[];
              set(ZerPolRadio(11:12), 'Enable', 'off');
            end
          end
        end
        
        if length(ind_ob) > 0,
          if strcmp(selection_, 'normal')
            % jeeli punkt jest akurat wybrany to tylko tryb przesuwania
            set(ZerPolFigure,...
                 'windowbuttondownfcn','', ...
                 'windowbuttonupfcn','ZerPol(''up'')', ...
                 'windowbuttonmotionfcn','ZerPol(''Ruch'')');
            ZerPolStart=get(ZerPolhAxes, 'CurrentPoint');
            ZerPolStart=ZerPolStart(1,1:2);
            ZerPolStart_Obiekt_ind = ind_ob(1); %Obiekt;
          else
            % z SHIFTem to usu zaznaczenie wybranego punktu
            ZerPolWybrane(ind_ob,:)=[];
            set(Obiekt, 'FontWeight', 'light','Color', [0 0 0]);   
            if size(ZerPolWybrane,1) == 1,
              set(ZerPolRadio(11:12), 'Enable', 'on');

              if get(ZerPolRadio(3),'Value')==1
                set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
                set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
              else
                set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
                set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
              end
            else
              set(ZerPolRadio(11:12), 'Enable', 'off');
            end
          end
        else
          if (get(Obiekt, 'String')=='o') | (get(Obiekt, 'String')=='x')
            ZerPolWybrane(size(ZerPolWybrane,1)+1,1)=Obiekt;
            if get(Obiekt, 'String')=='o'
              ZerPolWybrane(size(ZerPolWybrane,1),2)=ZerPolZera(find(ZerPolZera(:,1)==Obiekt),2);
            else
              ZerPolWybrane(size(ZerPolWybrane,1),2)=ZerPolBieguny(find(ZerPolBieguny(:,1)==Obiekt),2);
            end
            set(Obiekt, 'FontWeight', 'bold',...
                         'Color', [1 0 0]);
                       
            if size(ZerPolWybrane,1) == 1,
              set(ZerPolRadio(11:12), 'Enable', 'on');
              if get(ZerPolRadio(3),'Value')==1
                set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
                set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
              else
                set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
                set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
              end
            else
              set(ZerPolRadio(11:12), 'Enable', 'off');
            end

            if strcmp(selection_, 'normal')
            % i przejd w tryb przesuwania
              set(ZerPolFigure,...
                   'windowbuttondownfcn','', ...
                   'windowbuttonupfcn','ZerPol(''up'')', ...
                   'windowbuttonmotionfcn','ZerPol(''Ruch'')');
              ZerPolStart=get(ZerPolhAxes, 'CurrentPoint');
              ZerPolStart=ZerPolStart(1,1:2);
              ZerPolStart_Obiekt_ind = size(ZerPolWybrane,1); %Obiekt;
            end
          end
        end
      else
        % jeeli lewy przycisk to usu wybr
        if strcmp(selection_, 'normal')
          %Usu poprzednie zaznaczenia
          % jeeli punkt jest akurat wybrany to tylko tryb przesuwania
          if ~isempty(ZerPolWybrane)
            set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);   
            ZerPolWybrane=[];
            set(ZerPolRadio(11:12), 'Enable', 'off');
          end
        end
      end
      return;
    else
      %Zoom !!!
      if strcmp(selection_, 'normal')
        %Zapamitaj stare XLim i YLim
        ZerPolXLim(size(ZerPolXLim,1)+1,1:2)=get(ZerPolhAxes,'XLim');
        ZerPolYLim(size(ZerPolYLim,1)+1,1:2)=get(ZerPolhAxes,'YLim');
        %Mag  
        x_mag=get(ZerPolhAxes,'XTick');
        ZerPolXTick(size(ZerPolXTick,1)+1,1:5+4)=x_mag(1:5+4); % \fixed 2005_09_29
        x_mag=get(ZerPolhAxes,'YTick');
        ZerPolYTick(size(ZerPolYTick,1)+1,1:5+4)=x_mag(1:5+4); % \fixed 2005_09_29
        clear x_mag;
        %Mag end
        
        %Pobierz mowe XLim i YLim
        Start=get(ZerPolhAxes,'currentpoint');
        Start = Start(1,1:2);
        % \fixed 2005_09_29
        set(gcf, 'Units', 'pixels');
        % /fixed 2005_09_29
        rbbox([get(gcf, 'currentpoint') 0 0],get(gcf, 'currentpoint'));
        Koniec=get(ZerPolhAxes,'currentpoint');
        Koniec = Koniec(1,1:2);
        set(ZerPolhAxes, 'XLim', [min([Start(1) Koniec(1)]), max([Start(1) Koniec(1)])],...
                         'YLim', [min([Start(2) Koniec(2)]), max([Start(2) Koniec(2)])]);
        ZerPolSkalaX=abs(Start(1)-Koniec(1));
        ZerPolSkalaY=abs(Start(2)-Koniec(2));
        %Mag
        x_mag=ceil(1000*abs(Start(1)-Koniec(1))/4)/1000;
        y_mag=ceil(1000*min([Start(1) Koniec(1)]))/1000;
        set(ZerPolhAxes,'XTick',[y_mag-2*x_mag y_mag-x_mag y_mag y_mag+x_mag y_mag+2*x_mag y_mag+3*x_mag y_mag+4*x_mag y_mag+5*x_mag y_mag+6*x_mag]); % \fixed 2005_09_29 
        x_mag=ceil(1000*abs(Start(2)-Koniec(2))/4)/1000;
        y_mag=ceil(1000*min([Start(2) Koniec(2)]))/1000;
%         set(ZerPolhAxes,'YTick',[y_mag y_mag+x_mag y_mag+2*x_mag y_mag+3*x_mag y_mag+4*x_mag]);
        set(ZerPolhAxes,'YTick',[y_mag-2*x_mag y_mag-x_mag y_mag y_mag+x_mag y_mag+2*x_mag y_mag+3*x_mag y_mag+4*x_mag y_mag+5*x_mag y_mag+6*x_mag]); % \fixed 2005_09_29 
        clear x_mag;
        clear y_mag;
        %Mag end
  % 'XTick', [-2 -1 0 1 2],...
      elseif strcmp(selection_, ZerPol_Sel)
        %Odtwrz poprzednie XLim i YLim
        if ~isempty(ZerPolXLim)
          XLim=ZerPolXLim(length(ZerPolXLim(:,1)),:);
          YLim=ZerPolYLim(length(ZerPolYLim(:,1)),:);
          set(ZerPolhAxes, 'XLim', XLim, 'YLim', YLim);
          %Mag
       	  set(ZerPolhAxes, 'XTick', ZerPolXTick(length(ZerPolXTick(:,1)),:),...
             'YTick', ZerPolYTick(length(ZerPolYTick(:,1)),:));
          ZerPolXTick=ZerPolXTick(1:(length(ZerPolXTick(:,1))-1),:);
          ZerPolYTick=ZerPolYTick(1:(length(ZerPolYTick(:,1))-1),:);
          %Mag end
          ZerPolXLim=ZerPolXLim(1:(length(ZerPolXLim(:,1))-1),:);
          ZerPolYLim=ZerPolYLim(1:(length(ZerPolYLim(:,1))-1),:);
          ZerPolSkalaX=abs(XLim(1)-XLim(2));
          ZerPolSkalaY=abs(YLim(1)-YLim(2));
        end
      end
    end

  %porusznie myszk nad paszczyzn
  elseif strcmp(Param, 'Ruch_info')
    Pozycja=get(ZerPolhAxes, 'CurrentPoint');
    Pozycja = Pozycja(1,1:2);
    Real_Pozycja = ConvertPos(Pozycja, 1); % from compressed to real values ?? \fixed 2005_09_29
    
    Obiekty=GetOb([ZerPolZera; ZerPolBieguny], Real_Pozycja(1)+j*Real_Pozycja(2), 1);  

    ile_z = 0; ile_p = 0;
    for ind_ = 1:size(Obiekty,1),
      if length(find(Obiekty(ind_,1)==ZerPolZera(:,1))) > 0,
        % zero
        ile_z = ile_z + 1;
      else
        % pole
        ile_p = ile_p + 1;
      end
    end
%     set(ZerPolFigure,'Name', ...
%        [ZerPolVer, '   ', sprintf('%1.5g+j%1.5g: zeros x %i. poles x %i', Real_Pozycja(1), Real_Pozycja(2), ile_z, ile_p)]);
    if ile_z > 1,
      tekst = sprintf('{\\fontsize{14} {\\bf{zeros x %i}}}/%i', ile_z, size(ZerPolZera,1));
    elseif ile_z == 1,
      tekst = sprintf('{\\bf{zeros x %i}}/%i', ile_z, size(ZerPolZera,1));
    else
      tekst = sprintf('zeros x %i/%i', ile_z, size(ZerPolZera,1));
    end
    if ile_p > 1,
      tekst = sprintf('%s, {\\fontsize{14} {\\bf{poles x %i}}}/%i', tekst, ile_p, size(ZerPolBieguny,1));
    elseif ile_p == 1,
      tekst = sprintf('%s, {\\bf{poles x %i}}/%i', tekst, ile_p, size(ZerPolBieguny,1));
    else
      tekst = sprintf('%s, poles x %i/%i', tekst, ile_p, size(ZerPolBieguny,1));
    end
    if ile_z + ile_p > 0,
      Real_Pozycja = [real(Obiekty(1,2)), imag(Obiekty(1,2))];
    end
    if Real_Pozycja(2) < 0,    
      tekst = sprintf('%s (%1.5g-j%1.5g)', tekst, Real_Pozycja(1), -Real_Pozycja(2));
    else
      % \fixed 2007.11.07
      tekst = sprintf('%s (%1.5g+j%1.5g)', tekst, Real_Pozycja(1), Real_Pozycja(2));
    end
    set(ZerPol_xlabel, 'String', tekst);
    return;
    
  %porusznie myszk z przycinitym lewym klawiszem
  elseif strcmp(Param, 'Ruch')
    Pozycja=get(ZerPolhAxes, 'CurrentPoint');
    Korekta=ConvertPos(ZerPolStart, 1)-ConvertPos(Pozycja(1,1:2),1); % \fixed 2005_09_29
    
    NowePozycje = GetNewPositions(Korekta, (get(ZerPolRadio(10), 'Value') > 0));
    if size(ZerPolWybrane,1) == 1,
      % przesuwamy jeden punkt jeeli jest w zakresie
      set(ZerPolWybrane(1,1), 'Position', ConvertPos(NowePozycje, 0)); 
      if get(ZerPolRadio(3),'Value')==1
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', NowePozycje(1)));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', NowePozycje(2)));
      else
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(NowePozycje(1)+j*NowePozycje(2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(NowePozycje(1)+j*NowePozycje(2))));
      end
    else
      %No to teraz przesumy wybrane punkty osobliwe
      %jeli przesuwany punkt podstawowy jest w zakresie wsprzdnych
      set(ZerPolWybrane(ZerPolStart_Obiekt_ind,1), 'Position', ConvertPos(NowePozycje(ZerPolStart_Obiekt_ind,:), 0)); 
      if get(ZerPolRadio(3),'Value')==1
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', NowePozycje(ZerPolStart_Obiekt_ind,1)));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', NowePozycje(ZerPolStart_Obiekt_ind,2)));
      else
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(NowePozycje(ZerPolStart_Obiekt_ind,1)+j*NowePozycje(ZerPolStart_Obiekt_ind,2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(NowePozycje(ZerPolStart_Obiekt_ind,1)+j*NowePozycje(ZerPolStart_Obiekt_ind,2))));
      end
      
      for ind_=1:size(ZerPolWybrane,1),
        if ind_ ~= ZerPolStart_Obiekt_ind,
          set(ZerPolWybrane(ind_,1), 'Position', ConvertPos(NowePozycje(ind_,:), 0)); 
        end
      end
    end
    return;

  %Puszczenie lewego przycisku myszki
  elseif strcmp(Param, 'up')
    if ZerPolZoom==0
%       Zmiany=0;
      %No to wybrane na nowe pozycje
      Pozycja=get(ZerPolhAxes, 'CurrentPoint');
      Korekta=ConvertPos(ZerPolStart, 1)-ConvertPos(Pozycja(1,1:2),1); % \fixed 2005_09_29

      [NowePozycje, Zmiany] = GetNewPositions(Korekta, (get(ZerPolRadio(10), 'Value') > 0));
      if Zmiany == 0,
        for ind_=1:size(ZerPolWybrane,1),
          NowePozycje(ind_,1:2) = [real(ZerPolWybrane(ind_,2)), imag(ZerPolWybrane(ind_,2))];
        end
      else
        for ind_=1:size(ZerPolWybrane,1),
          ZerPolWybrane(ind_,2)=NowePozycje(ind_,1)+j*NowePozycje(ind_,2);
        end
      end
      for ind_=1:size(ZerPolWybrane,1),
        set(ZerPolWybrane(ind_,1), 'Position', ConvertPos(NowePozycje(ind_,:),0)); % \fixed 2005_09_29
      end
      
      if size(ZerPolWybrane,1) == 1,
        % przesuwamy jeden punkt jeeli jest w zakresie
        set(ZerPolWybrane(1,1), 'Position', ConvertPos(NowePozycje, 0)); 
        if get(ZerPolRadio(3),'Value')==1
          set(ZerPolRadio(11), 'String', sprintf('%1.16g', NowePozycje(1)));
          set(ZerPolRadio(12), 'String', sprintf('%1.16g', NowePozycje(2)));
        else
          set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(NowePozycje(1)+j*NowePozycje(2))));
          set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(NowePozycje(1)+j*NowePozycje(2))));
        end
      else
        %No to teraz przesumy wybrane punkty osobliwe
        %jeli przesuwany punkt podstawowy jest w zakresie wsprzdnych
        set(ZerPolWybrane(ZerPolStart_Obiekt_ind,1), 'Position', ConvertPos(NowePozycje(ZerPolStart_Obiekt_ind,:), 0)); 
        if get(ZerPolRadio(3),'Value')==1
          set(ZerPolRadio(11), 'String', sprintf('%1.16g', NowePozycje(ZerPolStart_Obiekt_ind,1)));
          set(ZerPolRadio(12), 'String', sprintf('%1.16g', NowePozycje(ZerPolStart_Obiekt_ind,2)));
        else
          set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(NowePozycje(ZerPolStart_Obiekt_ind,1)+j*NowePozycje(ZerPolStart_Obiekt_ind,2))));
          set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(NowePozycje(ZerPolStart_Obiekt_ind,1)+j*NowePozycje(ZerPolStart_Obiekt_ind,2))));
        end
      end
      
      %No to teraz przesumy wybrane punkty osobliwe
      %jeli bd z zakresie wsprzdnych
      for i=1:size(ZerPolWybrane,1),
    		if get(ZerPolWybrane(i,1), 'String')=='o'
          ZerPolZera(find(ZerPolZera(:,1)==ZerPolWybrane(i,1)),2)=...
            ZerPolWybrane(i,2);
        else
          ZerPolBieguny(find(ZerPolBieguny(:,1)==ZerPolWybrane(i,1)),2)=...
            ZerPolWybrane(i,2);
        end
      end
      set(ZerPolFigure,...
        'windowbuttondownfcn','ZerPol(''down'')', ...
        'windowbuttonupfcn','', ...
        'windowbuttonmotionfcn','ZerPol(''Ruch_info'')');
      if Zmiany
        ZerPol('Licz');
      end
    else
     %Zoom!!!
    end
    return;

  elseif strcmp(Param, 'SelectAll')
   ZerPolWybrane=[ZerPolZera; ZerPolBieguny];
   if nargin <= 1
     ZerPolWybrane = CheckSelectionMode(ZerPolWybrane);
   end
   if ~isempty(ZerPolWybrane)
     if get(ZerPolRadio(3),'Value')==1
       set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
       set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
     else
       set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
       set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
     end
     if size(ZerPolWybrane,1)==1
       set(ZerPolRadio(11:12), 'Enable', 'on');
     end
     set(ZerPolWybrane(:,1), 'FontWeight', 'bold', 'Color', [1 0 0]);
   else
     set(ZerPolRadio(11:12), 'Enable', 'off');
   end

  elseif strcmp(Param, 'SelectZ')
   %Usu poprzednie zaznaczenia
   if ~isempty(ZerPolWybrane)
    set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);
   end
   ZerPolWybrane=ZerPolZera;
   if nargin <= 1
     ZerPolWybrane = CheckSelectionMode(ZerPolWybrane);
   end
   if ~isempty(ZerPolWybrane)
     if get(ZerPolRadio(3),'Value')==1
       set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
       set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
     else
       set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
       set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
     end
     if size(ZerPolWybrane,1)==1
       set(ZerPolRadio(11:12), 'Enable', 'on');
     end
     set(ZerPolWybrane(:,1), 'FontWeight', 'bold', 'Color', [1 0 0]);
   else
     set(ZerPolRadio(11:12), 'Enable', 'off');
   end

  elseif strcmp(Param, 'SelectP')
   %Usu poprzednie zaznaczenia
   if ~isempty(ZerPolWybrane)
    set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);
   end
   ZerPolWybrane=ZerPolBieguny;
   if nargin <= 1
     ZerPolWybrane = CheckSelectionMode(ZerPolWybrane);
   end
   if ~isempty(ZerPolWybrane)
     if get(ZerPolRadio(3),'Value')==1
       set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
       set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
     else
       set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
       set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
     end
     if size(ZerPolWybrane,1)==1
       set(ZerPolRadio(11:12), 'Enable', 'on');
     end
     set(ZerPolWybrane(:,1), 'FontWeight', 'bold', 'Color', [1 0 0]);
   else
     set(ZerPolRadio(11:12), 'Enable', 'off');
   end
  return;

  elseif strcmp(Param, 'Zoom')
   ZerPolZoom=1-ZerPolZoom;
   if ZerPolZoom==1
     set([ZerPolFigure ZerPolSygnaly],'Pointer','circle');
     pom_f=gcf;
     figure(ZerPolSygnaly); 
     zoom on;
     GrSlow('Zoom_in');
     figure(pom_f); 
   else
     set(ZerPolFigure,'Pointer','crosshair');
     set(ZerPolSygnaly,'Pointer','arrow');
     pom_f=gcf;
     figure(ZerPolSygnaly); 
     zoom off;
     GrSlow('Zoom_out');
     figure(pom_f); 
   end
   ZerPol('Licz');
   return;

  elseif strcmp(Param, 'Key')
   Klawisz=upper(get(gcf, 'CurrentCharacter'));
   if length(Klawisz) > 0,
     if Klawisz=='D',
       ZerPol('Delete');
     else
       if DebugKeys == 1,
         disp(real(Klawisz));
       end
     end
   end
   return;

  %Zmiana wprowadzanego punktu osobliwego
  elseif strcmp(Param(1:length(Param)-1), 'Zera')
    if Param(length(Param))=='0'
      ZerPolObiekt='o';
      set(ZerPolRadio(1), 'Value', 1);
      set(ZerPolRadio(2), 'Value', 0);
  	else
      ZerPolObiekt='x';
      set(ZerPolRadio(1), 'Value', 0);
      set(ZerPolRadio(2), 'Value', 1);
    end
    %A teraz jeszcze trzeba zmieni zaznaczone

  %Zmiana trybu tekstowego wywietlania/wprowadzania punktu osobliwego
  elseif strcmp(Param(1:length(Param)-1), 'Polar')
    if Param(length(Param))=='0'
      ZerPolTrybEdycji=0;
      set(ZerPolRadio(5), 'String', 'real:');
      set(ZerPolRadio(6), 'String', 'imag:');
      set(ZerPolRadio(3), 'Value', 1);
      set(ZerPolRadio(4), 'Value', 0);
  	else
      ZerPolTrybEdycji=1;
      set(ZerPolRadio(5), 'String', 'magn.:');
      set(ZerPolRadio(6), 'String', 'phase:');
      set(ZerPolRadio(3), 'Value', 0);
      set(ZerPolRadio(4), 'Value', 1);
    end
    if ~isempty(ZerPolWybrane)
      if get(ZerPolRadio(3),'Value')==1
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      else
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      end
    end

  elseif strcmp(Param, 'NoweZero')
    figure(ZerPolFigure);
		pom=text(0, 0, 'o');
		ZerPolZera(size(ZerPolZera,1)+1,1)=pom;
		ZerPolZera(size(ZerPolZera,1),2)=0;
		set(pom, 'HorizontalAlignment', 'Center',...
						 'FontWeight', 'bold',...
						 'Color', [1 0 0], ...
						 'VerticalAlignment', 'Middle');
    %Usu poprzednie zaznaczenia
    if ~isempty(ZerPolWybrane)
     set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);
    end
    ZerPolWybrane=ZerPolZera(size(ZerPolZera,1),:);
    if get(ZerPolRadio(3),'Value')==1
      set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
    else
      set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
    end
    set(ZerPolRadio(11:12), 'Enable', 'on');
    ZerPol('Ruch_info');
    ZerPol('Licz');
    
  elseif strcmp(Param, 'NowyBiegun')
    figure(ZerPolFigure);
		pom=text(0, 0, 'x');
		ZerPolBieguny(size(ZerPolBieguny,1)+1,1)=pom;
		ZerPolBieguny(size(ZerPolBieguny,1),2)=0;
		set(pom, 'HorizontalAlignment', 'Center',...
						 'FontWeight', 'bold',...
						 'Color', [1 0 0], ...
						 'VerticalAlignment', 'Middle');
    %Usu poprzednie zaznaczenia
    if ~isempty(ZerPolWybrane)
     set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);
    end
    ZerPolWybrane=ZerPolBieguny(size(ZerPolBieguny,1),:);
    if get(ZerPolRadio(3),'Value')==1
      set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
    else
      set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
    end
    set(ZerPolRadio(11:12), 'Enable', 'on');
    ZerPol('Ruch_info');
		ZerPol('Licz');

  elseif strcmp(Param, 'DodajSprzone_All')
    figure(ZerPolFigure);
    
    % poles
    ile_p = size(ZerPolBieguny,1);
		ZerPolBieguny(ile_p+[1:ile_p],2)=conj(ZerPolBieguny([1:ile_p],2));
    for ind_=1:ile_p,
      tmp_pos=ConvertPos([real(ZerPolBieguny(ile_p+ind_,2)), imag(ZerPolBieguny(ile_p+ind_,2))], 0);
  		pom=text(tmp_pos(1), tmp_pos(2), 'x');
   		set(pom, 'HorizontalAlignment', 'Center',...
 	  					 'FontWeight', 'bold',...
 			  			 'Color', [1 0 0], ...
 						  'VerticalAlignment', 'Middle');
  		ZerPolBieguny(ile_p+ind_,1)=pom;
    end
    
    % zeros
    ile_z = size(ZerPolZera,1);
		ZerPolZera(ile_z+[1:ile_z],2)=conj(ZerPolZera([1:ile_z],2));
    for ind_=1:ile_z,
      tmp_pos=ConvertPos([real(ZerPolZera(ile_z+ind_,2)), imag(ZerPolZera(ile_z+ind_,2))], 0);
  		pom=text(tmp_pos(1), tmp_pos(2), 'o');
   		set(pom, 'HorizontalAlignment', 'Center',...
 	  					 'FontWeight', 'bold',...
 			  			 'Color', [1 0 0], ...
 						  'VerticalAlignment', 'Middle');
  		ZerPolZera(ile_z+ind_,1)=pom;
    end
    
    %Usu poprzednie zaznaczenia
    if ~isempty(ZerPolWybrane)
      set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);
    end
    ZerPolWybrane=[ZerPolBieguny(ile_p+[1:ile_p],:); ZerPolZera(ile_z+[1:ile_z],:)];
    if size(ZerPolWybrane,1) == 1,
      if get(ZerPolRadio(3),'Value')==1
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      else
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      end
      set(ZerPolRadio(11:12), 'Enable', 'on');
    else
      set(ZerPolRadio(11:12), 'Enable', 'off');
    end
    ZerPol('Ruch_info');
		ZerPol('Licz');

  elseif strcmp(Param, 'DodajSprzone_Selected')
    figure(ZerPolFigure);
    
    ile_ = size(ZerPolWybrane,1);

    if ile_ > 0,
      ile_z = size(ZerPolZera,1);
      ile_p = size(ZerPolBieguny,1);
      
      for ind_=1:ile_,
        if get(ZerPolWybrane(ind_,1), 'String') == 'x',
          % poles
      		ZerPolBieguny(end+1,2)=conj(ZerPolWybrane(ind_,2));
          tmp_pos=ConvertPos([real(ZerPolBieguny(end,2)), imag(ZerPolBieguny(end,2))], 0);
      		pom=text(tmp_pos(1), tmp_pos(2), 'x');
      		ZerPolBieguny(end,1)=pom;
        else    
          % zeros
      		ZerPolZera(end+1,2)=conj(ZerPolWybrane(ind_,2));
          tmp_pos=ConvertPos([real(ZerPolZera(end,2)), imag(ZerPolZera(end,2))], 0);
      		pom=text(tmp_pos(1), tmp_pos(2), 'o');
      		ZerPolZera(end,1)=pom;
        end
        
     		set(pom, 'HorizontalAlignment', 'Center',...
   	  					 'FontWeight', 'bold',...
   			  			 'Color', [1 0 0], ...
   						  'VerticalAlignment', 'Middle');
      end
      
      %Usu poprzednie zaznaczenia
      if ~isempty(ZerPolWybrane)
        set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);
      end
      ZerPolWybrane=[ZerPolBieguny((ile_p+1):end,:); ZerPolZera((ile_z+1):end,:)];
      if size(ZerPolWybrane,1) == 1,
        if get(ZerPolRadio(3),'Value')==1
          set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
          set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        else
          set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
          set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        end
        set(ZerPolRadio(11:12), 'Enable', 'on');
      else
        set(ZerPolRadio(11:12), 'Enable', 'off');
      end
      ZerPol('Ruch_info');
  		ZerPol('Licz');
    end
    
  elseif strcmp(Param, 'DodajOdwrcone_All')
    figure(ZerPolFigure);
    
    % poles
    ile_p = size(ZerPolBieguny,1);
    for ind_=1:ile_p,
      if abs(ZerPolBieguny(ind_,2)) > 100*eps,
    		ZerPolBieguny(end+1,2)=1./conj(ZerPolBieguny(ind_,2));

        tmp_pos=ConvertPos([real(ZerPolBieguny(end,2)), imag(ZerPolBieguny(end,2))], 0);
    		pom=text(tmp_pos(1), tmp_pos(2), 'x');
     		set(pom, 'HorizontalAlignment', 'Center',...
   	  					 'FontWeight', 'bold',...
   			  			 'Color', [1 0 0], ...
   						  'VerticalAlignment', 'Middle');
    		ZerPolBieguny(end,1)=pom;
      end
    end
    
    % zeros
    ile_z = size(ZerPolZera,1);
    for ind_=1:ile_z,
      if abs(ZerPolZera(ind_,2)) > 100*eps,
    		ZerPolZera(end+1,2)=1./conj(ZerPolZera(ind_,2));
        
        tmp_pos=ConvertPos([real(ZerPolZera(end,2)), imag(ZerPolZera(end,2))], 0);
    		pom=text(tmp_pos(1), tmp_pos(2), 'o');
     		set(pom, 'HorizontalAlignment', 'Center',...
 	    					 'FontWeight', 'bold',...
 			    			 'Color', [1 0 0], ...
   						  'VerticalAlignment', 'Middle');
    		ZerPolZera(end,1)=pom;
      end
    end
    
    %Usu poprzednie zaznaczenia
    if ~isempty(ZerPolWybrane)
      set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);
    end
    ZerPolWybrane=[ZerPolBieguny((ile_p+1):end,:); ZerPolZera((ile_z+1):end,:)];
    if size(ZerPolWybrane,1) == 1,
      if get(ZerPolRadio(3),'Value')==1
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      else
        set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
      end
      set(ZerPolRadio(11:12), 'Enable', 'on');
    else
      set(ZerPolRadio(11:12), 'Enable', 'off');
    end
    ZerPol('Ruch_info');
		ZerPol('Licz');

  elseif strcmp(Param, 'DodajOdwrcone_Selected')
    figure(ZerPolFigure);
    
    ile_ = size(ZerPolWybrane,1);

    if ile_ > 0,
      ile_z = size(ZerPolZera,1);
      ile_p = size(ZerPolBieguny,1);
      
      for ind_=1:ile_,
        if get(ZerPolWybrane(ind_,1), 'String') == 'x',
          % poles
      		ZerPolBieguny(end+1,2)=1./conj(ZerPolWybrane(ind_,2));
          tmp_pos=ConvertPos([real(ZerPolBieguny(end,2)), imag(ZerPolBieguny(end,2))], 0);
      		pom=text(tmp_pos(1), tmp_pos(2), 'x');
      		ZerPolBieguny(end,1)=pom;
        else    
          % zeros
      		ZerPolZera(end+1,2)=1./conj(ZerPolWybrane(ind_,2));
          tmp_pos=ConvertPos([real(ZerPolZera(end,2)), imag(ZerPolZera(end,2))], 0);
      		pom=text(tmp_pos(1), tmp_pos(2), 'o');
      		ZerPolZera(end,1)=pom;
        end
        
     		set(pom, 'HorizontalAlignment', 'Center',...
   	  					 'FontWeight', 'bold',...
   			  			 'Color', [1 0 0], ...
   						  'VerticalAlignment', 'Middle');
      end
      
      %Usu poprzednie zaznaczenia
      if ~isempty(ZerPolWybrane)
        set(ZerPolWybrane(:,1), 'FontWeight', 'light','Color', [0 0 0]);
      end
      ZerPolWybrane=[ZerPolBieguny((ile_p+1):end,:); ZerPolZera((ile_z+1):end,:)];
      if size(ZerPolWybrane,1) == 1,
        if get(ZerPolRadio(3),'Value')==1
          set(ZerPolRadio(11), 'String', sprintf('%1.16g', real(ZerPolWybrane(size(ZerPolWybrane,1),2))));
          set(ZerPolRadio(12), 'String', sprintf('%1.16g', imag(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        else
          set(ZerPolRadio(11), 'String', sprintf('%1.16g', abs(ZerPolWybrane(size(ZerPolWybrane,1),2))));
          set(ZerPolRadio(12), 'String', sprintf('%1.16g', angle(ZerPolWybrane(size(ZerPolWybrane,1),2))));
        end
        set(ZerPolRadio(11:12), 'Enable', 'on');
      else
        set(ZerPolRadio(11:12), 'Enable', 'off');
      end
      ZerPol('Ruch_info');
  		ZerPol('Licz');
    end

    
  elseif strcmp(Param, 'NowyFiltr')
    %Usu wszystkie punkty osobliwe
    ZerPol('SelectAll', 1); % ignore selection mode
    ZerPol('Delete');
    figure(ZerPolFigure);

    % \fixed 2005_09_30 
    pom=[];
    for ind_=1:length(Param1),
      tmp_pos=ConvertPos([real(Param1(ind_)), imag(Param1(ind_))], 0);
  		pom(ind_,1)=text(tmp_pos(1), tmp_pos(2), 'o');
    end
    % /fixed 2005_09_30 
		ZerPolZera(1:length(Param1),1)=pom;
 		ZerPolZera(1:length(Param1),2)=Param1;
		set(pom, 'HorizontalAlignment', 'Center',...
						 'FontWeight', 'light',...
						 'Color', [0 0 0], ...
						 'VerticalAlignment', 'Middle');

    % \fixed 2005_09_30 
    pom=[];
    for ind_=1:length(Param2), % \Fixed 2005_12_16
      tmp_pos=ConvertPos([real(Param2(ind_)), imag(Param2(ind_))], 0);
  		pom(ind_,1)=text(tmp_pos(1), tmp_pos(2), 'x');
    end
    % /fixed 2005_09_30 
		ZerPolBieguny(1:length(Param2),1)=pom;
		ZerPolBieguny(1:length(Param2),2)=Param2;
		set(pom, 'HorizontalAlignment', 'Center',...
						 'FontWeight', 'light',...
						 'Color', [0 0 0], ...
						 'VerticalAlignment', 'Middle');
    ZerPol('Ruch_info');
		ZerPol('Licz');
    
  % \fixed 2005_09_29    
  elseif strcmp(Param, 'SelectZplaneRange')
    pom=get(ZerPol_ZplaneRange, 'Value');
    % jeeli zmiana ZerPol_Zplane_compressed to przeba przerystowa
    ZerPol_Zplane_compressed = 0;
    switch (pom),
      case 1, % 2.0
        z_range = 2.0;
      case 2, % 5.0
        z_range = 5.0;
      case 3, % 10.0
        z_range = 10.0;
      otherwise, %case 4: % compressed
        z_range = 2.0;
        ZerPol_Zplane_compressed = 1;
    end
    
    % \fixed 2005_09_29
    % reset zeroes and poles positions 
    for i=1:size(ZerPolZera,1),
      set(ZerPolZera(i,1), 'Position', ConvertPos([real(ZerPolZera(i,2)) imag(ZerPolZera(i,2))], 0));
    end
    for i=1:size(ZerPolBieguny,1),
      set(ZerPolBieguny(i,1), 'Position', ConvertPos([real(ZerPolBieguny(i,2)) imag(ZerPolBieguny(i,2))], 0));
    end
    
    if ZerPol_Zplane_compressed == 0,
      set(ZerPol_h_inf_ring, 'Visible', 'off');
    else
      set(ZerPol_h_inf_ring, 'Visible', 'on');
    end
    % /fixed 2005_09_29
    
    if length(z_range) > 0,
      if prod(size(ZerPolXLim)) > 0,
        prev_range = max(ZerPolXLim);
        range_threshold = min([prev_range, z_range]);
%         ind_=find(ZerPolXLim(:,1) <= -range_threshold);
%         if length(ind_) > 0,
%           ZerPolXLim(ind_,1) = -z_range*ones(size(ind_));
%         end
%         ind_=find(ZerPolXLim(:,2) >= +range_threshold);
%         if length(ind_) > 0,
%           ZerPolXLim(ind_,2) = +z_range*ones(size(ind_));
%         end
%         ind_=find(ZerPolYLim(:,1) <= -range_threshold);
%         if length(ind_) > 0,
%           ZerPolYLim(ind_,1) = -z_range*ones(size(ind_));
%         end
%         ind_=find(ZerPolYLim(:,2) >= +range_threshold);
%         if length(ind_) > 0,
%           ZerPolYLim(ind_,2) = +z_range*ones(size(ind_));
%         end
        ZerPolXLim = z_range*[-1, 1];
        ZerPolYLim = z_range*[-1, 1];
        % \fixed 2005_09_30
        ZerPolXTick = [-10 -5 -2 -1 0 1 2 5 10];
        ZerPolYTick = [-10 -5 -2 -1 0 1 2 5 10];
        figure(ZerPolFigure); 
        tmp_ZerPolZoom = ZerPolZoom;
        ZerPolZoom = 1;
        set(ZerPolFigure,'SelectionType', ZerPol_Sel); 
        ZerPol('down');
        ZerPolZoom = tmp_ZerPolZoom;
        % /fixed 2005_09_30
      else
        set(ZerPolhAxes, 'Xlim', z_range*[-1, 1]);
        set(ZerPolhAxes, 'Ylim', z_range*[-1, 1]);
      end
    end
  % /fixed 2005_09_29    
  
  elseif strcmp(Param, '3D_view')
      
    warning off
    if nargin == 1,
      ZerPol_Hz_3D_fig = Draw_Hz_3d(ZerPol_K, ZerPolZera(:,2),ZerPolBieguny(:,2), ZerPol_Hz_3D_fig);
    else
      tekst=get(Param1(1), 'String');
      tekst2=get(Param1(2), 'String');
      ZerPol_Hz_3D_fig = Draw_Hz_3d(ZerPol_K, ZerPolZera(:,2),ZerPolBieguny(:,2), ZerPol_Hz_3D_fig, eval(tekst, '0'), eval(tekst2, '0'));
    end
    set(ZerPol_Hz_3D_fig, 'UserData', ZerPolVer);
    warning on
    
  elseif strcmp(Param,'autoK') 
    ZerPol_autoK = (get(ZerPolRadio(15), 'Value') > 0); 
    if ZerPol_autoK == 0, % disable auto scalling
      set(ZerPolRadio(14),'Enable', 'on');

      ZerPol_K = 1;
      set(ZerPolRadio(14), 'String', ZerPol_K);
      
      ZerPol('Licz');
    else % enable auto scalling
      set(ZerPolRadio(14),'Enable', 'off');

      ZerPol('Licz');
    end

  elseif strcmp(Param,'SoundConfig')
    h_sc_fig=Show_SoundConfig;
%     uiwait(h_sc_fig);
  
  else
    evalin('caller', [Param, ';']);
  end

end %if nargin
return;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function pos_out = ConvertPos(pos_in, to_real)
% to_real == 1: convert to not compressed
% to_real == 0: convert to compressed

global ZerPol_Zplane_compressed;

if ZerPol_Zplane_compressed,
  if to_real == 1, % to not compressed
    val = pos_in(1) + j*pos_in(2);
    mod = abs(val);
    if mod >= 2,
      pos_out = pos_in*NaN;
    elseif mod > 1,
      new_mod = 1/(2-mod);
%       new_mod = 1/(mod - 1);
      pos_out = new_mod*pos_in/mod;
    else
      pos_out = pos_in;
    end
  else % to compressed
    val = pos_in(1) + j*pos_in(2);
    mod = abs(val);
    if mod > 1,
      new_mod = 2-1/mod;
      pos_out = new_mod*pos_in/mod;
    else
      pos_out = pos_in;
    end
  end
else
  pos_out = pos_in;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Obiekt=GetOb(Obiekty, Pozycja, select_all) 

  if nargin == 2,
    select_all = 0;
  end
% \fixed 2005_09_29
%  wg. faktycznej pozycji w axes dla trybu compressed

Obiekt=[];
if ~isempty(Obiekty) & all(isfinite(Pozycja))
 global ZerPolSkalaX ZerPolSkalaY;
 for ind_=1:size(Obiekty, 1),
   tmp_ob_pos = ConvertPos([real(Obiekty(ind_,2)), imag(Obiekty(ind_,2))], 0);
   ob_pos(ind_) = tmp_ob_pos(1) + j*tmp_ob_pos(2);
 end
 conv_Pos = ConvertPos([real(Pozycja), imag(Pozycja)], 0);
 conv_Pos = conv_Pos(1) + j*conv_Pos(2);

 Odleglosc=min(abs(ob_pos-conv_Pos)); 
 pom=find(abs(ob_pos-conv_Pos)==Odleglosc); 
 Odleglosc=ob_pos(pom(1))-conv_Pos; 
 if (abs(real(Odleglosc))<.015*ZerPolSkalaX) & (abs(imag(Odleglosc))<0.015*ZerPolSkalaY)
   Obiekt=Obiekty(pom(1),1);
 end
 
 % add all objects at the same position
 if size(Obiekt,1) > 0,
   if select_all == 1,
%      ind_=find(abs(Obiekty(:,1)-Obiekt(1,1)) < 1000*eps);
     ind_=find(abs(Obiekty(:,2)-Obiekty(pom(1),2)) < 0.0001 * max([ZerPolSkalaX, ZerPolSkalaY])); % \fixed 2006.10.23
     Obiekt(1:length(ind_),1:2) = Obiekty(ind_,:); 
   end
 end
end
% /fixed 2005_09_29
return;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function GrSlow(Akcja, Dane, Nr);
 % Dane(1, :) - wsprzdne X
 % Dane(2, :) - wsprzdne Y


Debug = 0; % \added 2005_09_29

 global GrSlowhSygn MatLabVer ZerPol_lin_dB ZerPol_netto ZerPolResponseAxes;

 if strcmp(Akcja,'Inicjuj')
   ZerPol_lin_dB(1)=uicontrol('style', 'checkbox', 'units', 'normalized', ...
     'Position', [0.8 0.97 0.2 0.03], 'String', 'linear', 'BackgroundColor', 'w', ... % \Fixed 2005_12_16
     'Callback', 'ZerPol lin_dB');
   ZerPol_netto(1)=uicontrol('style', 'checkbox', 'units', 'normalized', ...
     'Position', [0.8 0.765 0.15 0.03], 'String', 'net', 'BackgroundColor', 'w', ... 
     'Callback', 'ZerPol netto');
   for i=1:3
     pom=subplot('position', [0.1 0.40+(3-i)*0.20 0.85 0.16]);
     ZerPolResponseAxes(i) = pom;
     GrSlowhSygn(i)=plot(-pi:pi/16:(pi-pi/16), zeros([1 32]));
     if (MatLabVer>=5) % \fixed 2005_09_29
       set(pom, 'XLim', [-pi pi],...
            'XTick', [-pi -pi/2 0 pi/2 pi],...
            'XTickLabel', ['-\pi'; '    '; '    '; '    '; ' \pi'],...
            'FontSize', 10,...
            'LineWidth', 2);
     else 
       set(pom, 'XLim', [-pi pi],...
            'XTick', [-pi -pi/2 0 pi/2 pi],...
            'XTickLabels', ['-\pi'; '    '; '    '; '     '; ' \pi'],...
            'FontSize', 10,...
            'LineWidth', 2);
     end;
     set(GrSlowhSygn(i), 'Color', [1 0 0],...
                       'LineWidth', 2);
     %Dodajemy tytu wykresu
     if i==1
       if MatLabVer==4
         title('Magnitude response [dB]');
         ZerPol_lin_dB(2)=findobj(gca,'type', 'text');
       else
         ZerPol_lin_dB(2)=title('Magnitude response [dB]');
       end
     end
     if i==2
       ZerPol_netto(2) = title('Phase response [rad]');
     end
     if i==3
       ZerPol_netto(3) = title('Group delay response [Sa]');
     end
     Tytul=get(pom, 'Title');
     set(Tytul,'FontName', 'Times New Roman', 'FontSize', 9, 'Color', [0 0 1]);
     grid on;
   end
   for i=4:5,
    pom=subplot('position', [0.1 0.03+(5-i)*0.17 0.85 0.14]); %5,1,i);
    x((1:34)*3-2)=-2:31;
    x((1:34)*3-1)=-2:31;
    x((1:34)*3)=nan*ones([1 34]);
    GrSlowhSygn(i)=plot(x, [zeros(size(x))]);
    set(GrSlowhSygn(i), 'LineWidth', 2, 'Color', [1 0 0]);
    set(pom, 'XLim', [-2 31],...
            'FontSize', 9,...
            'XGrid', 'on',...
            'LineWidth', 2);
    if i==4
      title('Impulse response - real & imaginary part');
      Tytul=get(pom, 'Title');
      set(Tytul,'FontName', 'Times New Roman', 'FontSize', 9, 'Color', [0 0 1]);
    end;
  end
  return;
 end
 
 if strcmp(Akcja,'Koniec')
  clear global GrSlowhSygn;
  return;
 end

 if strcmp(Akcja,'Rysuj')
   % \fixed 2005_09_29
     real_range = max(real(Dane(2,:)))-min(real(Dane(2,:)));
     imag_range = max(imag(Dane(2,:)))-min(imag(Dane(2,:)));
     if (real_range < 500*eps) | (imag_range < 500*eps)
       if (real_range < 500*eps)
         new_r = mean(real(Dane(2,:)))*ones(size(Dane(2,:)));
       else
         new_r = real(Dane(2,:));
       end
       if (imag_range < 500*eps)
         new_i = mean(imag(Dane(2,:)))*ones(size(Dane(2,:)));
       else
         new_i = imag(Dane(2,:));
       end
       Dane(2,:)=new_r+j*new_i;
     end
   % /fixed 2005_09_29
   
  if (Nr>=1) & (Nr<=3)
    if (Nr==1) & (get(ZerPol_lin_dB(1),'Value')~=0)
     tmp_=find(isfinite(Dane(2,:)));
     pom=[0 max(Dane(2,tmp_))];
   else
     tmp_=find(isfinite(Dane(2,:)));
     pom=[min(Dane(2,tmp_)) max(Dane(2,tmp_))];
   end;
   Rozstep=abs(pom(1)-pom(2)); %
%    if Rozstep < 20*10000000*eps %Rozstep==0 \fixed 2005_09_29
   if Rozstep < 0.001, %Rozstep==0 \fixed 2005_09_29
     Rozstep=2;
   end
   pom(1)=pom(1)-Rozstep/20;
   pom(2)=pom(2)+Rozstep/20;

   if (get(get(GrSlowhSygn(Nr), 'Parent'), 'YLim') ~= pom)
    % \added 2005_09_29
    if Debug == 1,
      disp('dbg marker 1');
    end
    % /added 2005_09_29
    set(get(GrSlowhSygn(Nr), 'Parent'), 'YLim', pom);
   end
   set(GrSlowhSygn(Nr), 'Xdata', Dane(1,:),...
	                     'Ydata', Dane(2,:));
	end

  if Nr==4
   pomY=1.1*round(1000*max(abs([real(Dane(2,:)) imag(Dane(2,:))])))/1000; % \Fixed 2005.12.22
   % \fixed 2005_09_29
   if pomY < 1000*eps,
     pomY = 0.1;
   end
   % /fixed 2005_09_29
   if (get(get(GrSlowhSygn(4), 'Parent'), 'YLim') ~= [-pomY pomY])
    % \added 2005_09_29
    if Debug == 1,
      disp('dbg marker 2');
    end
    % /added 2005_09_29
    set(get(GrSlowhSygn(4), 'Parent'), 'YLim', [-pomY pomY]);
    set(get(GrSlowhSygn(5), 'Parent'), 'YLim', [-pomY pomY]);
   end
   pomX=[min(Dane(1,:)) max(Dane(1,:))];
   if (get(get(GrSlowhSygn(4), 'Parent'), 'XLim') ~= pomX) % \fixed 2005_09_29
    set(get(GrSlowhSygn(4), 'Parent'), 'XLim', pomX);
    set(get(GrSlowhSygn(5), 'Parent'), 'XLim', pomX);
   end

   Indeksy=1:length(Dane(1,:));
   x((Indeksy)*3-2)=Dane(1,:);
   x((Indeksy)*3-1)=Dane(1,:);
   x((Indeksy)*3)=nan*ones(size(Indeksy));
   y((Indeksy)*3-2)=zeros(size(Indeksy));
	 y((Indeksy)*3-1)=Dane(2,:);
	 y((Indeksy)*3)=nan*ones(size(Indeksy));
	 set(GrSlowhSygn(4), 'Xdata', x, 'Ydata',real(y));
	 set(GrSlowhSygn(5), 'Xdata', x, 'Ydata',imag(y));
  end
  return;
 elseif strcmp(Akcja,'Zoom_out')
  for i=1:3
   pom=get(GrSlowhSygn(i), 'Parent');  
   if (MatLabVer>=5) % \fixed 2005_09_29
     set(pom, 'XLim', [-pi pi],...
            'XTick', [-pi -pi/2 0 pi/2 pi],...
            'XTickLabel', ['-p'; '  '; '  '; '  '; ' p'],...
            'XGrid', 'on', 'YGrid', 'on',...
            'FontName', 'symbol');
   else 
     set(pom, 'XLim', [-pi pi],...
            'XTick', [-pi -pi/2 0 pi/2 pi],...
            'XTickLabels', ['-p'; '  '; '  '; '  '; ' p'],...
            'XGrid', 'on', 'YGrid', 'on',...
            'FontName', 'symbol');
   end;
  end;     
  for i=4:5
   pom=get(GrSlowhSygn(i), 'Parent');  
   set(pom, 'XLim', [-2 31], 'XGrid', 'on');
  end;     
  
 elseif strcmp(Akcja,'Zoom_in')
  for i=1:3
   pom=get(GrSlowhSygn(i), 'Parent');  
   if (MatLabVer==5)
     set(pom, 'XLim', [-pi pi],...
       'XTickMode', 'auto',...
       'XTickLabelMode', 'auto',...
       'XGrid', 'off', 'YGrid', 'off',...
       'FontName', 'Helvetica');
   else 
     set(pom, 'XLim', [-pi pi],...
       'XTickMode', 'auto',...
       'XTickLabelMode', 'auto',...
       'XGrid', 'off', 'YGrid', 'off',...
       'FontName', 'Helvetica');
   end;
  end;     
  for i=4:5
   pom=get(GrSlowhSygn(i), 'Parent');  
   set(pom, 'XLim', [-2 31], 'XGrid', 'off');
  end;        
 end
return;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Wynik = InBox(Pozycja, Box)
% Box =[Xmin Xmax Ymin Ymax]

% \fixed 2005_09_29
global ZerPol_Zplane_compressed;

if ZerPol_Zplane_compressed == 1,
  Wynik = all(isfinite(Pozycja));
else
  Wynik = (Pozycja(1)>=Box(1)) & (Pozycja(1)<=Box(2))...
        & (Pozycja(2)>=Box(3)) & (Pozycja(2)<=Box(4));
end
% /fixed 2005_09_29
return;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function LoadTool(Akcja, Param1, Param2)

global ZerPolLoad ZerPolhLoad MatLabVer;

if nargin==0
  % Ramka wyboru metody Projektowania/Wczytywania
  uicontrol('Style','frame',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','Load/Design',...
    'Units', 'Normalized',...
    'Position', [0.02 0.22 0.40 0.76]);
  h(1)=uicontrol('Style','radiobutton',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','Design',...
    'Units', 'Normalized',...
    'Position', [0.03 0.89 0.15 0.07],...
    'UserData', 0,...
    'Callback', 'ZerPol LoadTool(''Design'')');
  h(2)=uicontrol('Style','radiobutton',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','Load',...
    'Units', 'Normalized',...
    'Position', [0.21 0.89 0.15 0.07],...
    'UserData', 0,...
    'Callback', 'ZerPol LoadTool(''Load'');');
  h(3)=uicontrol('Style','text',...
    'BackgroundColor', [0.9 0.9 0.9],...
    'String','Opis metody',...
    'Units', 'Normalized',...
    'Position', [0.03 0.23 0.38 0.51]);
  h(4)=uicontrol('Style','popupmenu',...
    'BackgroundColor', [0.9 0.9 0.9],...
    'String','Opis metody',...
    'Units', 'Normalized',...
    'Position', [0.03 0.75 0.38 0.10],...
    'UserData', [5 1]); % init with window method

  % Ramka ramka edycji parametrw metod Projektowania
  uicontrol('Style','frame',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','Ramka Dane',...
    'Units', 'Normalized',...
    'Position', [0.44 0.22 0.54 0.76]);
  h(5)=uicontrol('Style','checkbox',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','minimum order selection',...
    'Units', 'Normalized',...
    'Position', [0.46 0.84 0.50 0.11],...
    'CallBack', 'ZerPol LoadTool(''ZmianaInterfejsu'');');
  h(6)=uicontrol('Style','text',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','Filter type:',...
    'Units', 'Normalized',...
    'Position', [0.46 0.71 0.17 0.10],...
    'HorizontalAlignment', 'left');
  h(7)=uicontrol('Style','popupmenu',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','lowpass|highpass|bandpass|stopband|comb filter type I|comb filter type II|Hilbert transformer|differentiator',...
    'Units', 'Normalized',...
    'Position', [0.63 0.71 0.33 0.10],...
    'CallBack', 'ZerPol LoadTool(''ZmianaInterfejsu'', 1);');
  h(8)=uicontrol('Style','text',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','Window:',...
    'Units', 'Normalized',...
    'Position', [0.46 0.84 0.17 0.10],...
    'HorizontalAlignment', 'left',...
    'Visible', 'off');
  h(9)=uicontrol('Style','popupmenu',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','Rectangular|Triangular|Blackman|Chebyshev|Hamming|Hann|Kaiser',...
    'Units', 'Normalized',...
    'Position', [0.63 0.84 0.33 0.10],...
    'Visible', 'off',...
    'CallBack', 'ZerPol LoadTool(''ZmianaInterfejsu'', 1);');

  h(11)=uicontrol('Style','text',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','N:',...
    'HorizontalAlignment', 'right',...
    'Units', 'Normalized',...
    'Position', [0.46 0.59 0.10 0.09]);
  h(21)=uicontrol('Style','edit',...
    'BackgroundColor', [1 1 1],...
    'String','0.0',...
    'Units', 'Normalized',...
    'Position', [0.56 0.59 0.15 0.1]);
  h(12)=uicontrol('Style','text',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','Wd2:',...
    'HorizontalAlignment', 'right',...
    'Units', 'Normalized',...
    'Position', [0.71 0.59 0.10 0.09]);
  h(22)=uicontrol('Style','edit',...
    'BackgroundColor', [1 1 1],...
    'String','0.0',...
    'Units', 'Normalized',...
    'Position', [0.81 0.59 0.15 0.1]);
  h(13)=uicontrol('Style','text',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','N:',...
    'HorizontalAlignment', 'right',...
    'Units', 'Normalized',...
    'Position', [0.46 0.48 0.10 0.09]);
  h(23)=uicontrol('Style','edit',...
    'BackgroundColor', [1 1 1],...
    'String','0.0',...
    'Units', 'Normalized',...
    'Position', [0.56 0.48 0.15 0.1]);
  h(14)=uicontrol('Style','text',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','Wd2:',...
    'HorizontalAlignment', 'right',...
    'Units', 'Normalized',...
    'Position', [0.71 0.48 0.10 0.09]);
  h(24)=uicontrol('Style','edit',...
    'BackgroundColor', [1 1 1],...
    'String','0.0',...
    'Units', 'Normalized',...
    'Position', [0.81 0.48 0.15 0.1]);
  h(15)=uicontrol('Style','text',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','N:',...
    'HorizontalAlignment', 'right',...
    'Units', 'Normalized',...
    'Position', [0.46 0.37 0.10 0.09]);
  h(25)=uicontrol('Style','edit',...
    'BackgroundColor', [1 1 1],...
    'String','0.0',...
    'Units', 'Normalized',...
    'Position', [0.56 0.37 0.15 0.1]);
  h(16)=uicontrol('Style','text',...
    'BackgroundColor', [0.8 0.8 0.8],...
    'String','Wd2:',...
    'HorizontalAlignment', 'right',...
    'Units', 'Normalized',...
    'Position', [0.71 0.37 0.10 0.09]);
  h(26)=uicontrol('Style','edit',...
    'BackgroundColor', [1 1 1],...
    'String','0.0',...
    'Units', 'Normalized',...
    'Position', [0.81 0.37 0.15 0.1]);
  h(10)=uicontrol('Style','pushbutton',...
    'BackgroundColor', [1 1 1],...
    'String','OK',...
    'Units', 'Normalized',...
    'Position', [0.86 0.25 0.10 0.11]);


  uicontrol('Style','pushbutton ',...
    'String','Exit',...
    'CallBack', 'ZerPol;',...
    'Units', 'Normalized',...
    'Position', [0.86 0.045 0.12 0.13]);
  uicontrol('Style','pushbutton',...
    'String','Save',...
    'Units', 'Normalized',...
    'CallBack', 'global ZerPolZera ZerPolBieguny; ZerPol SaveZP(ZerPolZera(:,2), ZerPolBieguny(:,2));',...
    'Position', [0.16 0.045 0.12 0.13]);
  uicontrol('Style','pushbutton',...
    'String','Tools',...
    'CallBack', 'global ZerPolLoad ZerPolTools; set(ZerPolLoad, ''Visible'', ''off''); set(ZerPolTools, ''Visible'', ''on'');',...
    'Units', 'Normalized',...
    'Position', [0.02 0.045 0.12 0.13]);

  ZerPolhLoad=h;
  LoadTool('Design'); % start with design active
  %LoadTool('Load');
  return;
else
  if nargin <= 1,
    Param1 = 0;
  end
  
  h=ZerPolhLoad;
  if strcmp(Akcja, 'Design')
    %Aktualizujemy radiobuttons
    if  (get(h(1), 'UserData')==1)
      set(h(1), 'Value', 1);
      return;
    end
    set(h(1), 'Value', 1, 'UserData', 1);
    set(h(2), 'Value', 0, 'UserData', 0);
    %Aktualizujemy popupmenu
    pom=get(h(4), 'UserData');
    set(h(4), 'String', 'Butterworth|Chebyshev type I|Chebyshev type II|Elliptic|Window method',...
              'CallBack', 'ZerPol LoadTool(''ZmianaMetody'', 1)',...
              'Value',pom(1));
    LoadTool('ZmianaMetody', 1);
    return;
  elseif strcmp(Akcja, 'Load')
    %Aktualizujemy radiobuttons
    if  (get(h(2), 'UserData')==1)
      set(h(2), 'Value', 1);
      return;
    end
    set(h(2), 'Value', 1, 'UserData', 1);
    set(h(1), 'Value', 0, 'UserData', 0);
    %Aktualizujemy popupmenu
    pom=get(h(4), 'UserData');
    set(h(4), 'String', 'Zeros&Poles|Impuls responce|Frequency responce',...
              'CallBack', 'ZerPol LoadTool(''ZmianaMetody'', 2)',...
              'Value',pom(2));
    LoadTool('ZmianaMetody', 2);
    return;
  elseif strcmp(Akcja, 'ZmianaMetody')
    pom=get(h(4), 'UserData');
    pom(Param1)=get(h(4), 'Value');
    set(h(4), 'UserData', pom);
    
    %Zmieniamy opis metody
    if Param1==1
     %Opisy metod projektowania filtrw
     %Mag
     %switch pom(1)
     if (pom(1)==1)
     %case 1,
       set(h(3), 'String', 'Butterworth digital filter design.');
     elseif (pom(1)==2)
     %case 2,
       set(h(3), 'String', 'Chebyshev type I filter design (passband ripple).');
     elseif (pom(1)==3)
     %case 3,
       set(h(3), 'String', 'Chebyshev type I filter design (stopband ripple).');
     elseif (pom(1)==4)
     %case 4,
       set(h(3), 'String', 'Elliptic or Cauer filter design (passband and stopband ripple).');
     elseif (pom(1)==5)
     %case 5,
       set(h(3), 'String', 'FIR filter design using the window method.');
     else
     %otherwise,
       set(h(3), 'String', 'No method description.');
     end
    elseif Param1==2
     %Opisy metod wczytywania filtrw
     %switch pom(2)
     if (pom(2)==1)
     %case 1,
       set(h(3), 'String', 'Load filter saved as its zeros and poles positions.');
     elseif (pom(2)==2)
     %case 2,
       set(h(3), 'String', 'Time domain filter design based on desired impuls responce.');
     elseif (pom(2)==3)
     %case 3,
       set(h(3), 'String', 'Frequency domain filter design based on desired frequency responce.');
     else     
     %otherwise Mag end,
       set(h(3), 'String', 'No method description.');
     end
    end

    %Zmieniamy interfejs wprowadzania parametrw
    % pokazanie, ukrycie i inicjacja odpowiednich pl
    LoadTool('ZmianaInterfejsu');
    return;
  elseif strcmp(Akcja, 'ZmianaInterfejsu')
    %Naley sprawdzi jaki interfejs jest potrzebny i taki zrealizowa

    %1) sprawdzamy Design/Load
    if get(h(1), 'Value')==1
      %Design
      set(h([5:9]), 'Visible', 'on');
      Metoda=get(h(4), 'Value');
      TypFiltru=get(h(7), 'Value');
      set(h(10), 'Callback', sprintf('ZerPol LoadTool(''RunDesign'', %i, %i);',Metoda,TypFiltru));
      if (Metoda>=1) & (Metoda<=4)
        %Cz wsplna tych metod
        set(h(5),'Visible', 'on');
        set(h(8:9),'Visible', 'off');
        %1a) sprawdzamy czy "order" checked
        if get(h(5), 'Value')==1
          %minimum order selection
          set(h(11), 'String', 'Rp:');
          set(h(21), 'String', '3');
          set(h(12), 'String', 'Rs:');
          set(h(22), 'String', '25');
          set(h([11 12 21 22]), 'Visible', 'on');
          %switch TypFiltru
          %Mag
          if (TypFiltru==1)
          %case 1,
            %lowpass
            set(h(13), 'String', 'Wp:');
            set(h(23), 'String', '0.45*pi');
            set(h(14), 'String', 'Ws:');
            set(h(24), 'String', '0.55*pi');
            set(h([13 14 23 24]), 'Visible', 'on');
            set(h([15 16 25 26]), 'Visible', 'off');
          elseif (TypFiltru==2)
          %case 2,
            %highpass
            set(h(13), 'String', 'Ws:');
            set(h(23), 'String', '0.45*pi');
            set(h(14), 'String', 'Wp:');
            set(h(24), 'String', '0.55*pi');
            set(h([13 14 23 24]), 'Visible', 'on');
            set(h([15 16 25 26]), 'Visible', 'off');
          elseif (TypFiltru==3)
	  %case 3,
            %bandpass
            set(h(13), 'String', 'Ws_1:');
            set(h(23), 'String', '0.2*pi');
            set(h(14), 'String', 'Wp_1:');
            set(h(24), 'String', '0.3*pi');
            set(h(15), 'String', 'Wp_2:');
            set(h(25), 'String', '0.7*pi');
            set(h(16), 'String', 'Ws_2:');
            set(h(26), 'String', '0.8*pi');
            set(h([13:16  23:26]), 'Visible', 'on');
          else
	  %otherwise, Mag end
            %stopband
            set(h(13), 'String', 'Wp_1:');
            set(h(23), 'String', '0.2*pi');
            set(h(14), 'String', 'Ws_1:');
            set(h(24), 'String', '0.3*pi');
            set(h(15), 'String', 'Ws_2:');
            set(h(25), 'String', '0.7*pi');
            set(h(16), 'String', 'Wp_2:');
            set(h(26), 'String', '0.8*pi');
            set(h([13:16  23:26]), 'Visible', 'on');
          end
        else
          %Uytkownik podaje order
          set(h(11), 'String', 'N:');
          if (Param1 == 0)
            set(h(21), 'String', '4');
          end
          set(h([11 21]), 'Visible', 'on');
          set(h([12 22]), 'Visible', 'off');
          %switch TypFiltru
	  %Mag
	  if (TypFiltru==1)
          %case 1,
            %lowpass
            set(h(13), 'String', 'W_l:');
            set(h(23), 'String', '0.5*pi');
            set(h([13 23]), 'Visible', 'on');
            set(h([14 24]), 'Visible', 'off');
	  elseif (TypFiltru==2)
          %case 2,
            %highpass
            set(h(14), 'String', 'W_u:');
            set(h(24), 'String', '0.5*pi');
            set(h([14 24]), 'Visible', 'on');
            set(h([13 23]), 'Visible', 'off');
	  elseif(TypFiltru==3)
          %case 3,
            %bandpass
            set(h(13), 'String', 'Wp_l:');
            set(h(23), 'String', '0.25*pi');
            set(h(14), 'String', 'Wp_u:');
            set(h(24), 'String', '0.75*pi');
            set(h([13 14 23 24]), 'Visible', 'on');
	  else
          %otherwise Mag end
            %stopband
            set(h(13), 'String', 'Ws_l:');
            set(h(23), 'String', '0.25*pi');
            set(h(14), 'String', 'Ws_u:');
            set(h(24), 'String', '0.75*pi');
            set(h([13 14 23 24]), 'Visible', 'on');
          end
          %A teraz to co inne dla tych metod
          %switch Metoda
	  %Mag
	  if (Metoda==1)
          %case 1,
            %Butterworth
            set(h([15 16 25 26]), 'Visible', 'off');
	  elseif (Metoda==2)
          %case 2,
            %Chebyshev type I
            set(h(15), 'String', 'Rp:');
            set(h(25), 'String', '3');
            set(h([15 25]), 'Visible', 'on');
            set(h([16 26]), 'Visible', 'off');
	  elseif (Metoda==3)
          %case 3,
            %Chebyshev type II
            set(h(16), 'String', 'Rs:');
            set(h(26), 'String', '25');
            set (h([16 26]), 'Visible', 'on');
            set(h([15 25]), 'Visible', 'off');
          elseif (Metoda==4) %case 4, Mag end
            %Elliptic
            set(h(15), 'String', 'Rp:');
            set(h(25), 'String', '3');
            set(h(16), 'String', 'Rs:');
            set(h(26), 'String', '25');
            set (h([15 16 25 26]), 'Visible', 'on');
          end
        end
      elseif Metoda==5 % METODA OKIEN
        %Metoda polegajca na okienkowaniu odpowiedzi impulsowej idealnego filtru
        TypOkna=get(h(9),'Value');
        set(h(11), 'String', 'N:');
        if (Param1 == 0)
          set(h(21), 'String', '4');
        end
        set(h([8 9 11 21]), 'Visible', 'on');
        set(h([5 12 22]), 'Visible', 'off');
        %switch TypFiltru
	%Mag
        if (TypFiltru==1) %case 1, lowpass
          set(h(13), 'String', 'W_l:');
          set(h(23), 'String', '0.5*pi');
          set(h([13 23]), 'Visible', 'on');
          set(h([14 24]), 'Visible', 'off');
        elseif (TypFiltru==2) %case 2, highpass
          set(h(14), 'String', 'W_u:');
          set(h(24), 'String', '0.5*pi');
          set(h([14 24]), 'Visible', 'on');
          set(h([13 23]), 'Visible', 'off');
        elseif (TypFiltru==3) %case 3, bandpass
          set(h(13), 'String', 'Wp_l:');
          set(h(23), 'String', '0.25*pi');
          set(h(14), 'String', 'Wp_u:');
          set(h(24), 'String', '0.75*pi');
          set(h([13 14 23 24]), 'Visible', 'on');
        elseif (TypFiltru==4) %case 4, stopband
          set(h(13), 'String', 'Ws_l:');
          set(h(23), 'String', '0.25*pi');
          set(h(14), 'String', 'Ws_u:');
          set(h(24), 'String', '0.75*pi');
          set(h([13 14 23 24]), 'Visible', 'on');
        elseif ((TypFiltru==5) | ... %case 5, comb filter type 1
                (TypFiltru==6) | ... %case 6, comb filter type 2
                (TypFiltru==7) | ... %case 7, Hilbert transformer
                (TypFiltru==8))      %case 8, differentiator
          set(h([13 14 23 24]), 'Visible', 'off');
        else %otherwise,
          WARNING('Unrecognized filter type');
        end
        %switch TypOkna
        if (TypOkna==4) %case 4,
          set(h(15), 'String', 'R:');
          set(h(25), 'String', '25');
          set(h([15 25]), 'Visible', 'on');
          set(h([16 26]), 'Visible', 'off');
        elseif (TypOkna==7) %case 7,
          set(h(15), 'String', 'alfa:');
          set(h(25), 'String', '25');
          set(h([15 25]), 'Visible', 'on');
          set(h([16 26]), 'Visible', 'off');
        else %otherwise, Mag end
          set(h([15 16 25 26]), 'Visible', 'off');
        end
      end
    else
      %Load
      Metoda=get(h(4), 'Value');
      set(h(10), 'Callback', sprintf('ZerPol LoadTool(''RunLoad'', %i);',Metoda));
      set(h([5:9 11:16 21:26]), 'Visible', 'off');
    end
    return;
  elseif strcmp(Akcja, 'RunLoad')
    %switch Param1
    %Mag
    if (Param1==1) %case 1, Zero/Pole position
      % \fixed 2005_09_29
      if MatLabVer > 5, 
        % it might work in ver.5 but I can't check it
        [Nazwa, Path] = uigetfile({'*.zp', 'Zero/pole position files (*.zp)'; ...
                                   '*.m', 'MATLAB script files (*.m)'; ...
                                   '*.*', 'all files (*.*)'}, 'Loading zeroes & poles'); 
      else
        [Nazwa, Path] = uigetfile('*.zp', 'Loading zeroes & poles'); 
      end
      % /fixed 2005_09_29
      
      % /fixed 2005_09_29
      if Path~=0
        plik=fopen([Path Nazwa], 'rt');
        if plik~=-1
          z=[]; p=[];
          % \fixed 2005_09_29
          tekst = [];
          while feof(plik) ~= 1,
            tmp_tekst=fgetl(plik);
            tekst=[tekst, char(13), tmp_tekst];
          end
          fclose(plik);
          eval(tekst);
          % /fixed 2005_09_29
          
          ZerPol('NowyFiltr', z, p);
        end
      end
      return;
      
    elseif (Param1==2) %case 2, %design on the base of impulse responce
      % \added 2006.10.23
      if MatLabVer > 5, 
        % it might work in ver.5 but I can't check it
        [Nazwa, Path] = uigetfile({'*.mat', 'FIR filter definition files (*.mat)'; ...
                                   '*.m', 'MATLAB script files (*.m)'; ...
                                   '*.*', 'all files (*.*)'}, 'Loading zeroes & poles'); 
      else
        [Nazwa, Path] = uigetfile('*.mat', 'Loading FIR filter'); 
      end
     
      if Path~=0
        h=[]; a=[];
        if (length(findstr([Path Nazwa], '.mat')) > 0)
          [h, a]=ZerPol_loadFIR([Path Nazwa]);
        else
          plik=fopen([Path Nazwa], 'rt');
          if plik~=-1
            tekst = [];
            while feof(plik) ~= 1,
              tmp_tekst=fgetl(plik);
              tekst=[tekst, char(13), tmp_tekst];
            end
            fclose(plik);
            eval(tekst);
          end  
        end
        
        if length(h) > 0,
          [z, dp]=roots_(h); p=[dp; zeros(size(z))];
          ZerPol('NowyFiltr', z, p);
        else
          z = []; p = [];
          ZerPol('NowyFiltr', z, p);
        end
      end
      % /added 2006.10.23
      
    else %otherwise, % design on the base of frequency responce
    end
    return;
  elseif strcmp(Akcja, 'RunDesign')
    %switch Param1
    if (Param1==1) %case 1,
      if get(h(5), 'Value')==1
        %minimum order selection
        Rp=str2num(get(h(21), 'String'));
        Rs=str2num(get(h(22), 'String'));
        %switch Param2
        if (Param2==1) %case 1,
          Wp=str2num(get(h(23), 'String'));
          Ws=str2num(get(h(24), 'String'));
          [N Wn]=buttord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=butter(N,Wn);
        elseif (Param2==2) %case 2,
          Ws=str2num(get(h(23), 'String'));
          Wp=str2num(get(h(24), 'String'));
          [N Wn]=buttord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=butter(N,Wn,'high');         
        elseif (Param2==3) %case 3,
          Wp=[str2num(get(h(24), 'String')) str2num(get(h(25), 'String'))];
          Ws=[str2num(get(h(23), 'String')) str2num(get(h(26), 'String'))];
          [N Wn]=buttord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=butter(N,Wn);         
        elseif (Param2==4) %case 4,
          Wp=[str2num(get(h(23), 'String')) str2num(get(h(26), 'String'))];
          Ws=[str2num(get(h(24), 'String')) str2num(get(h(25), 'String'))];
          [N Wn]=buttord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=butter(N,Wn,'stop');         
        else %otherwise
        end
        ZerPol('NowyFiltr', z, p);
        return;
      else
        N=str2num(get(h(21), 'String'));
        %switch Param2
        if (Param2==1) %case 1,
          Wn=str2num(get(h(23), 'String'));
          [z p k]=butter(N,Wn/pi);
        elseif (Param2==2) %case 2,
          Wn=str2num(get(h(24), 'String'));
          [z p k]=butter(N,Wn/pi, 'high');         
        elseif (Param2==3) %case 3,
          Wn=[str2num(get(h(23), 'String')) str2num(get(h(24), 'String'))];
          [z p k]=butter(N,Wn/pi);         
        else %otherwise,
          Wn=[str2num(get(h(23), 'String')) str2num(get(h(24), 'String'))];
          [z p k]=butter(N,Wn/pi, 'stop');         
        end
        ZerPol('NowyFiltr', z, p);
        return;
      end
    elseif (Param1==2) %case 2,
      if get(h(5), 'Value')==1
        %minimum order selection
        Rp=str2num(get(h(21), 'String'));
        Rs=str2num(get(h(22), 'String'));
        %switch Param2
        if (Param2==1) %case 1,
          Wp=str2num(get(h(23), 'String'));
          Ws=str2num(get(h(24), 'String'));
          [N Wn]=cheb1ord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=cheby1(N,Rp,Wn);
        elseif (Param2==2) %case 2,
          Ws=str2num(get(h(23), 'String'));
          Wp=str2num(get(h(24), 'String'));
          [N Wn]=cheb1ord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=cheby1(N,Rp,Wn,'high');         
        elseif (Param2==3) %case 3,
          Wp=[str2num(get(h(24), 'String')) str2num(get(h(25), 'String'))];
          Ws=[str2num(get(h(23), 'String')) str2num(get(h(26), 'String'))];
          [N Wn]=cheb1ord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=cheby1(N,Rp,Wn);         
        else %otherwise,
          Wp=[str2num(get(h(23), 'String')) str2num(get(h(26), 'String'))];
          Ws=[str2num(get(h(24), 'String')) str2num(get(h(25), 'String'))];
          [N Wn]=cheb1ord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=cheby1(N,Rp,Wn,'stop');         
        end
        ZerPol('NowyFiltr', z, p);
        return;
      else
        N=str2num(get(h(21), 'String'));
        Rp=str2num(get(h(25), 'String'));
        %switch Param2
        if (Param2==1) %case 1,
          Wn=str2num(get(h(23), 'String'));
          [z p k]=cheby1(N,Rp,Wn/pi);
        elseif (Param2==2) %case 2,
          Wn=str2num(get(h(24), 'String'));
          [z p k]=cheby1(N,Rp,Wn/pi, 'high');         
        elseif (Param2==3) %case 3,
          Wn=[str2num(get(h(23), 'String')) str2num(get(h(24), 'String'))];
          [z p k]=cheby1(N,Rp,Wn/pi);         
        else %otherwise,
          Wn=[str2num(get(h(23), 'String')) str2num(get(h(24), 'String'))];
          [z p k]=cheby1(N,Rp,Wn/pi, 'stop');         
        end
        ZerPol('NowyFiltr', z, p);
        return;
      end
    elseif (Param1==3) %case 3,
      if get(h(5), 'Value')==1
        %minimum order selection
        Rp=str2num(get(h(21), 'String'));
        Rs=str2num(get(h(22), 'String'));
        %switch Param2
        if (Param2==1) %case 1,
          Wp=str2num(get(h(23), 'String'));
          Ws=str2num(get(h(24), 'String'));
          [N Wn]=cheb2ord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=cheby2(N,Rs,Wn);
        elseif (Param2==2) %case 2,
          Ws=str2num(get(h(23), 'String'));
          Wp=str2num(get(h(24), 'String'));
          [N Wn]=cheb2ord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=cheby2(N,Rs,Wn,'high');         
        elseif (Param2==3) %case 3,
          Wp=[str2num(get(h(24), 'String')) str2num(get(h(25), 'String'))];
          Ws=[str2num(get(h(23), 'String')) str2num(get(h(26), 'String'))];
          [N Wn]=cheb2ord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=cheby2(N,Rs,Wn);         
        else %otherwise,
          Wp=[str2num(get(h(23), 'String')) str2num(get(h(26), 'String'))];
          Ws=[str2num(get(h(24), 'String')) str2num(get(h(25), 'String'))];
          [N Wn]=cheb1ord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=cheby1(N,Rp,Wn,'stop');         
        end
        ZerPol('NowyFiltr', z, p);
        return;
      else
        N=str2num(get(h(21), 'String'));
        Rs=str2num(get(h(26), 'String'));
        %switch Param2
        if (Param2==1) %case 1,
          Wn=str2num(get(h(23), 'String'));
          [z p k]=cheby2(N,Rs,Wn/pi);
        elseif (Param2==2) %case 2,
          Wn=str2num(get(h(24), 'String'));
          [z p k]=cheby2(N,Rs,Wn/pi, 'high');         
        elseif (Param2==3) %case 3,
          Wn=[str2num(get(h(23), 'String')) str2num(get(h(24), 'String'))];
          [z p k]=cheby2(N,Rs,Wn/pi);         
        else %otherwise
          Wn=[str2num(get(h(23), 'String')) str2num(get(h(24), 'String'))];
          [z p k]=cheby2(N,Rs,Wn/pi, 'stop');         
        end
        ZerPol('NowyFiltr', z, p);
        return;
      end
    elseif (Param1==4) %case 4,
      if get(h(5), 'Value')==1
        %minimum order selection
        Rp=str2num(get(h(21), 'String'));
        Rs=str2num(get(h(22), 'String'));
        %switch Param2
        if (Param2==1) %case 1,
          Wp=str2num(get(h(23), 'String'));
          Ws=str2num(get(h(24), 'String'));
          [N Wn]=ellipord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=ellip(N,Rp,Rs,Wn);
        elseif (Param2==2) %case 2,
          Ws=str2num(get(h(23), 'String'));
          Wp=str2num(get(h(24), 'String'));
          [N Wn]=ellipord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=ellip(N,Rp,Rs,Wn,'high');         
        elseif (Param2==3) %case 3,
          Wp=[str2num(get(h(24), 'String')) str2num(get(h(25), 'String'))];
          Ws=[str2num(get(h(23), 'String')) str2num(get(h(26), 'String'))];
          [N Wn]=ellipord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=ellip(N,Rp,Rs,Wn);         
        else %otherwise,
          Wp=[str2num(get(h(23), 'String')) str2num(get(h(26), 'String'))];
          Ws=[str2num(get(h(24), 'String')) str2num(get(h(25), 'String'))];
          [N Wn]=ellipord(Wp/pi,Ws/pi,Rp,Rs);
          [z p k]=ellip(N,Rp,Rs,Wn,'stop');         
        end
        ZerPol('NowyFiltr', z, p);
        return;
      else
        N=str2num(get(h(21), 'String'));
        Rp=str2num(get(h(25), 'String'));
        Rs=str2num(get(h(26), 'String'));
        %switch Param2
        if (Param2==1) %case 1,
          Wn=str2num(get(h(23), 'String'));
          [z p k]=ellip(N,Rp,Rs,Wn/pi);
        elseif (Param2==2) %case 2,
          Wn=str2num(get(h(24), 'String'));
          [z p k]=ellip(N,Rp,Rs,Wn/pi, 'high');         
        elseif (Param2==3) %case 3,
          Wn=[str2num(get(h(23), 'String')) str2num(get(h(24), 'String'))];
          [z p k]=ellip(N,Rp,Rs,Wn/pi);         
        else %otherwise,
          Wn=[str2num(get(h(23), 'String')) str2num(get(h(24), 'String'))];
          [z p k]=ellip(N,Rp,Rs,Wn/pi, 'stop');         
        end
        ZerPol('NowyFiltr', z, p);
        return;
      end
    elseif (Param1==5) %case 5,
      TypOkna=get(h(9), 'Value');
      N=str2num(get(h(21), 'String'));
      %switch TypOkna
      if (TypOkna==1) %case 1,
        W=boxcar(N);
      elseif (TypOkna==2) %case 2,
        W=triang(N);
      elseif (TypOkna==3) %case 3,
        W=blackman(N);
      elseif (TypOkna==4) %case 4,
        R=str2num(get(h(25), 'String'));
        W=chebwin(N,R);
      elseif (TypOkna==5) %case 5,
        W=hamming(N);
      elseif (TypOkna==6) %case 6,
        W=hanning(N);
      else %otherwise,
        alfa=str2num(get(h(25), 'String'));
        if alfa<21
          beta=0;
        elseif (alfa>=21) & (alfa<=50)
          beta=0.5842*(alfa-21)^0.4+0.07886*(alfa-21);
        else alfa>50
          beta=0.1102*(alfa-8.7);
        end
        W=kaiser(N,beta);
      end;

      z = []; p = [];
      %switch Param2
      if (Param2==1) %case 1,
        Wn=str2num(get(h(23), 'String'));
        b=fir1(N-1,Wn/pi,W);
      elseif (Param2==2) %case 2,
        Wn=str2num(get(h(24), 'String'));
        b=fir1(N-1,Wn/pi,'high',W);         
      elseif (Param2==3) %case 3,
        Wn=[str2num(get(h(23), 'String')) str2num(get(h(24), 'String'))];
        b=fir1(N-1,Wn/pi,W);         
      elseif (Param2==4) %case 4,
        Wn=[str2num(get(h(23), 'String')) str2num(get(h(24), 'String'))];
        b=fir1(N-1,Wn/pi,'stop',W);
      elseif (Param2==5) %case 5, comb filter type 1
        b = 1; b(N+1) =1;
      elseif (Param2==6) %case 6, comb filter type 2
        b = 1; b(N+1) =-1;
      elseif (Param2==7) %case 7, Hilbert transformer
        n = 0:N-1; n = n - (N-1)/2;
        warning off
        b = 2/pi*(sin(pi*n/2).^2)./n;
        warning on
        ind = find(~isfinite(b));
        if length(ind) >= 1,
          b(ind) = 0;
        end;
        b = b(:).*W(:);
        
%         if (rem(N, 4) == 1)
% % %           g = b(1); 
% % %           for n=2:length(b)-1,
% % %             g(n) = b(n)-g(n-1);
% % %           end
% % %           b = g;
% % %           z = -1;
% % 
% %           g = b(1); 
% %           for n=2:length(b)-1,
% %             g(n) = b(n)+g(n-1);
% %           end
% %           b = g;
% %           z = +1;
%           
% %           b = g(2:end-1)
% %           g(1), g(end)
%           b = b(2:end-1); % discard trailing zeros
%           z = []; p = [0];
%         end
%         b = conv(g,[1, 1])
      elseif (Param2==8) %case 8, differentiator
        n = 0:N-1; n = n - (N-1)/2;
        warning off
        if rem(N, 2) == 1,
          b = ((-1).^n)./n;
        else
          b = 4/pi*cos(pi*(n-1/2))./((2*n).^2);
        end
        warning on
        ind = find(~isfinite(b));
        if length(ind) >= 1,
          b(ind) = 0;
        end;
        b = b(:).*W(:);
      else %otherwise,
        warning('Unsupported filter type');
      end
      [z, dp, K]=roots_(b); p=[dp; zeros(size(z))];

      ZerPol_K = K;
      global ZerPolRadio;
      set(ZerPolRadio(14), 'String', ZerPol_K);

      ZerPol('NowyFiltr', z, p);
      return;
    end
  end
end
return;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function SaveZP(z,p);

% \fixed 2005_09_29
global MatLabVer ZerPolVer

IsOK = 0;
while IsOK == 0,
  if MatLabVer > 5, 
    % it might work in ver.5 but I can't check it
    [Nazwa, Path] = uiputfile({'*.zp', 'Zero/pole position files (*.zp)'; ...
                               '*.m', 'MATLAB script files (*.m)'; ...
                               '*.*', 'all files (*.*)'}, 'Saving zeroes & poles'); 
    IsOK = 1;

    if Path~=0
      if length(find(Nazwa == '.')) == 0,
        ButtonName = questdlg('Are you sure that want to save to file without ''.zp'' extention?', ...
           'Filename without extention detected', 'Yes', 'No', 'Abort saving', 'No');
        switch (ButtonName),
          case 'Yes',
            IsOK = 1;
          case 'No',
            IsOK = 0;
          case 'Abort saving',
            return;
        end
      end
    end
  else
    [Nazwa, Path] = uiputfile('*.zp', 'Saving zeroes & poles');
    IsOK = 1;
  end
end
% /fixed 2005_09_29

if Path~=0
% % problem that overwrite warnings will address files without extention
%   % \fixed 2005_09_29 
%   if length(find(Nazwa == '.')) == 0,
%     Nazwa = [Nazwa, '.zp'];
%   end
%   % /fixed 2005_09_29
  plik=fopen([Path Nazwa], 'wt');
  if plik~=-1
    N=length(z); M=length(p);
    % \fixed 2005_09_29
    fprintf(plik, '%%%s: zeroes and poles positions\n\n', ZerPolVer);
    fprintf(plik, '%%>>zeros:\n');
    if N==0
      fprintf(plik, 'z=[];');
    elseif N==1
    % /fixed 2005_09_29
      fprintf(plik, 'z=[(%g)+i*(%g)];', real(z(1)), imag(z(1)));
    elseif N==2
      fprintf(plik, 'z=[(%g)+i*(%g); (%g)+i*(%g)];', real(z(1)), imag(z(1)), real(z(2)), imag(z(2)));
    else
      % \fixed 2005_09_29
      fprintf(plik, 'z=[(%g)+i*(%g); ...\n', real(z(1)), imag(z(1)));
      for ind=2:N-1,
        fprintf(plik, '   (%g)+i*(%g); ...\n', real(z(ind)), imag(z(ind)));
      end
      fprintf(plik, '   (%g)+i*(%g)];', real(z(N)), imag(z(N)));
      % /fixed 2005_09_29
    end
    fprintf(plik, '\n'); % \fixed 2005_09_29
    fprintf(plik, '%%>>poles:\n');
    % \fixed 2005_09_29
    if M==0
      fprintf(plik, 'p=[];');
    elseif M==1
    % /fixed 2005_09_29
      fprintf(plik, 'p=[(%g)+i*(%g)];', real(p(1)), imag(p(1)));
    elseif M==2
      fprintf(plik, 'p=[(%g)+i*(%g);(%g)+i*(%g)];', real(p(1)), imag(p(1)), real(p(2)), imag(p(2)));
    else
      % \fixed 2005_09_29
      fprintf(plik, 'p=[(%g)+i*(%g); ...\n', real(p(1)), imag(p(1)));
      for ind=2:M-1,
        fprintf(plik, '   (%g)+i*(%g); ...\n', real(p(ind)), imag(p(ind)));
      end
      fprintf(plik, '   (%g)+i*(%g)];', real(p(M)), imag(p(M)));
      % /fixed 2005_09_29
    end
    fclose(plik);
  end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Tools()

global ZerPolRadio ZerPolTrybEdycji ZerPolZoom ZerPol_ZplaneRange ZerPol_select_mode;
global ZerPol_K ZerPol_autoK;

% Ramka wyboru trybu wprowadzania i modyfikacji zer i biegunw
uicontrol('Style','frame',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','Modyfing',...
  'Units', 'Normalized',...
  'Position', [0.02 0.22 0.27 0.76]);

ZerPolRadio(1)=uicontrol('Style','radiobutton',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','zeros',...
  'Units', 'Normalized',...
  'Position', [0.03 0.89 0.11 0.07],...
  'Value', 1,...
  'CallBack', 'ZerPol(''Zera0'')');
ZerPolRadio(2)=uicontrol('Style','radiobutton',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','poles',...
  'Units', 'Normalized',...
  'Position', [0.17 0.89 0.11 0.07],...  %   'Position', [0.03 0.79 0.15 0.07],...
  'Value', 0,...
  'CallBack', 'ZerPol(''Zera1'')');

uicontrol('Style','pushbutton ',...
  'String','z<->p',...
  'CallBack','ZerPol(''Zamien'');',...
  'Units', 'Normalized',...
  'Position', [0.09 0.775 0.12 0.1]);
uicontrol('Style','pushbutton ',...
  'String','-real(z)',...
  'CallBack','ZerPol(''ZamienReal'');',...
  'Units', 'Normalized',...
  'Position', [0.03 0.65 0.12 0.1]);
uicontrol('Style','pushbutton ',...
  'String','-imag(z)',...
  'CallBack','ZerPol(''ZamienImag'');',...
  'Units', 'Normalized',...
  'Position', [0.16 0.65 0.12 0.1]);
%   'Position', [0.03 0.375 0.11 0.11]);
uicontrol('Style','pushbutton ',...
  'String','1/conj(z)',...
  'CallBack','ZerPol(''ZamienMod'');',...
  'Units', 'Normalized',...
  'Position', [0.09 0.525 0.12 0.1]);
%   'Position', [0.03 0.475 0.12 0.11]);

uicontrol('Style','pushbutton ',...
  'String','+conj(z)',...
  'CallBack','ZerPol(''DodajSprzone_All'');',...
  'Units', 'Normalized',...
  'Position', [0.03 0.36 0.12 0.1]);
uicontrol('Style','pushbutton ',...
  'String','+conj(z_sel)',...
  'CallBack','ZerPol(''DodajSprzone_Selected'');',...
  'Units', 'Normalized',...
  'Position', [0.16 0.36 0.12 0.1]);

uicontrol('Style','pushbutton ',...
  'String','+1/conj(z)',...
  'CallBack','ZerPol(''DodajOdwrcone_All'');',...
  'Units', 'Normalized',...
  'Position', [0.03 0.24 0.12 0.1]);
uicontrol('Style','pushbutton ',...
  'String','+1/conj(z_sel)',...
  'CallBack','ZerPol(''DodajOdwrcone_Selected'');',...
  'Units', 'Normalized',...
  'Position', [0.16 0.24 0.12 0.1]);

% Ramka zaznaczania i usuwania punktw osobliwych
uicontrol('Style','frame',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','Ramka select',...
  'Units', 'Normalized',...
  'Position', [0.31 0.22 0.21 0.76]);

uicontrol('Style','text',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','Select:',...
  'Units', 'Normalized',...
  'Position', [0.32 0.90 0.09 0.07]);
ZerPol_select_mode=uicontrol('Style','popupmenu',...
    'BackgroundColor', [1.0 1.0 1.0],...
    'String',{'all', '|z| < 1', '|z| > 1'},...
    'Units', 'Normalized',...
    'Position', [0.41 0.87 0.10 0.10]);
uicontrol('Style','pushbutton ',...
  'String','z',...
  'CallBack','ZerPol(''SelectZ'');',...
  'Units', 'Normalized',...
  'Position', [0.32 0.77 0.05 0.11]);
uicontrol('Style','pushbutton',...
  'String','all',...
  'CallBack','ZerPol(''SelectAll'');',...
  'Units', 'Normalized',...
  'Position', [0.38 0.77 0.07 0.11]);
uicontrol('Style','pushbutton',...
  'String','p',...
  'CallBack','ZerPol(''SelectP'');',...
  'Units', 'Normalized',...
  'Position', [0.46 0.77 0.05 0.11]);
% \fixed 2005_09_29
uicontrol('Style','text',...
  'String','Z plane max range:',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'Units', 'Normalized',...
  'Position', [0.32 0.45 0.19 0.11]);
ZerPol_ZplaneRange = uicontrol('Style','popupmenu',...
  'String',str2mat('2.0', '5.0', '10.0', 'compressed'),...
  'CallBack','ZerPol(''SelectZplaneRange'');',...
  'Units', 'Normalized',...
  'Position', [0.32 0.35 0.19 0.11]);
% /fixed 2005_09_29


uicontrol('Style','pushbutton ',...
  'String','Delete',...
  'Units', 'Normalized',...
  'Position', [0.35 0.63 0.13 0.11],...
  'CallBack', 'ZerPol(''Delete'');');

uicontrol('Style','checkbox',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','zoom',...
  'CallBack','ZerPol(''Zoom'');',...
  'Value',0,...
  'Units', 'Normalized',...
  'Position', [0.32 0.24 0.075 0.09]);
ZerPolZoom=0;
  
ZerPolRadio(10)=uicontrol('Style','checkbox',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','keep conj',...
  'CallBack','',...
  'Value',1,...
  'Units', 'Normalized',...
  'Position', [0.40 0.24 0.11 0.09]);



h_Exit=uicontrol('Style','pushbutton ',...
  'String','Exit',...
  'Units', 'Normalized',...
  'Position', [0.86 0.045 0.12 0.13],...
  'CallBack', 'ZerPol;');
uicontrol('Style','pushbutton',...
  'String','Save',...
  'Units', 'Normalized',...
  'CallBack', 'global ZerPolZera ZerPolBieguny; ZerPol SaveZP(ZerPolZera(:,2), ZerPolBieguny(:,2));',...
  'Position', [0.20 0.045 0.12 0.13]);
uicontrol('Style','pushbutton',...
  'String','Design/Load',...
  'CallBack', 'global ZerPolLoad ZerPolTools; set(ZerPolTools, ''Visible'', ''off''); set(ZerPolLoad, ''Visible'', ''on'');',...
  'Units', 'Normalized',...
  'Position', [0.02 0.045 0.16 0.13]);

uicontrol('Style','frame',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','Ramka Dane',...
  'Units', 'Normalized',...
  'Position', [0.54 0.22 0.44 0.76]);

ZerPolRadio(5)=uicontrol('Style','text',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','magn.:',...
  'HorizontalAlignment', 'right',...
  'Units', 'Normalized',...
  'Position', [0.55 0.59 0.11 0.09]);
uicontrol('Style','pushbutton ',...
  'String','New zero',...
  'Units', 'Normalized',...
  'Position', [0.55 0.84 0.20 0.11],...
  'CallBack', 'ZerPol(''NoweZero'');');
uicontrol('Style','pushbutton ',...
  'String','New pole',...
  'Units', 'Normalized',...
  'Position', [0.77 0.84 0.20 0.11],...
  'CallBack', 'ZerPol(''NowyBiegun'');');

ZerPolRadio(11)=uicontrol('Style','edit',...
  'BackgroundColor', [1 1 1],...
  'String','0.0',...
  'Units', 'Normalized',...
  'Position', [0.67 0.59 0.30 0.1],...
  'Callback', 'ZerPol ZmienWart');
ZerPolRadio(6)=uicontrol('Style','text',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','phase:',...
  'HorizontalAlignment', 'right',...
  'Units', 'Normalized',...
  'Position', [0.55 0.46 0.11 0.09]);
ZerPolRadio(12)=uicontrol('Style','edit',...
  'BackgroundColor', [1 1 1],...
  'String','0.0',...
  'Units', 'Normalized',...
  'Position', [0.67 0.46 0.30 0.1],...
  'Callback', 'ZerPol ZmienWart');

ZerPolRadio(3)=uicontrol('Style','radiobutton',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','Cartesian',...
  'Units', 'Normalized',...
  'Position', [0.77 0.71 0.20 0.10],...
  'Value', 0,...
  'CallBack', 'ZerPol(''Polar0'')');
ZerPolRadio(4)=uicontrol('Style','radiobutton',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','polar',...
  'Units', 'Normalized',...
  'Position', [0.55 0.71 0.13 0.10],...
  'Value', 1,...
  'CallBack', 'ZerPol(''Polar1'')');


ZerPolRadio(13)=uicontrol('Style','text',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','K:',...
  'HorizontalAlignment', 'right', ...
  'Units', 'Normalized',...
  'Position', [0.55 0.3 0.05 0.10],...
  'Value', 1,...
  'CallBack', 'ZerPol(''Polar1'')');
ZerPolRadio(14)=uicontrol('Style','edit',...
  'BackgroundColor', [1 1 1],...
  'String', ZerPol_K,...
  'Units', 'Normalized',...
  'Position', [0.61 0.31 0.15 0.1],...
  'Enable', 'on', ...
  'Callback', 'ZerPol(''Licz'')');
ZerPolRadio(15)=uicontrol('Style','checkbox',...
  'BackgroundColor', [0.8 0.8 0.8],...
  'String','auto',...
  'Units', 'Normalized',...
  'Position', [0.77 0.3 0.10 0.10],...
  'Value', ZerPol_autoK,...
  'CallBack', 'ZerPol(''autoK'');');

h_=uicontrol('Style','pushbutton',...
  'String','3D view',...
  'CallBack','ZerPol(''3D_view'')',...
  'Units', 'Normalized',...
  'Position', [0.86 0.24 0.11 0.1]);
%   'Position', [0.03 0.24 0.12 0.1]);
%   'BackgroundColor', [0.8 0.8 0.8],...

set(h_Exit, 'units', 'Pixels');
poz_=get(h_Exit, 'Position');
set(h_Exit, 'units', 'Normalized');

A_ = GetImage(2);
h=uicontrol('style', 'pushbutton', 'CData', A_);
set(h, 'Units', 'Pixels', 'Position', [poz_(1)-3*(size(A_,1)+14), poz_(2)-4, size(A_,1)+10, size(A_,2)+10]);
set(h, 'units', 'Normalized', ...
  'TooltipString', 'Sound config', ...
  'Callback', 'ZerPol(''SoundConfig'');');
A_ = GetImage(0);
h=uicontrol('style', 'pushbutton', 'CData', A_);
set(h, 'Units', 'Pixels', 'Position', [poz_(1)-2*(size(A_,1)+14), poz_(2)-4, size(A_,1)+10, size(A_,2)+10]);
set(h, 'units', 'Normalized', ...
  'TooltipString', 'Play filtered sound', ...
  'Callback', 'ZerPol Show_SoundConfig([],''Play'');');

ZerPolTrybEdycji=1; 
return;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%function Wyj=ZPaxesT(Polecenie, Param1, Param2, Param3)
% Polecenie = {'Init', 'Rysuj'}
function Wyj=ZPaxesF(Polecenie, Param1, Param2, Param3)

Wyj(1,8)=0; %maksymalnie osiem handlerw (musiby identycznie = ZPaxesF)

if strcmp(Polecenie, 'Init')
 haxesGl=Param1; PozycjaAxes= Param2;

 %Rysujemy axes

 %axes dla plotw
 Wyj(1,1)=axes;
 x((1:34)*3-2)=0:33;
 x((1:34)*3-1)=0:33;
 x((1:34)*3)=nan*ones([1 34]);
 y((1:34)*3-2)=zeros([1 34]);
 y((1:34)*3-1)=zeros([1 34]);
 y((1:34)*3)=nan*ones([1 34]);
 Wyj(1,2)=plot(x,y);
 %set(Wyj(1,2), 'EraseMode', 'xor', 'Color', [0 1 1]);
 set(Wyj(1,2), 'Color', [0 1 1]);
 hold on;
 Wyj(1,3)=plot([0 33], [0 0]);
 %set(Wyj(1,3), 'EraseMode', 'xor', 'Color', [1 1 1]);
 set(Wyj(1,3), 'Color', [1 1 1]);
 set(Wyj(1,1), 'Position', PozycjaAxes, 'Visible', 'off', 'Units', 'normalized', 'XLim', [0 33], 'YLim', [-0.5 0.5]);

% set(Okno, 'CurrentAxes', haxesGl);
 Pozycja=[0 -0.5 33 1];
 %Box
 pom=line([Pozycja(1) Pozycja(1) Pozycja(1)+Pozycja(3) Pozycja(1)+Pozycja(3) Pozycja(1)],...
          [Pozycja(2) Pozycja(2)+Pozycja(4) Pozycja(2)+Pozycja(4) Pozycja(2) Pozycja(2)]);
 %set(pom, 'LineWidth', 1, 'EraseMode', 'none', 'Color', [0 0 0]);
 set(pom, 'LineWidth', 1, 'Color', [0 0 0]);

 if nargin==4
  %Dodajemy tytu wykresu
  pom=text(Pozycja(1)+Pozycja(3)/2, Pozycja(2)+Pozycja(4), Param3);
  set(pom,'HorizontalAlignment', 'Center', 'FontSize', 7,...
          'VerticalAlignment', 'bottom', 'Color', [0 0 1]);
 end
 
 %grid      
 Wyj(1,8)=plot([-0.1 -0.1], [-0.5 0.5]);
 set(Wyj(1,8), 'LineWidth', 0.5, 'LineStyle', '--', 'Color', [0.5 0.5 0.5]);

 %etykiety osi X
 Wyj(1,6)=uicontrol('Style', 'text', 'Position', [PozycjaAxes(1) PozycjaAxes(2)-0.03 0.1 0.03],...
                  'String', '-2', 'Units', 'normalized',...
                  'HorizontalAlignment', 'left', 'ForegroundColor', [0 0 0],...
                  'BackgroundColor', [1 1 1]);
 Wyj(1,7)=uicontrol('Style', 'text', 'Position', [PozycjaAxes(1)+PozycjaAxes(3)-0.1 PozycjaAxes(2)-.03 0.1 0.03],...
                  'String', '31', 'Units', 'normalized',...
                  'HorizontalAlignment', 'right', 'ForegroundColor', [0 0 0],...
                  'BackgroundColor', [1 1 1]);

 %etykiety osi Y
 Wyj(1,4)=uicontrol('Style', 'text', 'Position', [0 PozycjaAxes(2)+PozycjaAxes(4)-0.03 PozycjaAxes(1)-0.001 0.03],...
                  'String', '   1.0', 'Units', 'normalized',...
                  'HorizontalAlignment', 'left', 'ForegroundColor', [0 0 0],...
                  'BackgroundColor', [1 1 1]);
 Wyj(1,5)=uicontrol('Style', 'text', 'Position', [0 PozycjaAxes(2) PozycjaAxes(1)-0.001 0.03],...
                  'String', '  -1.0', 'Units', 'normalized',...
                  'HorizontalAlignment', 'left', 'ForegroundColor', [0 0 0],...
                  'BackgroundColor', [1 1 1]);
 return;
elseif strcmp(Polecenie, 'Rysuj')
 DaneX=Param1(1,1:34); Dane=Param1(2,1:34); handlery=Param2;
 Maks=max(abs(Dane));
 Rozp = 2*Maks;
 %Wyznaczenie wspczynnika zaokrglenia skali
 Wsp=10;
 while (Rozp/Wsp<10)
  Wsp=Wsp/10;
 end
 %teraz zaokrglamy
 if rem(Maks, Wsp)~=0
  if sign(Maks)==1
   Maks=Maks+Wsp-rem(Maks, Wsp);
  else
   Maks=Maks-rem(Maks, Wsp);
  end
 end
 %No to zmieniamy wartoci skali
 if strcmp(sprintf('%g',Maks),'NaN')
  Maks=0;
 end

 if rem(abs(Maks),1) > 0.0001
  set(handlery(4), 'String', sprintf('%g', Maks));
  set(handlery(5), 'String', sprintf('%g', -Maks));
 else
  set(handlery(4), 'String', sprintf('%1.1f', Maks));
  set(handlery(5), 'String', sprintf('%1.1f', -Maks));
 end
 set(handlery(6), 'String', sprintf('%i', DaneX(1)));
 set(handlery(7), 'String', sprintf('%i', DaneX(34)));
 set(handlery(8), 'XData', [-DaneX(1)-0.1 -DaneX(1)-0.1]);

 %Teraz trzeba unormowa Dane i je wykreli
 if Maks~=0
  Dane=Dane/(2*Maks);
 end
 LenX=length(DaneX);
 x(1:3:(3*LenX))=DaneX;
 x(2:3:(3*LenX+1))=DaneX;
 x(3:3:(3*LenX+2))=nan*ones(size(DaneX));
 y(1:3:(3*LenX))=zeros(size(Dane));
 y(2:3:(3*LenX+1))=Dane;
 y(3:3:(3*LenX+2))=nan*ones(size(Dane));
 set(handlery(2), 'YData', y);  %, 'XData', x);

 %na koniec trzeba uaktuali linie zera

 drawnow;
else
 disp('Nieprawidowy parametr polecenie');
end
return;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [new_positions, zmiana] = GetNewPositions(Korekta, keep_conjugate)

global ZerPolhAxes ZerPolWybrane ZerPolStart_Obiekt_ind

zmiana = 1;
if nargin == 1,
  keep_conjugate = 1;
end

if size(ZerPolWybrane,1) == 1,
  % przesuwamy jeden punkt jeeli jest w zakresie
  Zakres = [get(ZerPolhAxes, 'XLim'), get(ZerPolhAxes, 'YLim')];
  new_positions=[real(ZerPolWybrane(1,2)) imag(ZerPolWybrane(1,2))]-Korekta;
  if ~InBox(new_positions, Zakres) 
    new_positions(1,1:2)=[real(ZerPolWybrane(1,2)) imag(ZerPolWybrane(1,2))];
    zmiana = 0;
  end
else
  %No to teraz przesumy wybrane punkty osobliwe
  %jeli przesuwany punkt podstawowy jest w zakresie wsprzdnych
  Zakres = [get(ZerPolhAxes, 'XLim'), get(ZerPolhAxes, 'YLim')];

  StaraPozycja = [real(ZerPolWybrane(ZerPolStart_Obiekt_ind,2)), imag(ZerPolWybrane(ZerPolStart_Obiekt_ind,2))];
  if keep_conjugate == 1,
    imag_znak = imag(ZerPolWybrane(ZerPolStart_Obiekt_ind,2)) > 0;
  end
  new_positions(ZerPolStart_Obiekt_ind,1:2) = StaraPozycja-Korekta;
  if ~InBox(new_positions(ZerPolStart_Obiekt_ind,1:2), Zakres)
    new_positions(ZerPolStart_Obiekt_ind,1:2)=[real(ZerPolWybrane(ZerPolStart_Obiekt_ind,2)) imag(ZerPolWybrane(ZerPolStart_Obiekt_ind,2))];
    zmiana = 0;
  end

  z1_abs = abs(StaraPozycja(1)+j*StaraPozycja(2));
  if z1_abs < 100*eps,
    for ind_=1:size(ZerPolWybrane,1),
      new_positions(ind_,1:2)=[real(ZerPolWybrane(ind_,2)) imag(ZerPolWybrane(ind_,2))];
    end
    zmiana = 0;
    return
  end
  
  faza_real = sign(new_positions(ZerPolStart_Obiekt_ind,1)) * sign(StaraPozycja(1));
  faza_skala = (new_positions(ZerPolStart_Obiekt_ind,1)+j*new_positions(ZerPolStart_Obiekt_ind,2))/(StaraPozycja(1)+j*StaraPozycja(2));
  faza_skala = faza_skala/abs(faza_skala);
  alfa_z1_abs = abs(new_positions(ZerPolStart_Obiekt_ind,1)+j*new_positions(ZerPolStart_Obiekt_ind,2));
  if z1_abs > 1,
    z1_abs = 1/z1_abs;
    if alfa_z1_abs > 1,
      alfa_z1_abs = 1/alfa_z1_abs;
      reverse_start = 0;
    else
      reverse_start = 1;
    end
  else
    if alfa_z1_abs > 1,
      alfa_z1_abs = 1/alfa_z1_abs;
      reverse_start = 1;
    else
      reverse_start = 0;
    end
  end
  for ind_=1:size(ZerPolWybrane,1),
    if ind_ ~= ZerPolStart_Obiekt_ind,
      z2_abs = abs(ZerPolWybrane(ind_,2));
      
      if z2_abs > 100*eps,
        faza_=ZerPolWybrane(ind_,2)/z2_abs;
      
        faza_skala_ = faza_skala;
        if keep_conjugate == 1,
          if abs(imag(ZerPolWybrane(ind_,2))) < 100*eps,
            faza_skala_ = faza_real;
          else
            if imag_znak ~= (imag(ZerPolWybrane(ind_,2)) > 0),
              faza_skala_ = conj(faza_skala_);
            end
          end
        end
      
        if z2_abs > 1,
          z2_abs = 1/z2_abs;
          reverse_ = 1 - reverse_start;
        else
          reverse_ = reverse_start;
        end
        gamma_ = log(1-z2_abs)*log(1-alfa_z1_abs)/log(1-z1_abs);
        if reverse_ == 1,
          nowy_punkt_=(1/(1-exp(gamma_)))*faza_*faza_skala_;
        else
          nowy_punkt_=(1-exp(gamma_))*faza_*faza_skala_;
        end
        new_positions(ind_,1:2)=[real(nowy_punkt_) imag(nowy_punkt_)];
      else
        new_positions(ind_,1:2)=[real(ZerPolWybrane(ind_,2)) imag(ZerPolWybrane(ind_,2))];
      end
    end
  end
end
return


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function h_fig=Draw_Hz_3d(filter_K, z_zeros, z_poles, h_fig, H_AdB_offset, Max_Hz_AdB)

if nargin <= 1,
  filter_K = 1;
  z_zeros=[0, 1/2, 0.5+j];
  z_poles=[-1, 0.1+j];
  H_AdB_offset = 0;
%   Max_Hz_A = 1000;
%   Max_Hz_AdB = 20*log10(Max_Hz_A);
  Max_Hz_AdB = 60;
end
if nargin == 2,
%   z_zeros=[0, 1/2, 0.5+j];
  z_poles=[];
  H_AdB_offset = -ceil(20*log10(filter_K)/10)*10; %0;
%   Max_Hz_A = 1000;
%   Max_Hz_AdB = 20*log10(Max_Hz_A);
  Max_Hz_AdB = 60;
end
if nargin == 4,
  H_AdB_offset = -ceil(20*log10(filter_K)/10)*10; %0;
%   Max_Hz_A = 1000;
%   Max_Hz_AdB = 20*log10(Max_Hz_A);
  Max_Hz_AdB = 60;
end
if nargin == 5,
%   Max_Hz_A = 1000;
%   Max_Hz_AdB = 20*log10(Max_Hz_A);
  Max_Hz_AdB = 60;
end
if nargin  <= 3,
  h_fig=4;
else
  if isempty(h_fig),
    tmp_=findobj(0,'type', 'figure');
    if isempty(tmp_)
      h_fig = 1;
    else
      for ind=1:length(tmp_),
        tmp__(ind) = tmp_(ind).Number;
      end
      h_fig = ceil(max(tmp__))+1;
    end
  end
end
Max_Hz_AdB = abs(Max_Hz_AdB);
if Max_Hz_AdB < 1,
  Max_Hz_AdB = 1;
end

% h_fig
draw_all = 0;
% H_A_offset = 10.^(H_AdB_offset/20);

x=[-2:0.05:+2]; N=length(x);
y=[-2:0.05:+2].'; M=length(y);

x_ = ones(M,1) * x; % w wierszu (czyli drugi indeks)
y_ = y * ones(1,N); % w kolumnie (czyli pierwszy indeks)
% whos

z_s = [z_zeros(:); z_poles(:)];
r_z = 1; %abs(x_+j*y_ - z_s(1));
for ind_z_ = 1:length(z_s),
  r_z = r_z .* abs(x_+j*y_ - z_s(ind_z_));
end
% r_z=sqrt(r_z);
r_z=r_z.^(1/10);

if draw_all == 1,
  figure(1)
  mesh(x,y,r_z)
end
 
if length(z_s) > 0,
  for ind_x_ = 1:N,
    r_z_f(:,ind_x_)=(r_z(:,ind_x_)-min(r_z(:,ind_x_)))/(max(r_z(:,ind_x_))-min(r_z(:,ind_x_)));
  
    r_z_f(:,ind_x_)=cumsum(1-r_z_f(:,ind_x_));
    r_z_f(:,ind_x_)=(r_z_f(:,ind_x_))/(max(r_z_f(:,ind_x_)));

    r_tmp=[r_z_f(:,ind_x_); 1.1];
    for ind_y_ = 1:M,
      y_tmp=(y(ind_y_)-min(y))/(max(y)-min(y));
      ind__=find(r_tmp > y_tmp);
    
      if ind__(1) > M,
        ind__(1) = M;
      end
      if ind__(1) == 1,
        ind__(1) = 2;
      end
      y1 = y(ind__(1)-1);
      y2 = y(ind__(1));
      x1 = r_tmp(ind__(1)-1);
      x2 = r_tmp(ind__(1));
      a = (y1-y2)/(x1-x2);
      b = (y1+y2)/2 - 1/2*(x1+x2)*(y1-y2)/(x1-x2);
    
      y_f(ind_y_,ind_x_)=a*y_tmp+b;
  %     y_f2(ind_y_,ind_x_)=y(ind__(1));
    end
    y_f(end,ind_x_) = 2.0; % ??? could be done better but it works
  %   y_f(:,ind_x_)=r_z_f(:,ind_x_)*(max(y_(:,ind_x_))-min(y_(:,ind_x_)))+min(y_(:,ind_x_));
  end
else
  y_f = y_;
end

if draw_all == 1,
  figure(2)
  mesh(x,y,r_z_f)
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
y_=y_;
H_z = filter_K*ones(size(x_));
for ind_z_ = 1:length(z_zeros),
  H_z = H_z .* (x_+j*y_ - z_zeros(ind_z_));
end
for ind_z_ = 1:length(z_poles),
  H_z = H_z ./ (x_+j*y_ - z_poles(ind_z_));
end
Hz_A = abs(H_z);
Hz_AdB=20*log10(Hz_A);

% ind_ = find(Hz_A > (Max_Hz_A*H_A_offset));
% Hz_A(ind_) = Max_Hz_A*H_A_offset;
% ind_ = find(Hz_A < 1/Max_Hz_A*H_A_offset);
% Hz_A(ind_) = 1/Max_Hz_A*H_A_offset;
ind_ = find(Hz_AdB > (Max_Hz_AdB-H_AdB_offset));
Hz_AdB(ind_) = Max_Hz_AdB-H_AdB_offset;
ind_ = find(Hz_AdB < -Max_Hz_AdB-H_AdB_offset);
Hz_AdB(ind_) = -Max_Hz_AdB-H_AdB_offset;


if draw_all == 1,
  figure(3)
  subplot(1,2,1);
  % mesh(x_,y_f,r_z)
  mesh(x_,y_,Hz_AdB)
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
y_=y_f;
r_z = 1; %abs(x_+j*y_ - z_s(1));
for ind_z_ = 1:length(z_s),
  r_z = r_z .* abs(x_+j*y_ - z_s(ind_z_));
end
r_z=sqrt(r_z);

if length(z_s) > 0,
  for ind_y_ = 1:M,
    r_z_f(ind_y_,:)=(r_z(ind_y_,:)-min(r_z(ind_y_,:)))/(max(r_z(ind_y_,:))-min(r_z(ind_y_,:)));

    r_z_f(ind_y_,:)=cumsum(1-r_z_f(ind_y_,:));
    r_z_f(ind_y_,:)=(r_z_f(ind_y_,:))/(max(r_z_f(ind_y_,:)));

    r_tmp=[r_z_f(ind_y_,:), 1.1];
    for ind_x_ = 1:N,
      x_tmp=(x(ind_x_)-min(x))/(max(x)-min(x));
      ind__=find(r_tmp > x_tmp);
    
      if ind__(1) > N,
        ind__(1) = N;
      end
      if ind__(1) == 1,
        ind__(1) = 2;
      end
      y1 = x(ind__(1)-1);
      y2 = x(ind__(1));
      x1 = r_tmp(ind__(1)-1);
      x2 = r_tmp(ind__(1));
      if abs(x1-x2) < 100*eps,
        x_f(ind_y_,ind_x_)=x(ind__(1)-1);
      else
        a = (y1-y2)/(x1-x2);
        b = (y1+y2)/2 - 1/2*(x1+x2)*(y1-y2)/(x1-x2);
    
        x_f(ind_y_,ind_x_)=a*x_tmp+b;
      end
  %     y_f2(ind_y_,ind_x_)=y(ind__(1));
    end
  %   y_f(:,ind_x_)=r_z_f(:,ind_x_)*(max(y_(:,ind_x_))-min(y_(:,ind_x_)))+min(y_(:,ind_x_));
  end
else
  x_f = x_;
end

x_=x_f;
H_z = filter_K*ones(size(x_));
for ind_z_ = 1:length(z_zeros),
  H_z = H_z .* (x_+j*y_ - z_zeros(ind_z_));
end
for ind_z_ = 1:length(z_poles),
  H_z = H_z ./ (x_+j*y_ - z_poles(ind_z_));
end
Hz_A = abs(H_z);
% ind_ = find(Hz_A > Max_Hz_A*H_A_offset);
% Hz_A(ind_) = Max_Hz_A*H_A_offset;
% ind_ = find(Hz_A < 1/Max_Hz_A*H_A_offset);
% Hz_A(ind_) = 1/Max_Hz_A*H_A_offset;
Hz_AdB=20*log10(Hz_A);
ind_ = find(Hz_AdB > (Max_Hz_AdB-H_AdB_offset));
Hz_AdB(ind_) = Max_Hz_AdB-H_AdB_offset;
ind_ = find(Hz_AdB < -Max_Hz_AdB-H_AdB_offset);
Hz_AdB(ind_) = -Max_Hz_AdB-H_AdB_offset;

z_ = exp(j*linspace(0, 2*pi, 400));
H_z = filter_K*ones(size(z_));
for ind_z_ = 1:length(z_zeros),
  H_z = H_z .* (z_ - z_zeros(ind_z_));
end
for ind_z_ = 1:length(z_poles),
  H_z = H_z ./ (z_ - z_poles(ind_z_));
end
Hz1_A = abs(H_z); Hz1_AdB=20*log10(Hz1_A);
% % Hz1_A = abs(H_z); ind_ = find(Hz1_A > Max_Hz_A*H_A_offset); Hz1_A(ind_) = Max_Hz_A*H_A_offset;
% % ind_ = find(Hz1_A < 1/Max_Hz_A*H_A_offset); Hz1_A(ind_) = 1/Max_Hz_A*H_A_offset;
ind_ = find(Hz1_AdB > (Max_Hz_AdB-H_AdB_offset));
Hz1_AdB(ind_) = NaN; %Max_Hz_AdB-H_AdB_offset;
ind_ = find(Hz1_AdB < -Max_Hz_AdB-H_AdB_offset);
Hz1_AdB(ind_) = NaN; %-Max_Hz_AdB-H_AdB_offset;

z_x = linspace(-2.0, 2.0, 200);
H_z = filter_K*ones(size(z_x));
for ind_z_ = 1:length(z_zeros),
  H_z = H_z .* (z_x - z_zeros(ind_z_));
end
for ind_z_ = 1:length(z_poles),
  H_z = H_z ./ (z_x - z_poles(ind_z_));
end
Hz1_A = abs(H_z); 
% ind_ = find(Hz1_A > Max_Hz_A*H_A_offset); Hz1_A(ind_) = Max_Hz_A*H_A_offset;
% ind_ = find(Hz1_A < 1/Max_Hz_A*H_A_offset); Hz1_A(ind_) = 1/Max_Hz_A*H_A_offset;
Hzx_AdB=20*log10(Hz1_A);
ind_ = find(Hzx_AdB > (Max_Hz_AdB-H_AdB_offset));
Hzx_AdB(ind_) = Max_Hz_AdB-H_AdB_offset;
ind_ = find(Hz1_AdB < -Max_Hz_AdB-H_AdB_offset);
Hzx_AdB(ind_) = -Max_Hz_AdB-H_AdB_offset;

z_y = j*linspace(-2.0, 2.0, 200);
H_z = filter_K*ones(size(z_y));
for ind_z_ = 1:length(z_zeros),
  H_z = H_z .* (z_y - z_zeros(ind_z_));
end
for ind_z_ = 1:length(z_poles),
  H_z = H_z ./ (z_y - z_poles(ind_z_));
end
Hz1_A = abs(H_z); Hzy_AdB=20*log10(Hz1_A);
% ind_ = find(Hz1_A > Max_Hz_A*H_A_offset); Hz1_A(ind_) = Max_Hz_A*H_A_offset;
% ind_ = find(Hz1_A < 1/Max_Hz_A*H_A_offset); Hz1_A(ind_) = 1/Max_Hz_A*H_A_offset;
ind_ = find(Hzy_AdB > (Max_Hz_AdB-H_AdB_offset));
Hzy_AdB(ind_) = Max_Hz_AdB-H_AdB_offset;
ind_ = find(Hzy_AdB < -Max_Hz_AdB-H_AdB_offset);
Hzy_AdB(ind_) = -Max_Hz_AdB-H_AdB_offset;

% % figure(h_fig)
% get(h_fig,'tag')
h_tmp = findobj(0, 'tag', 'H_AdB_3D_figure_tag');
if any(h_tmp == h_fig),
  figure(h_fig);
  [az,el] = view;
else
  az = NaN;
end
figure(h_fig);
set(h_fig, 'Color', 'w'); set(h_fig, 'Renderer', 'OpenGL');
set(h_fig, 'NumberTitle', 'off',...
           'name', 'ZerPol - 3D view', ...
           'tag', 'H_AdB_3D_figure_tag');
subplot(1,1,1);
% % mesh(x_,y_f,r_z)
% % mesh(x_,y_,Hz_AdB)
% surfc(x_,y_,Hz_AdB)
surf(x_,y_,Hz_AdB)
shading interp
hold on
% whos
[C_, h_]=contour3(x_,y_,Hz_AdB, linspace(-Max_Hz_AdB-H_AdB_offset,Max_Hz_AdB-H_AdB_offset,21));
for i = 1:length(h_);
%   newz = get(h_(i),'Zdata') - 20*log10(Max_Hz_A);
  newz = 0*get(h_(i),'Zdata') - Max_Hz_AdB -H_AdB_offset;
  set(h_(i),'Zdata',newz)
end

plot3(real(z_), imag(z_), Hz1_AdB, 'color', 'm', 'linewidth', 2)
plot3(real(z_x), imag(z_x), Hzx_AdB, 'color', 'k', 'LineStyle', '--', 'linewidth', 1)
plot3(real(z_y), imag(z_y), Hzy_AdB, 'color', 'k', 'LineStyle', '--',  'linewidth', 1)

plot3([0, 0], [-2.1, +2.1], [0, 0], 'color', 'k', 'linewidth', 2)
plot3([-2.1, +2.1], [0, 0], [0, 0], 'color', 'k', 'linewidth', 2)
plot3([0, 0], [0, 0], [-1.05, +1.05]*Max_Hz_AdB-H_AdB_offset, 'color', 'k', 'linewidth', 2)

plot3(real(z_), imag(z_), -Max_Hz_AdB*ones(size(z_))-H_AdB_offset, 'color', 'm', 'LineStyle', '--',  'linewidth', 1)
hold off
% shading flat
axis square
pom = get(gca, 'Position');
pom(1) = pom(1)/2; set(gca, 'Position', pom);

set(gca,'Xlim', [-2, 2], 'Ylim', [-2, 2], 'Zlim', [-1, +1]*Max_Hz_AdB-H_AdB_offset);
set(gca, 'Clim', [-1, +1]*Max_Hz_AdB-H_AdB_offset);
% zoom on
% set(h_fig, 'MenuBar', 'none');
set(h_fig, 'Units', 'normalized');
set(h_fig, 'Position', [0.025, 0.035, 0.95, 0.85]);
xlabel('real(\it{z})');
ylabel('imag(\it{z})');
zlabel('|H_{dB}(\it{z})|');

h_tmp = findobj(h_fig, 'tag', 'H_AdB_offset_tag');
if ~isempty(h_tmp) > 0,
  delete(h_tmp);
end
uicontrol('Style','frame',...
    'BackgroundColor', [0.9 0.9 0.9],...
    'String','H_AdB_offset',...
    'Units', 'Normalized',...
    'Position', [0.88 0.81 0.11 0.18], ... 
    'tag', 'H_AdB_offset_tag');
uicontrol('Style','text',...
    'BackgroundColor', [0.9 0.9 0.9],...
    'String','|H(z)| offset [dB]:',...
    'HorizontalAlignment', 'left',...
    'Units', 'Normalized',...
    'Position', [0.885 0.96 0.10 0.025], ... 
    'tag', 'H_AdB_offset_tag');
uicontrol('Style','edit',...
    'BackgroundColor', [1 1 1],...
    'String', H_AdB_offset,...
    'HorizontalAlignment', 'center',...
    'Units', 'Normalized',...
    'Position', [0.885 0.925 0.10 0.03], ... 
    'tag', 'H_AdB_offset_tag', ...
    'UserData', 'H_AdB_offset_edit');

uicontrol('Style','text',...
    'BackgroundColor', [0.9 0.9 0.9],...
    'String','|H(z)| +/- range [dB]:',...
    'HorizontalAlignment', 'left',...
    'Units', 'Normalized',...
    'Position', [0.885 0.9 0.10 0.025], ... 
    'tag', 'H_AdB_offset_tag');
uicontrol('Style','edit',...
    'BackgroundColor', [1 1 1],...
    'String', Max_Hz_AdB,...
    'HorizontalAlignment', 'center',...
    'Units', 'Normalized',...
    'Position', [0.885 0.865 0.10 0.03], ... 
    'tag', 'H_AdB_offset_tag', ...
    'UserData', 'H_AdB_range_edit');
  
uicontrol('Style','pushbutton',...
    'BackgroundColor', [0.8, 0.8, 0.8],...
    'String','Redraw',...
    'Units', 'Normalized',...
    'Position', [0.9 0.815 0.07 0.04], ... 
    'Callback', sprintf('ZerPol(''3D_view'', [findobj(%.15g,''UserData'', ''H_AdB_offset_edit''), findobj(%.15g,''UserData'', ''H_AdB_range_edit'')])', h_fig, h_fig), ...
    'tag', 'H_AdB_offset_tag');

if isfinite(az),
  view([az,el]);
end
rotate3d on;

set(h_fig,'Units', 'normalized', 'outerposition', [0,0,1,1]);
set(h_fig, 'Visible', 'on');
return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ZerPol_Show_SoundConfig_fig = Show_SoundConfig(handle, akcja)

global ZerPol_Show_SoundConfig_fig ZerPol_SoundConfig ZerPolVer;

if nargin == 0,
%   if isempty(ZerPol_SoundConfig),
%   	ZerPol_SoundConfig.Fs=8000;
%   	ZerPol_SoundConfig.T=2;
%   	ZerPol_SoundConfig.dF=0;
%     ZerPol_SoundConfig.play_real_part = 1;
%   end
  
  is_new = 0;
  tmp_=findobj(0,'type', 'figure');
  if isempty(tmp_)
    ZerPol_Show_SoundConfig_fig = 1;
    is_new = 1;
  else
    for ind=1:length(tmp_),
      tmp__(ind) = tmp_(ind).Number;
    end
    tmp_ = tmp__;

  	if isempty(ZerPol_Show_SoundConfig_fig),
      ZerPol_Show_SoundConfig_fig = ceil(max(tmp_))+1;
      is_new = 1;
    else
      if all(ZerPol_Show_SoundConfig_fig ~= tmp_)
        ZerPol_Show_SoundConfig_fig = ceil(max(tmp_))+1;
        is_new = 1;
      end
    end
	end
	
	h_fig_tmp = figure(ZerPol_Show_SoundConfig_fig);
  set(h_fig_tmp, 'UserData', ZerPolVer);
  if is_new == 1,
  	set(ZerPol_Show_SoundConfig_fig, 'Units', 'Normalized');
  	set(ZerPol_Show_SoundConfig_fig, 'Position', [1/4, 3/10, 1/2, 2/5], ...
        'menu', 'none', ...
        'NumberTitle', 'off', ...
        'Name', 'ZerPol sound config', ...
        'Color', [0.95, 0.95, 0.95]);
	
  	ZerPol_SoundConfig.edit_signal = uicontrol('Style','edit',...
        'BackgroundColor', [1 1 1],...
        'String', ZerPol_SoundConfig.signal_string,...
        'HorizontalAlignment', 'left',...
        'Units', 'Normalized',...
        'Position', [0.01 0.02 0.50 0.96], ... 
        'Max', 2, ...
        'tag', 'SoundConfig_tag');
  	uicontrol('Style','text',...
        'BackgroundColor', [0.9 0.9 0.9],...
        'String', ZerPol_SoundConfig.signal_info_string,...
        'HorizontalAlignment', 'left',...
        'Units', 'Normalized',...
        'Position', [0.52 0.32 0.47 0.66], ... 
        'Max', 2, ...
        'tag', 'SoundConfig_tag');
	
  	uicontrol('Style','text',...
        'BackgroundColor', [0.95 0.95 0.95],...
        'String','Fs [Sa/s]:',...
        'HorizontalAlignment', 'right',...
        'Units', 'Normalized',...
        'Position', [0.52 0.245 0.10 0.05], ... 
        'tag', 'SoundConfig_tag');
  	ZerPol_SoundConfig.edit_Fs = uicontrol('Style','edit',...
        'BackgroundColor', [1 1 1],...
        'String', ZerPol_SoundConfig.Fs,...
        'HorizontalAlignment', 'left',...
        'Units', 'Normalized',...
        'Position', [0.63 0.24 0.15 0.06], ... 
        'tag', 'SoundConfig_tag');
  	uicontrol('Style','text',...
        'BackgroundColor', [0.95 0.95 0.95],...
        'String','T [s]:',...
        'HorizontalAlignment', 'right',...
        'Units', 'Normalized',...
        'Position', [0.78 0.245 0.05 0.05], ... 
        'tag', 'SoundConfig_tag');
  	ZerPol_SoundConfig.edit_T = uicontrol('Style','edit',...
        'BackgroundColor', [1 1 1],...
        'String', ZerPol_SoundConfig.T,...
        'HorizontalAlignment', 'left',...
        'Units', 'Normalized',...
        'Position', [0.84 0.24 0.15 0.06], ... 
        'tag', 'SoundConfig_tag');
	
  	uicontrol('Style','text',...
        'BackgroundColor', [0.95 0.95 0.95],...
        'String','dF [Hz]:',...
        'HorizontalAlignment', 'right',...
        'Units', 'Normalized',...
        'Position', [0.52 0.175 0.10 0.05], ... 
        'tag', 'SoundConfig_tag');
  	ZerPol_SoundConfig.edit_dF = uicontrol('Style','edit',...
        'BackgroundColor', [1 1 1],...
        'String', ZerPol_SoundConfig.dF,...
        'HorizontalAlignment', 'left',...
        'Units', 'Normalized',...
        'Position', [0.63 0.17 0.15 0.06], ... 
        'tag', 'SoundConfig_tag');
    ZerPol_SoundConfig.h_radio_real = uicontrol('Style','radiobutton',...
        'BackgroundColor', [0.95 0.95 0.95],...
        'String','real',...
        'Units', 'Normalized',...
        'Position', [0.55 0.10 0.1 0.05],...
        'Value', ZerPol_SoundConfig.play_real_part,...
        'TooltipString', 'Play only real part', ...
        'tag', 'SoundConfig_tag', ...
        'Callback', 'ZerPol tmp=Show_SoundConfig(gcbo,''radio'');');
    ZerPol_SoundConfig.h_radio_imag = 	uicontrol('Style','radiobutton',...
        'BackgroundColor', [0.95 0.95 0.95],...
        'String','imag',...
        'Units', 'Normalized',...
        'Position', [0.68 0.10 0.1 0.05],...
        'Value', ZerPol_SoundConfig.play_imag_part,...
        'TooltipString', 'Play only imaginary part', ...
        'tag', 'SoundConfig_tag', ...
        'Callback', 'ZerPol tmp=Show_SoundConfig(gcbo,''radio'');');
    ZerPol_SoundConfig.h_radio_stereo = 	uicontrol('Style','radiobutton',...
        'BackgroundColor', [0.95 0.95 0.95],...
        'String','stereo',...
        'Units', 'Normalized',...
        'Position', [0.81 0.10 0.1 0.05],...
        'Value', ZerPol_SoundConfig.play_stereo,...
        'TooltipString', 'Stereo playback: left ch. - real part, right ch. - imaginary part', ...
        'tag', 'SoundConfig_tag', ...
        'Callback', 'ZerPol tmp=Show_SoundConfig(gcbo,''radio'');');
    ZerPol_SoundConfig.h_auto_scale = 	uicontrol('Style','checkbox',...
        'BackgroundColor', [0.95 0.95 0.95],...
        'String','auto scale',...
        'Units', 'Normalized',...
        'Position', [0.55 0.03 0.15 0.05],...
        'Value', ZerPol_SoundConfig.auto_scale,...
        'TooltipString', 'If checked signal is automaticaly scaled to best fit dynamic range of D/A converter', ...
        'tag', 'SoundConfig_tag', ...
        'Callback', 'ZerPol tmp=Show_SoundConfig(gcbo,''auto_scale'');');
	
  	uicontrol('Style','pushbutton',...
        'BackgroundColor', [0.9, 0.9, 0.9],...
        'String','OK',...
        'Units', 'Normalized',...
        'Position', [0.92 0.02 0.07 0.06], ... 
        'Callback', 'ZerPol tmp=Show_SoundConfig(gcbo,''OK'');', ...
        'tag', 'SoundConfig_tag');
%         'Callback', sprintf('close(%.15g);', ZerPol_Show_SoundConfig_fig), ...
  else
    set(ZerPol_SoundConfig.h_radio_real, 'Value', ZerPol_SoundConfig.play_real_part);
    set(ZerPol_SoundConfig.h_radio_imag, 'Value', ZerPol_SoundConfig.play_imag_part);
    set(ZerPol_SoundConfig.h_radio_stereo, 'Value', ZerPol_SoundConfig.play_stereo);
  
    set(ZerPol_SoundConfig.edit_Fs, 'String', ZerPol_SoundConfig.Fs);
    set(ZerPol_SoundConfig.edit_T, 'String', ZerPol_SoundConfig.T);
    set(ZerPol_SoundConfig.edit_dF, 'String', ZerPol_SoundConfig.dF);

    set(ZerPol_SoundConfig.edit_signal, 'String', ZerPol_SoundConfig.signal_string);
  end
  
else
  if strcmp(akcja, 'radio')
    switch handle,
      case ZerPol_SoundConfig.h_radio_real,
        set(ZerPol_SoundConfig.h_radio_real, 'Value', 1);
        set(ZerPol_SoundConfig.h_radio_imag, 'Value', 0);
        set(ZerPol_SoundConfig.h_radio_stereo, 'Value', 0);
      case ZerPol_SoundConfig.h_radio_imag,
        set(ZerPol_SoundConfig.h_radio_real, 'Value', 0);
        set(ZerPol_SoundConfig.h_radio_imag, 'Value', 1);
        set(ZerPol_SoundConfig.h_radio_stereo, 'Value', 0);
      case ZerPol_SoundConfig.h_radio_stereo,
        set(ZerPol_SoundConfig.h_radio_real, 'Value', 0);
        set(ZerPol_SoundConfig.h_radio_imag, 'Value', 0);
        set(ZerPol_SoundConfig.h_radio_stereo, 'Value', 1);
    end
    return;
    
  elseif strcmp(akcja, 'auto_scale')
    % nothing to do ???
    
  elseif strcmp(akcja, 'OK')
    ZerPol_SoundConfig.play_real_part = get(ZerPol_SoundConfig.h_radio_real, 'Value');
    ZerPol_SoundConfig.play_imag_part = get(ZerPol_SoundConfig.h_radio_imag, 'Value');
    ZerPol_SoundConfig.play_stereo = get(ZerPol_SoundConfig.h_radio_stereo, 'Value');
    ZerPol_SoundConfig.auto_scale = get(ZerPol_SoundConfig.h_auto_scale, 'Value');
    ZerPol_SoundConfig.Fs = evalin('caller', get(ZerPol_SoundConfig.edit_Fs, 'String'), 'ZerPol_SoundConfig.Fs');
    ZerPol_SoundConfig.T  = evalin('caller', get(ZerPol_SoundConfig.edit_T, 'String'), 'ZerPol_SoundConfig.T');
    ZerPol_SoundConfig.dF = evalin('caller', get(ZerPol_SoundConfig.edit_dF, 'String'), 'ZerPol_SoundConfig.dF');
    
    ZerPol_SoundConfig.signal_string = get(ZerPol_SoundConfig.edit_signal, 'String');
    
    close(ZerPol_Show_SoundConfig_fig);
    ZerPol_Show_SoundConfig_fig = [];
    
%     Show_SoundConfig([], 'Play');
  elseif strcmp(akcja, 'Play')
    Fs = ZerPol_SoundConfig.Fs;
    N=ceil(ZerPol_SoundConfig.T*Fs);
    n = 0:N-1;
    
    signal_string = ZerPol_SoundConfig.signal_string.';
    signal_string = signal_string(:).';

    ind_ = find(signal_string == 10);
    signal_string(ind_)=[];
    ind_ = find(signal_string == 13);
    signal_string(ind_)=[];
%     signal=evalin('caller', [ZerPol_SoundConfig.signal_string, ';'], [ZerPol_SoundConfig.signal_string, ';']);
% %     signal=evalin('base', [ZerPol_SoundConfig.signal_string, ';'], [ZerPol_SoundConfig.signal_string, ';']);
% %     signal=evalin('caller', [ZerPol_SoundConfig.signal_string, ';'], 'zeros(size(n));');
    signal=eval([signal_string, ';'], 'zeros(size(n));');

    signal=signal(:).*exp(j*2*pi*ZerPol_SoundConfig.dF/Fs*n(:));

    global ZerPol_K ZerPolZera ZerPolBieguny;
    if size(ZerPolZera,1)
      HL = ZerPol_K*poly(ZerPolZera(:,2)); %Licznik transmitancji
    else
      HL = ZerPol_K;
    end
    if size(ZerPolBieguny,1)
      HM = poly(ZerPolBieguny(:,2)); %Mianownik transmitancji
    else
      HM = 1;
    end
%     figure
%     subplot(2,1,1)
%     plot(signal)

    signal = filter(HL, HM, signal);
    Value = ZerPol_SoundConfig.play_real_part + ...
          2*ZerPol_SoundConfig.play_imag_part + ...
          4*ZerPol_SoundConfig.play_stereo;
    switch Value,
      case 1,
        signal = real(signal);
      case 2,
        signal = imag(signal);
      case 4,
        signal = [real(signal(:)), imag(signal(:))];
    end

    if ZerPol_SoundConfig.auto_scale == 1,
      signal = signal/max(signal(:));
    end
%     subplot(2,1,2)
%     plot(signal)
    
%     signal(1:10)
    %sound(signal, Fs, 16);
    tmp_h = gcf;
    tmp = get(tmp_h,'Pointer');
    set(tmp_h,'Pointer', 'watch');
    pause(0);
    if max(abs(signal(:))) > 1,
      warning('D/A converter is overloaded !!!');
    end
%     wavplay(signal, Fs, 'sync');
    sound(signal, Fs);
    set(tmp_h,'Pointer', tmp);
    pause(0);
    
  else
  end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function y=delta(n)

y=sinc(n);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function A=GetImage(ind)

switch ind
  case 0, % sound
  	x =[ ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  2,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  2,  2,  1,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  1,  1,  2,  2,  1,  1,  1,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  1,  2,  2,  1,  1,  0,  0,  1,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
       0,  0,  0,  0,  0,  1,  2,  1,  1,  0,  0,  0,  0,  1,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
       0,  0,  0,  0,  0,  1,  2,  1,  0,  0,  0,  0,  0,  1,  2,  1,  0,  0,  0,  0,  0,  2,  2,  2,  2,  2,  2,  2,  2,  0,  0,  0; ...
       0,  0,  0,  0,  0,  1,  2,  1,  0,  0,  0,  0,  0,  1,  2,  1,  0,  0,  0,  0,  2,  2,  1,  0,  1,  0,  1,  0,  2,  2,  0,  0; ...
       0,  0,  0,  0,  0,  1,  2,  1,  0,  0,  0,  1,  1,  1,  2,  1,  0,  0,  0,  2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  0; ...
       0,  0,  0,  0,  0,  1,  2,  1,  0,  0,  1,  2,  2,  2,  2,  1,  0,  0,  0,  2,  1,  1,  1,  2,  2,  2,  2,  1,  1,  0,  2,  0; ...
       0,  0,  0,  0,  0,  1,  2,  1,  0,  1,  2,  1,  1,  3,  2,  1,  0,  0,  2,  2,  1,  1,  2,  2,  2,  2,  2,  2,  1,  1,  2,  0; ...
       0,  0,  0,  0,  0,  1,  2,  1,  0,  1,  2,  1,  3,  3,  2,  1,  0,  0,  2,  0,  1,  2,  2,  0,  4,  4,  2,  2,  0,  1,  0,  0; ...
       0,  0,  0,  0,  0,  1,  2,  1,  0,  1,  2,  3,  3,  3,  2,  1,  0,  0,  2,  0,  1,  2,  0,  1,  0,  4,  2,  2,  0,  0,  0,  0; ...
       0,  0,  0,  1,  1,  1,  2,  1,  0,  0,  1,  2,  2,  2,  1,  0,  0,  0,  2,  0,  1,  2,  1,  1,  1,  0,  2,  2,  0,  0,  0,  0; ...
       0,  0,  1,  2,  2,  2,  2,  1,  0,  0,  0,  1,  1,  1,  0,  0,  0,  0,  2,  0,  1,  1,  1,  2,  2,  2,  2,  0,  0,  0,  0,  0; ...
       0,  1,  2,  1,  1,  3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  0,  1,  1,  2,  0,  1,  1,  1,  0,  0,  0,  0,  0; ...
       0,  1,  2,  1,  3,  3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  0,  1,  1,  2,  0,  1,  1,  1,  0,  0,  0,  0,  0; ...
       0,  1,  2,  3,  3,  3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  0,  1,  1,  2,  4,  0,  1,  1,  0,  0,  0,  0,  0; ...
       0,  0,  1,  2,  2,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  4,  0,  1,  1,  2,  4,  0,  0,  4,  0,  0,  0,  0; ...
       0,  0,  0,  1,  1,  1,  0,  0,  0,  0,  2,  2,  2,  2,  2,  2,  2,  0,  0,  2,  4,  0,  1,  1,  2,  4,  4,  2,  2,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  0,  2,  2,  4,  0,  1,  1,  2,  2,  2,  1,  1,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  2,  4,  0,  1,  1,  1,  1,  1,  1,  0,  0; ...
       0,  0,  0,  0,  0,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  0,  0,  0,  0,  0,  2,  2,  4,  0,  1,  1,  1,  1,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,  0,  2,  2,  4,  0,  0,  0,  0,  4,  2,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  2,  4,  4,  4,  4,  2,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  0,  0,  0,  2,  2,  2,  2,  2,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0];
  	map=[ 0.900, 0.900, 0.900; ...
       1.000, 1.000, 1.000; ...
       0.000, 0.000, 0.000; ...
       0.000, 0.000, 1.000; ...
       0.502, 0.502, 0.502; ...
       0.000, 0.000, 0.000; ...
       0.000, 0.000, 0.000; ...
       0.000, 0.000, 0.000];
  case 1, % sound1
    x = [...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  1,  0,  0,  0,  0; ...
      0,  0,  0,  3,  4,  4,  5,  5,  5,  4,  4,  4,  4,  4,  5,  5,  4,  4,  5,  4,  4,  4,  4,  4,  4,  5,  5,  6,  0,  0,  0,  0; ...
      0,  0,  0,  3,  5,  7,  6,  3,  3,  3,  3,  3,  3,  5,  5,  5,  4,  5,  5,  5,  3,  5,  3,  3,  8,  8,  9,  7,  0,  0,  0,  0; ...
      0,  0,  0, 10,  5, 11, 12,  3,  3,  3,  5,  4, 13, 13, 13, 13, 13, 13, 13,  4,  5,  3,  5,  3, 11,  7,  9,  7,  0,  0,  0,  0; ...
      0,  0,  0,  3,  5,  9,  3,  5,  3,  5, 13, 13, 10, 14,  1,  1,  1, 14, 10, 13, 13,  4,  5,  3,  9,  9,  9,  7,  0,  0,  0,  0; ...
      0,  0,  0,  9,  5,  5,  5,  3,  4, 13, 10, 15,  1, 14, 14, 14, 14, 14, 14,  1, 10, 13,  4,  3,  3,  3,  9,  7,  0,  0,  0,  0; ...
      0,  0,  0,  3,  5,  3,  3,  4,  4,  1,  1, 14,  1, 15,  7,  7,  7, 15,  1, 10,  1, 14, 13,  4,  3,  3,  9,  7,  0,  0,  0,  0; ...
      0,  0,  0,  3,  5,  3,  5, 13, 14,  1, 14, 15, 12, 11, 11, 11, 11, 11, 12, 15, 14,  1, 14, 13,  5,  3,  9,  7,  0,  0,  0,  0; ...
      0,  0,  0,  9,  3,  9, 13,  2,  6, 14, 15, 12, 11, 11, 12, 11, 11, 11, 11, 11,  7, 14,  1, 16, 13,  3,  9,  7,  0,  0,  0,  0; ...
      0,  0,  0,  9,  3,  3, 13,  1,  1,  6, 12, 12, 12, 12, 11, 11, 11, 11, 11, 11, 12, 15, 14,  1, 13,  5,  8,  7,  0,  0,  0,  0; ...
      0,  0,  0,  9,  3,  2, 16, 15, 14, 15,  7,  7, 12, 11, 15,  2,  1, 12, 11, 11, 12, 15, 14,  1,  4,  4,  8,  7,  0,  0,  0,  0; ...
      0,  0,  0,  9,  3,  4,  2, 15, 14, 15, 15,  6, 15, 15, 14,  2,  2,  1, 11, 11, 12,  7,  1,  1,  2, 13,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  9,  9,  4, 14,  1, 14,  1, 14, 10, 15, 12, 15,  1,  1,  1, 12, 12, 15, 15,  1,  1,  2, 13,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  6,  9,  4, 14,  1, 14,  1, 10, 16,  1, 11, 12, 12, 15, 15, 12, 15, 15, 15,  1,  1, 10, 13,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  6,  9, 16, 10,  6, 10,  1, 10, 16, 16, 12, 11, 11, 11, 11, 15, 14, 14,  1, 14,  1,  2, 13,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  6,  9, 10,  2, 15,  2, 14, 10, 16, 13,  2, 12, 11, 11,  1,  2,  2, 10, 14, 14, 15, 16,  4,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  6,  9,  9,  4, 15, 14,  2, 14, 16, 16, 13, 13, 16,  4, 13, 16, 16,  2, 10, 14, 15, 13, 10,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  6,  9,  8,  4, 10, 15, 16, 14, 10, 16, 16, 13, 13, 13, 13, 16, 16,  2,  2, 15, 10, 13,  9,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  6,  9,  8, 10, 13, 15,  1, 16, 10, 10,  2, 16, 13, 13, 16,  2,  2,  2,  1,  6, 13, 10,  9,  8, 11,  0,  0,  0,  0; ...
      0,  0,  0,  6,  9,  8,  8,  2, 16, 15,  1,  2,  2, 10, 10,  2,  2,  2,  2,  2,  1, 15,  4,  4,  9,  9,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  6,  9,  8,  8,  9,  2,  4, 15, 15, 14, 16, 16, 16, 16,  2, 14, 15,  6,  4,  4,  3,  9,  9,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  6,  9,  8,  9,  8,  6,  2, 13,  2, 15, 15,  6,  1, 15, 15,  1,  2, 13,  4,  3,  3,  3,  3,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  6,  6, 12,  7,  9,  8,  8, 10,  4, 13,  4,  2,  2, 16,  4, 13, 13, 10,  9,  9,  9,  7,  6,  6, 12,  0,  0,  0,  0; ...
      0,  0,  0,  6,  9, 11, 11,  9,  9,  8,  8,  9, 10,  2,  4,  4,  4,  2, 10,  9,  9,  9,  9,  6, 11,  7,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  9,  9,  7,  7,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, 12,  0,  0,  0,  0; ...
      0,  0,  0,  7, 12, 11, 11, 11, 11, 11, 11, 11, 11, 11, 12, 12, 11, 12, 12, 12, 12, 12, 12, 12,  7, 12, 12, 11,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0];
  map =[0.900, 0.900, 0.900; ...
      0.361, 0.369, 0.345; ...
      0.635, 0.663, 0.671; ...
      0.741, 0.455, 0.212; ...
      0.894, 0.843, 0.773; ...
      0.875, 0.667, 0.459; ...
      0.396, 0.286, 0.180; ...
      0.184, 0.094, 0.031; ...
      0.455, 0.212, 0.047; ...
      0.573, 0.337, 0.153; ...
      0.620, 0.569, 0.502; ...
      0.024, 0.024, 0.004; ...
      0.078, 0.047, 0.024; ...
      0.906, 0.945, 0.973; ...
      0.443, 0.478, 0.482; ...
      0.208, 0.220, 0.176; ...
      0.678, 0.733, 0.788; ...
      0.000, 0.000, 0.000];
  case 2, % panel
      x = [ ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2; ...
      0,  2,  2,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2; ...
      2,  3,  3,  3,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  1,  1,  4,  4,  1,  1,  4,  4,  4,  1,  1,  1,  4,  4,  1,  2; ...
      2,  3,  3,  1,  3,  4,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  1,  1,  4,  1,  1,  4,  5,  5,  5,  4,  1,  1,  4,  1,  1,  2; ...
      2,  3,  1,  1,  1,  3,  2,  0,  0,  0,  0,  0,  0,  0,  1,  3,  1,  1,  4,  4,  1,  1,  4,  4,  4,  1,  1,  1,  4,  4,  1,  2; ...
      0,  4,  2,  1,  1,  1,  4,  2,  2,  2,  0,  0,  0,  0,  1,  3,  1,  1,  4,  1,  1,  1,  1,  4,  1,  1,  1,  1,  4,  1,  1,  2; ...
      0,  0,  4,  2,  1,  1,  3,  4,  3,  3,  4,  0,  0,  0,  1,  3,  1,  4,  4,  4,  1,  1,  1,  4,  4,  1,  1,  1,  4,  4,  1,  2; ...
      0,  0,  0,  4,  4,  2,  1,  3,  4,  1,  3,  4,  0,  0,  1,  3,  4,  5,  5,  5,  4,  1,  1,  4,  1,  1,  1,  1,  4,  1,  1,  2; ...
      0,  0,  0,  0,  2,  4,  2,  1,  3,  4,  1,  4,  2,  0,  1,  3,  1,  4,  4,  4,  1,  1,  1,  4,  4,  1,  1,  4,  4,  4,  1,  2; ...
      0,  0,  0,  0,  2,  3,  4,  2,  1,  4,  1,  4,  2,  0,  1,  3,  1,  1,  4,  1,  1,  1,  1,  4,  1,  1,  4,  5,  5,  5,  4,  2; ...
      0,  0,  0,  0,  2,  3,  1,  4,  4,  1,  1,  4,  2,  0,  1,  3,  1,  1,  4,  4,  1,  1,  1,  4,  4,  1,  1,  4,  4,  4,  1,  2; ...
      0,  0,  0,  0,  0,  2,  1,  1,  1,  1,  4,  2,  2,  0,  1,  3,  1,  1,  4,  1,  1,  1,  1,  4,  1,  1,  1,  1,  4,  1,  1,  2; ...
      0,  0,  0,  0,  0,  0,  2,  4,  4,  4,  2,  2,  0,  0,  1,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2; ...
      0,  0,  0,  0,  0,  0,  0,  2,  2,  2,  2,  0,  0,  0,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  2,  2,  2,  2,  0,  0,  0,  0,  0,  0,  2,  2,  2,  2,  0,  0,  0,  0,  0,  2,  2,  2,  2,  0,  0,  0; ...
      0,  0,  0,  0,  0,  2,  3,  3,  3,  3,  4,  0,  0,  0,  0,  2,  1,  1,  1,  1,  2,  0,  0,  0,  2,  1,  1,  1,  1,  4,  0,  0; ...
      0,  0,  0,  0,  2,  3,  1,  4,  4,  1,  3,  4,  0,  0,  2,  1,  3,  2,  2,  1,  2,  4,  0,  2,  1,  3,  2,  2,  1,  2,  4,  0; ...
      0,  0,  0,  0,  2,  3,  2,  3,  1,  4,  1,  4,  2,  0,  2,  1,  2,  6,  6,  1,  2,  4,  2,  2,  1,  2,  7,  7,  1,  2,  4,  2; ...
      0,  0,  0,  0,  4,  2,  3,  1,  2,  4,  1,  4,  2,  0,  2,  1,  2,  6,  6,  1,  2,  4,  2,  2,  1,  2,  7,  7,  1,  2,  4,  2; ...
      0,  0,  0,  2,  3,  1,  1,  2,  4,  1,  1,  4,  2,  0,  2,  1,  1,  1,  1,  1,  2,  4,  2,  2,  1,  1,  1,  1,  1,  2,  4,  2; ...
      0,  0,  2,  3,  3,  1,  2,  4,  1,  1,  4,  2,  2,  0,  0,  2,  2,  2,  2,  2,  4,  2,  2,  0,  4,  2,  2,  2,  2,  4,  2,  2; ...
      0,  2,  3,  1,  1,  1,  4,  2,  4,  4,  2,  2,  0,  0,  0,  0,  4,  4,  4,  4,  2,  2,  0,  0,  0,  4,  4,  4,  4,  2,  2,  0; ...
      2,  3,  1,  1,  1,  2,  4,  2,  2,  2,  2,  0,  0,  0,  0,  0,  0,  2,  2,  2,  2,  0,  0,  0,  0,  0,  2,  2,  2,  2,  0,  0; ...
      4,  3,  1,  1,  2,  4,  2,  0,  0,  0,  0,  0,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      4,  2,  2,  2,  4,  2,  0,  0,  0,  0,  0,  4,  3,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  4,  4,  4,  2,  0,  0,  0,  0,  2,  0,  4,  5,  4,  0,  2,  0,  0,  2,  0,  0,  2,  0,  0,  2,  0,  0,  2,  0,  0,  4,  0; ...
      0,  0,  2,  2,  0,  0,  0,  0,  0,  2,  0,  4,  5,  4,  0,  2,  0,  0,  2,  0,  0,  2,  0,  0,  2,  0,  0,  2,  0,  0,  4,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  4,  4,  4,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  0];
  map = [...
      0.900, 0.900, 0.900; ...
      0.800, 0.800, 0.800; ...
      0.600, 0.600, 0.600; ...
      1.000, 1.000, 1.000; ...
      0.000, 0.000, 0.000; ...
      0.000, 1.000, 1.000; ...
      1.000, 0.000, 0.000; ...
      0.000, 1.000, 0.000];
  case 3, % viola
    x = [...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  2,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  3,  3,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  1,  1,  1,  1,  4,  1,  2,  3,  3,  3,  3,  3,  3,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  1,  1,  5,  5,  5,  5,  6,  1,  1,  1,  3,  3,  3,  3,  3,  3,  3,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  1,  5,  5,  7,  7,  7,  7,  5,  2,  6,  8,  1,  1,  1,  1,  1,  1,  9,  9,  3,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  1,  5,  7,  7, 10, 10, 10,  7,  7,  5,  5,  6,  2,  2,  2,  7,  1,  4,  1,  1,  9,  3,  3,  1,  1,  0,  0,  0,  0,  0,  0; ...
      0,  1,  5,  7, 10, 11,  4,  4, 11,  4, 12,  7,  5, 13,  7,  7,  7,  1, 11,  4,  4,  1,  9,  3,  3,  3,  1,  1,  0,  0,  0,  0; ...
      1,  5,  7, 10, 11, 11, 14, 11, 14, 11,  4,  2,  7,  6,  7,  7,  4,  1,  4,  4, 11,  4,  1,  9,  3,  3,  3,  3,  1,  1,  0,  0; ...
      1,  5,  7, 10, 11, 11, 11,  1,  1,  1, 11, 11,  2,  7,  6,  4,  1, 11,  4,  4, 11,  4,  4,  1,  3,  3,  3,  3,  3,  1,  0,  0; ...
      1,  5,  7, 10, 11, 11,  1,  1,  1,  1,  1, 14,  2,  7,  6,  4,  1,  1, 10, 10, 10, 10, 10,  1,  9,  3,  3,  3, 15,  1,  0,  0; ...
      1,  5,  7, 10, 11, 11,  1,  1,  1,  1,  1, 11, 14,  2,  7,  1,  1,  1,  4, 11, 11, 14, 11,  1,  9,  3,  3, 15, 15,  1,  0,  0; ...
      1,  5,  7, 10, 11, 11,  1,  1,  1,  1,  1, 13, 14,  2,  7,  1,  1, 11,  4, 11, 14, 11, 14,  1,  9,  3, 15, 15, 15,  1,  0,  0; ...
      1,  5,  7,  7, 10,  4,  1,  1,  1,  1,  1, 11, 13,  2,  7,  1,  4, 11, 11, 11, 11, 11,  1,  9,  3, 15, 15, 15, 15,  1,  0,  0; ...
      0,  1,  5,  7, 10,  4, 13,  1,  1,  1, 14, 13, 11,  2,  7,  1,  4, 14, 11, 14,  4,  1,  9,  3, 15, 15, 15, 15, 15,  1,  1,  0; ...
      0,  1,  5, 12, 10,  4, 13, 11, 13, 13, 11, 14, 13,  2,  7,  1,  4, 11, 11,  1,  1,  9,  3, 15, 15, 15, 15, 15, 15,  1,  3,  1; ...
      0,  1,  1,  8,  2, 11,  4, 13, 11, 14, 13, 11,  2,  7,  1,  1,  1,  1,  1,  9,  9,  3, 15, 15, 15, 15, 15, 15,  1,  3,  9,  1; ...
      0,  1,  1, 12,  7,  2,  2,  4,  4, 11,  4,  2,  2,  7,  1,  9,  9,  9,  9,  3,  3, 15, 15, 15, 15, 15, 15,  1,  3,  9, 15,  1; ...
      0,  1,  9,  1,  1,  7,  7,  2,  2,  2,  2,  7,  7,  1,  3,  3,  3,  3,  3,  3, 15, 15, 15, 15, 15, 15,  6,  3,  9, 15,  1,  0; ...
      0,  1,  9,  9,  1,  1,  1,  7,  7,  7,  7,  1,  1, 15,  2,  2,  3,  3,  3, 15, 15, 15, 15, 15, 15,  1,  3,  9, 15,  1,  0,  0; ...
      0,  1,  1,  1,  9,  1,  1,  1,  1,  1,  1, 15, 15, 15,  9,  9,  2,  3, 15, 15, 15, 15, 15, 15,  1,  3,  9, 15,  1,  0,  0,  0; ...
      1,  9,  3,  3,  1,  1,  7,  1,  1,  1, 15, 15, 15,  9,  9,  9,  9, 15, 15, 15, 15, 15, 15,  1,  3,  9, 15,  1,  0,  0,  0,  0; ...
      1, 15,  9,  9,  3,  1,  1,  1, 15, 15, 15, 15,  9,  9,  9,  9,  9, 15, 15, 15, 15, 15,  1,  3,  9, 15,  1,  0,  0,  0,  0,  0; ...
      1,  1, 15, 15,  9,  9, 15, 15,  1,  1,  9,  9,  9,  9,  9,  9,  9, 15, 15, 15, 15,  1,  3,  9, 15,  1,  0,  0,  0,  0,  0,  0; ...
      0,  0,  1,  1, 15, 15,  9,  9,  3,  3,  1,  1,  9,  9,  9,  9,  9, 15, 15, 15,  1,  3,  9, 15,  1,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  1,  1, 15, 15,  9,  9,  3,  3,  1,  1, 10,  9,  9, 15, 15,  1,  3,  9, 15,  1,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  1,  1, 15, 15,  9,  9,  3,  3,  1,  1,  9, 15,  1,  3,  9, 15,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  1,  1, 15, 15,  9,  9,  3,  3,  1,  1,  3,  9, 15,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1, 15, 15,  9,  9,  3, 15,  9, 15,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1, 15,  9,  9, 15, 15,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; ...
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1, 15, 15,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0];
  map = [...
      0.900, 0.900, 0.900; ...
      0.000, 0.000, 0.000; ...
      1.000, 1.000, 1.000; ...
      1.000, 0.549, 0.388; ...
      0.322, 0.322, 0.322; ...
      0.922, 0.937, 0.922; ...
      0.063, 0.094, 0.063; ...
      0.741, 0.741, 0.741; ...
      0.808, 0.808, 0.808; ...
      0.580, 0.388, 0.000; ...
      0.498, 0.529, 0.498; ...
      0.259, 0.290, 0.259; ...
      0.647, 0.678, 0.647; ...
      0.129, 0.129, 0.129; ...
      0.224, 0.224, 0.224; ...
      0.290, 0.192, 0.000];
end

ind_=1:length(map);
for ind=ind_;
  [x_,y_]=find(x == ind-1);
  for ind_A = 1:length(x_),
    A(x_(ind_A),y_(ind_A),1:3)=map(ind,1:3);
  end
end

return 

function b=ZerPol_isFIR(nazwa)

function [h, a]=ZerPol_loadFIR(nazwa)

ver=version; ver=ver(1);

if (ver~='4')
  h=load('-ascii', nazwa);
else
  load('-ascii', nazwa);
  eval(['h=' nazwa(1:end-4) ';'],'h=1;');
  eval(['clear(' nazwa(1:end-4) ');'],'1;');
end
a=1;


function [z, dp, K] = roots_(b)
% dp - korekta o wykryt liczb biegunw w zerze

dp = [];
while abs(b(1)) <= 10.^-15,
  b = b(2:end);
  dp = [dp; 0]; % impulse response is delayed
end
while abs(b(end)) <= 10.^-15,
  b = b(1:end-1);
end
z = roots(b);

h = poly(z);
K = max(b)/max(h);

function ZerPolWybrane_out = CheckSelectionMode(ZerPolWybrane)
global ZerPol_select_mode;

mode = get(ZerPol_select_mode, 'Value');
switch mode,
case 1, % all
  ZerPolWybrane_out = ZerPolWybrane;
case 2, % |z| < 1
  ind = find(abs(ZerPolWybrane(:,2)) < 0.99999);
  ZerPolWybrane_out = ZerPolWybrane(ind,:);
  %ZerPolWybrane_out(ind,:) = []; 
case 3, % |z| > 1
  ind = find(abs(ZerPolWybrane(:,2)) > 1.00001);
  ZerPolWybrane_out = ZerPolWybrane(ind,:);
  %ZerPolWybrane_out(ind,:) = []; 
otherwise, % error
  warning('Unsupported slection mode');
end
